7.0
 * Add prepared statement cache stats to nodetool info (CASSANDRA-14366)
 * Don't increment client metrics on messaging service connection unpause (CASSANDRA-21491)
 * Add nodetool getreplicas (CASSANDRA-17665)
 * Implementation of CEP-49: Hardware-accelerated compression (CASSANDRA-20975)
 * Avoid using ObjectUtils.getFirstNonNull in Schema (CASSANDRA-21394)
 * Allow nodetool garbagecollect to take a user defined list of SSTables (CASSANDRA-16767)
 * Add a guardrail for misprepared statements (CASSANDRA-21139)
Merged from 6.0:
 * Make cqlsh prompt to reset to no keyspace set by USE after dropping that keyspace (CASSANDRA-21548)
 * Implement CMS rediscovery and recovery protocol (CASSANDRA-20476)
 * Apply performance optimizations for rows merging logic (CASSANDRA-21524)
 * Fix operationMode reporting DECOMMISSION_FAILED instead of LEAVING when resuming a failed decommission (CASSANDRA-21493)
 * Avoid megamorphic calls when serializing and deserializing fixed-length values (CASSANDRA-21536)
 * Avoid megamorphic calls for Cell.timestamp/ttl/path/localDeletionTimeAsUnsignedInt methods (CASSANDRA-21526)
 * Reduce allocations in DefaultQueryOptions (CASSANDRA-21467)
 * Allow unreserved keywords as user and identity names in USER and IDENTITY statements (CASSANDRA-21510)
 * Reduce allocations in DefaultQueryOptions (CASSANDRA-21467)
 * Reduce number of scheduledTasks on metric id release in ThreadLocalMetrics (CASSANDRA-21475)
 * Cache various Enum.values() used in deserialization to avoid per-read array allocation (CASSANDRA-21528)
 * Fix Accord transaction error message when altering a table (CASSANDRA-20580)
 * Depend only on platform-specific Zstd JNI native libraries (CASSANDRA-21483)
 * Expose immediately-executed tasks in the queries virtual table (CASSANDRA-21471)
 * Avoid potential deadlock between GlobalLogFollower and GossipStage (CASSANDRA-21384)
 * Add CMS membership as a field in ClusterMetadata (CASSANDRA-20736)
 * Fix maven remote publishing of Accord artifacts (CASSANDRA-21261)
 * Move long running TCM operations to a longer timout (CASSANDRA-21453)
 * Offline nodetool commands should not print network options in help (CASSANDRA-20876)
 * Defer creation of the system_cluster_metadata keyspace until CMS initialization (CASSANDRA-21477)
 * Support direct I/O for background SSTable writes (CASSANDRA-21134)
 * Relax assertion on partitioner instances in SinglePartitionReadCommand (CASSANDRA-21251)
 * Report cancelled read command execution to coordinator as a RequestFailure.TIMEOUT (CASSANDRA-21468)
 * Add policy for selecting CMS host when submitting commit request (CASSANDRA-21456)
 * Fix TCM log catchup from peer with snapshots and gaps in the log sequence (CASSANDRA-21455)
 * Speed up nodetool doc generation by producing all command help in a single jvm (CASSANDRA-21444)
 * Always send TCM commit failures as Messaging failures (CASSANDRA-21457)
 * Fix ReadCommand serializedSize() using incorrect epoch (CASSANDRA-21438)
 * Allocation improvements in ProtocolVersion, StorageProxy and MerkleTree (CASSANDRA-21199)
 * Don't leave autocompaction disabled during bootstrap and replace (CASSANDRA-21236)
 * Make nodetool abortbootstrap more robust (CASSANDRA-21235)
 * Don't clear prepared statement cache on nodetool cms initialize (CASSANDRA-21234)
 * Improve performance when deserializing cluster metadata  (CASSANDRA-21224)
 * Minor TokenMap performance improvement (CASSANDRA-21223)
 * Handle lost response when committing PrepareMove (CASSANDRA-21222)
 * SEPExecutor.maybeExecuteImmediately does not always execute tasks immediately despite available worker capacity (CASSANDRA-21429)
 * Safely regain ranges and delete retired command stores (CASSANDRA-21212)
 * Reduce memory allocations in miscellaneous places along read path (CASSANDRA-21360)
 * Avoid ByteBuffer wrapping in cql3.selection.Selector.InputRow to reduce memory allocation rate (CASSANDRA-21362)
 * Reduce cost to calculate BTreeRow.minDeletionTime (CASSANDRA-21414)
 * Implement custom CassandraThread to keep direct references to frequently used thread local objects (CASSANDRA-21020)
 * Avoid megamorphic call overhead at RandomAccessReader#current (CASSANDRA-21399)
 * Enable async GC logging for JDK versions which support it to avoid potential hiccups caused by GC log file I/O blocking (CASSANDRA-21372)
 * Add rowsMutatedPerWriteHistogram metric to track rows mutated per write request (CASSANDRA-21320)
 * Add TotalRowsRead and TotalRowsMutated counters to TableMetrics for accurate per-table row throughput tracking (CASSANDRA-21321)
 * Move exception handling of SPI startup checks when iterating over them (CASSANDRA-21409)
 * Avoid type lookup in SerializationHeader#getType if schema and SSTable are aligned (CASSANDRA-21402)
 * Replace LongAdder in metric-like logic with ThreadLocalCounter (CASSANDRA-21400)
 * BTreeRow#hasLiveData: Avoid Cell iteration if there are no tombstones in a row (CASSANDRA-21363)
 * Reduce memory allocations in row merge logic (CASSANDRA-21359)
 * Restore option to avoid hint transfer during decommission (CASSANDRA-21341)
 * Add an offline cluster metadata tool (CASSANDRA-19151)
 * Accord: Tail Latency Improvements (CASSANDRA-21361)
 * Artificial Latency Injection (CASSANDRA-17024)
 * Accord: Clean Shutdown/Restart, Rebootstrap, et al (CASSANDRA-21355)
 * Reduce memory allocations in SelectStatement.getQuery (CASSANDRA-21351)
 * Avoid allocation by getFunctions in SelectStatement.authorize (CASSANDRA-21347)
 * Avoid unit conversion in DatabaseDescriptor.getMaxValueSize() for every deserializing Cell (CASSANDRA-21295)
 * Fix single token batch atomicity with Accord/non-Accord batches by using the batch log (CASSANDRA-20588)
 * Avoid CompactionOptions parsing for every read by WithoutPurgeableTombstones (CASSANDRA-21294)
 * Ensure schema created before 2.1 without tableId in folder name can be loaded in SnapshotLoader (CASSANDRA-21246)
 * Differentiate between legitimate cases where the first entry is the same as the last entry and empty bounds in SSTableCursorWriter#addIndexBlock() (CASSANDRA-21255)
 * Introduce minimum_threshold for data resurrection startup check (CASSANDRA-21293)
 * Synchronously publish changes to local gossip state following metadata updates (CASSANDRA-21239)
Merged from 5.0:
 * Propagate trickle_fsync settings to compressed SSTable writers (CASSANDRA-21487)
 * Allow setCompressedReadAheadBufferSizeInKb(0) to disable read-ahead buffer (CASSANDRA-21522)
 * Fix ThreadLocalReadAheadBuffer#fill() to throw a CorruptBlockException if chunk metadata and file size are out of sync (CASSANDRA-21519)
 * Support Python 3.12 and 3.13 in cqlsh (CASSANDRA-20997)
 * Make synchronization on VectorMemoryIndex inserts more granular (CASSANDRA-21160)
 * Fix RequestFailureReason serializer and nits in a few others (CASSANDRA-21437)
 * Remove golang dependency in gen-doc and replace with python implementation (CASSANDRA-21432)
 * Use estimated compressed size for tables to check if there is enough free space for a compaction (CASSANDRA-21245)
 * Fix failing select on system_views.settings for non-string keys (CASSANDRA-21348)
Merged from 4.0:
 * Do not make DNS lookup when querying system_views.clients for hostname column by removing it (CASSANDRA-21539)
 * Fix memtable on-heap accounting drift in BTree.update and BTreeRow.merge (CASSANDRA-21472)
 * Bound declared value length against readable bytes in CBUtil (CASSANDRA-21521)
 * Verify extension type before initializing reflectively-loaded classes (CASSANDRA-21525)
 * Rename conflicting nodetool import --copy-data short option from -p to -cd (CASSANDRA-20214)
 * Fix PasswordObfuscator failing to obfuscate certain passwords (CASSANDRA-21113)
 * Fix negative memtable allocator ownership when an update is shadowed by an existing row deletion (CASSANDRA-21469)
 * Consider first token of SSTable when calculating SSTable intersection in LeveledScanner  (CASSANDRA-21369)
 * Remove inFlightEcho entry on ECHO_REQ failure (CASSANDRA-21428)
 * Validate snapshot names (CASSANDRA-21389)


6.0-alpha2
 * Change default for cassandra.set_sep_thread_name to false to reduce CPU usage (CASSANDRA-21089)
 * Avoid permission checks for masked columns when the table doesn't have any (CASSANDRA-21299)
 * Reduce allocations and array copies due to buffer resizing in LocalDataResponse during row serialization (CASSANDRA-21285)
 * Implement a guardrail for client driver versions (CASSANDRA-21146)
 * Enable IAuthenticator to declare supported and alterable role options (CASSANDRA-20834)
 * Avoid capturing lambda allocation in UnfilteredSerializer.deserializeRowBody (CASSANDRA-21289)
 * Avoid Cell iterator allocation for alive rows in MetricsRecording transformation of ReadCommand (CASSANDRA-21288)
 * Reuse a single TrackedDataInputPlus instance per UnfilteredSerializer (CASSANDRA-21296)
 * In-tree docs are included in binary artifacts (tarball, deb, rpm) as html and man pages (CASSANDRA-17260)
 * Add tooling to repair system peers and peers_v2 if inconsistent with cluster metadata (CASSANDRA-21187)
 * Fix a removed TTLed row re-appearance in a materialized view after a cursor compaction (CASSANDRA-21152)
 * Rework ZSTD dictionary compression logic to create a trainer per training (CASSANDRA-21209)
Merged from 5.0:
 * SAI Component Checksum Validation Should be Segment-Aware (CASSANDRA-21516)
 * Ensure SAI sends range tombstones to the coordinator for queries on static columns (CASSANDRA-21332)
Merged from 4.1:
 * Add Paxos v2 option and informatin in cassandra.yaml (CASSANDRA-21316)
 * Harden data resurrection startup check with atomic heartbeat file write with fallback (CASSANDRA-21290)
Merged from 4.0:
 * BTree.FastBuilder.reset() fails to clear savedBuffer and savedNextKey, causing ClassCastException and SSTable header corruption during schema disagreement (CASSANDRA-21216, CASSANDRA-21260)
 * Backport CASSANDRA-17810 fix and improve RTBoundValidator error messages (CASSANDRA-18282)
 * Rate limit password changes (CASSANDRA-21202)


6.0-alpha1
 * Improve performance when calculating settled placements during range movements (CASSANDRA-21144)
 * Make shadow gossip round parameters configurable for testing (CASSANDRA-21149)
 * Avoid potential gossip thread deadlock during decommission (CASSANDRA-21143)
 * Improve construction of consensus groups for range movements (CASSANDRA-21142)
 * Support compaction_read_disk_access_mode for cursor-based compaction (CASSANDRA-21147)
 * Allow value/element indexing on frozen collections in SAI (CASSANDRA-18492)
 * Add tool to offline dump cluster metadata and the log (CASSANDRA-21129)
 * Send client warnings when writing to a large partition (CASSANDRA-17258)
 * Harden the possible range of values for max dictionary size and max total sample size for dictionary training (CASSANDRA-21194)
 * Implement a guardrail ensuring that minimum training frequency parameter is provided in ZstdDictionaryCompressor (CASSANDRA-21192)
 * Replace manual referencing with ColumnFamilyStore.selectAndReference when training a dictionary (CASSANDRA-21188)
 * Forbid nodes upgrading to a version which cannot read existing log entries (CASSANDRA-21174)
 * Introduce a check for minimum time to pass to train or import a compression dictionary from the last one (CASSANDRA-21179)
 * Allow overriding compaction strategy parameters during startup (CASSANDRA-21169)
 * Introduce created_at column to system_distributed.compression_dictionaries (CASSANDRA-21178)
 * Be able to detect and remove orphaned compression dictionaries (CASSANDRA-21157)
 * Fix BigTableVerifier to only read a data file during extended verification (CASSANDRA-21150) 
 * Reduce memory allocation during transformation of BatchStatement to Mutation (CASSANDRA-21141)
 * Direct I/O support for compaction reads (CASSANDRA-19987)
 * Support custom StartupCheck implementations via SPI (CASSANDRA-21093)
 * Make sstableexpiredblockers support human-readable output with SSTable sizes (CASSANDRA-20448)
 * Enhance nodetool compactionhistory to report more compaction properities (CASSANDRA-20081)
 * Fix initial auto-repairs skipped by too soon check (CASSANDRA-21115)
 * Add configuration to disk usage guardrails to stop writes across all replicas of a keyspace when any node replicating that keyspace exceeds the disk usage failure threshold. (CASSANDRA-21024)
 * BETWEEN where token(Y) > token(Z) returns wrong answer (CASSANDRA-20154)
 * Optimize memtable flush logic (CASSANDRA-21083)
 * No need to evict already prepared statements, as it creates a race condition between multiple threads (CASSANDRA-17401)
 * Include Level information for UnifiedCompactionStrategy in nodetool tablestats output (CASSANDRA-20820)
 * Support low-overhead async profiling (CASSANDRA-20854)
 * Minor perf optimizations around memtable put logic (CASSANDRA-21088)
 * When level compaction validates its table properties, it used the wrong default value for sstable_size_in_mb which allowed properties that would later be rejected at runtime (CASSANDRA-20570)
 * Fix off-by-one bug in exponential backoff for repair retry config (CASSANDRA-21102)
 * Move training parameters for Zstd dictionary compression to CQL (CASSANDRA-21078)
 * Add configuration for sorted imports in source files (CASSANDRA-17925)
 * Change the eager reference counting of compression dictionaries to lazy (CASSANDRA-21074)
 * Add cursor based optimized compaction path (CASSANDRA-20918)
 * Ensure peers with LEFT status are expired from gossip state (CASSANDRA-21035)
 * Optimize UTF8Validator.validate for ASCII prefixed Strings (CASSANDRA-21075)
 * Switch LatencyMetrics to use ThreadLocalTimer/ThreadLocalCounter (CASSANDRA-21080)
 * Accord: write rejections would be returned to users as server errors rather than INVALID and TxnReferenceOperation didn't handle all collections prperly (CASSANDRA-21061)
 * Use byte[] directly in QueryOptions instead of ByteBuffer and convert them to ArrayCell instead of BufferCell to reduce allocations (CASSANDRA-20166)
 * Log queries scanning too many SSTables per read (CASSANDRA-21048)
 * Extend nodetool verify to (optionally) validate SAI files (CASSANDRA-20949)
 * Fix CompressionDictionary being closed while still in use (CASSANDRA-21047)
 * When updating a multi cell collection element, if the update is rejected then the shared Row.Builder is not freed causing all future mutations to be rejected (CASSANDRA-21055)
 * Schema annotations escape validation on CREATE and ALTER DDL statements (CASSANDRA-21046)
 * Calculate once and cache the result of ModificationStatement#requiresRead as a perf optimization (CASSANDRA-21040)
 * Update system schema tables with new distributed keyspace on upgrade (CASSANDRA-20872)
 * Fix issue when running cms reconfiguration with paxos repair disabled (CASSANDRA-20869)
 * Added additional parameter to JVM shutdown to allow for logs to be properly shutdown (CASSANDRA-20978)
 * Improve isGossipOnlyMember and location lookup performance (CASSANDRA-21039)
 * Refactor the way we check if a transformation is allowed to be committed during upgrades (CASSANDRA-21043)
 * Improve debug around paused and disabled compaction (CASSANDRA-20131,CASSANDRA-19728)
 * DiskUsageBroadcaster does not update usageInfo on node replacement (CASSANDRA-21033)
 * Reject PrepareJoin if tokens are already assigned (CASSANDRA-21006)
 * Don't update registration status if node state for decommissioned peer is found with the same address (CASSANDRA-21005)
 * Avoid NPE when meta keyspace placements are empty before CMS is initialized (CASSANDRA-21004)
 * Gossip entries for hibernating non-members don't block truncate (CASSANDRA-21003)
 * Retry without time limit calculates wait time incorrectly (CASSANDRA-21002)
 * Don't submit AlterSchemaStatements which produce no effect locally to the CMS (CASSANDRA-21001)
 * Avoid iterating all prepared statements when getting PreparedStatementsCacheSize metric (CASSANDRA-21038)
 * Reduce performance impact of TableMetadataRef.get and KeyspaceMetadataRef.get (CASSANDRA-20465)
 * Improve CMS initialization (CASSANDRA-21036)
 * Introducing comments and security labels for schema elements (CASSANDRA-20943)
 * Extend nodetool tablestats for dictionary memory usage (CASSANDRA-20940)
 * Introduce separate GCInspector thresholds for concurrent GC events (CASSANDRA-20980)
 * Reduce contention in MemtableAllocator.allocate (CASSANDRA-20226)
 * Add export, list, import sub-commands for nodetool compressiondictionary (CASSANDRA-20941)
 * Add support in the binary protocol to allow transactions to have multiple conditions (CASSANDRA-20883)
 * Enable CQLSSTableWriter to create SSTables compressed with a dictionary (CASSANDRA-20938)
 * Support ZSTD dictionary compression (CASSANDRA-17021)
 * Fix ExceptionsTable when stacktrace has zero elements (CASSANDRA-20992)
 * Replace blocking wait with non-blocking delay in paxos repair (CASSANDRA-20983)
 * Implementation of CEP-55 - Generation of role names (CASSANDRA-20897)
 * Add cqlsh autocompletion for the identity mapping feature (CASSANDRA-20021)
 * Add DDL Guardrail enabling administrators to disallow creation/modification of keyspaces with durable_writes = false (CASSANDRA-20913)
 * Optimize Counter, Meter and Histogram metrics using thread local counters (CASSANDRA-20250)
 * Update snakeyaml to 2.4 (CASSANDRA-20928)
 * Update Netty to 4.1.125.Final (CASSANDRA-20925)
 * Expose uncaught exceptions in system_views.uncaught_exceptions table (CASSANDRA-20858)
 * Improved observability in AutoRepair to report both expected vs. actual repair bytes and expected vs. actual keyspaces (CASSANDRA-20581)
 * Execution of CreateTriggerStatement should not rely on external state (CASSANDRA-20287)
 * Support LIKE expressions in filtering queries (CASSANDRA-17198)
 * Make legacy index rebuilds safe on Gossip -> TCM upgrades (CASSANDRA-20887)
 * Minor improvements and hardening for IndexHints (CASSANDRA-20888)
 * Stop repair scheduler if two major versions are detected (CASSANDRA-20048)
 * Optimize audit logic for batch operations especially when audit is not enabled for DML (CASSANDRA-20885)
 * Implement nodetool history (CASSANDRA-20851)
 * Expose StorageService.dropPreparedStatements via JMX (CASSANDRA-20870)
 * Expose Metric for Prepared Statement Cache Size (in bytes) (CASSANDRA-20864)
 * Add support for BEGIN TRANSACTION to allow mutations that touch multiple partitions (CASSANDRA-20857)
 * AutoRepair: Safeguard Full repair against disk protection(CASSANDRA-20045)
 * BEGIN TRANSACTION crashes if a mutation touches multiple rows (CASSANDRA-20844)
 * Fix version range check in MessagingService.getVersionOrdinal (CASSANDRA-20842)
 * Allow custom constraints to be loaded via SPI (CASSANDRA-20824)
 * Optimize DataPlacement lookup by ReplicationParams (CASSANDRA-20804)
 * Fix ShortPaxosSimulationTest and AccordSimulationRunner do not execute from the cli (CASSANDRA-20805)
 * Allow overriding arbitrary settings via environment variables (CASSANDRA-20749)
 * Optimize MessagingService.getVersionOrdinal (CASSANDRA-20816)
 * Optimize TrieMemtable#getFlushSet (CASSANDRA-20760)
 * Support manual secondary index selection at the CQL level (CASSANDRA-18112)
 * When regulars CQL mutations run on Accord use the txn timestamp rather than server timestamp (CASSANDRA-20744)
 * When using BEGIN TRANSACTION if a complex mutation exists in the same statement as one that uses a reference, then the complex delete is dropped (CASSANDRA-20788)
 * Migrate all nodetool commands from airline to picocli (CASSANDRA-17445)
 * Journal.TopologyUpdate should not store the local topology as it can be inferred from the global on (CASSANDRA-20785)
 * Accord: Topology serializer has a lot of repeated data, can dedup to shrink the cost (CASSANDRA-20715)
 * Stream individual files in their own transactions and hand over ownership to a parent transaction on completion (CASSANDRA-20728)
 * Limit the number of held heap dumps to not consume disk space excessively (CASSANDRA-20457)
 * Accord: BEGIN TRANSACTIONs IF condition logic does not properly support meaningless emptiness and null values (CASSANDRA-20667)
 * Accord: startup race condition where accord journal tries to access the 2i index before its ready (CASSANDRA-20686)
 * Adopt Unsafe::invokeCleaner for Direct ByteBuffer cleaning (CASSANDRA-20677)
 * Add additional metrics around hints (CASSANDRA-20499)
 * Support for add and replace in IntervalTree (CASSANDRA-20513)
 * Enable single_sstable_uplevel by default for LCS (CASSANDRA-18509)
 * Introduce NativeAccessor to avoid new ByteBuffer allocation on flush for each NativeCell (CASSANDRA-20173)
 * Migrate sstableloader code to its own tools directory and artifact (CASSANDRA-20328)
 * Stop AutoRepair monitoring thread upon Cassandra shutdown (CASSANDRA-20623)
 * Avoid duplicate hardlink error upon forceful taking of ephemeral snapshots during repair (CASSANDRA-20490)
 * When a custom disk error handler fails to initiate, fail the startup of a node instead of using the no-op handler (CASSANDRA-20614)
 * Rewrite constraint framework to remove column specification from constraint definition, introduce SQL-like NOT NULL (CASSANDRA-20563)
 * Fix a bug in AutoRepair duration metric calculation if schedule finishes quickly (CASSANDRA-20622)
 * Fix AutoRepair flaky InJvm dtest (CASSANDRA-20620)
 * Increasing default for auto_repair.sstable_upper_threshold considering large Cassandra tables & revert three lines removed from CHANGES.txt due to a merge mistake (CASSANDRA-20586)
 * Fix token restrictions with MIN_TOKEN (CASSANDRO-20557)
 * Upgrade logback version to 1.5.18 and slf4j dependencies to 2.0.17 (CASSANDRA-20429)
 * Switch memtable-related off-heap objects to Native Endian and Memory to Little Endian (CASSANDRA-20190)
 * Change SSTableSimpleScanner to use SSTableReader#openDataReaderForScan (CASSANDRA-20538)
 * Automated Repair Inside Cassandra [CEP-37] (CASSANDRA-19918)
 * Implement appender of slow queries to system_views.slow_queries table (CASSANDRA-13001)
 * Add autocompletion in CQLSH for built-in functions (CASSANDRA-19631)
 * Grant permission on keyspaces system_views and system_virtual_schema not possible (CASSANDRA-20171)
 * General Purpose Transactions (Accord) [CEP-15] (CASSANDRA-17092)
 * Improve performance when getting writePlacementsAllSettled from ClusterMetadata (CASSANDRA-20526)
 * Add nodetool command to dump the contents of the system_views.{cluster_metadata_log, cluster_metadata_directory} tables (CASSANDRA-20525)
 * Fix TreeMap race in CollectionVirtualTableAdapter causing us to lose rows in the virtual table (CASSANDRA-20524)
 * Improve metadata log catch up with inter-DC mutation forwarding (CASSANDRA-20523)
 * Support topology-safe changes to Datacenter & Rack for live nodes (CASSANDRA-20528)
 * Add SSTableIntervalTree latency metric (CASSANDRA-20502)
 * Ignore repetitions of semicolon in CQLSH (CASSANDRA-19956)
 * Avoid NPE during cms initialization abort (CASSANDRA-20527)
 * Avoid failing queries when epoch changes and replica goes up/down (CASSANDRA-20489)
 * Split out truncation record lock (CASSANDRA-20480)
 * Throw new IndexBuildInProgressException when queries fail during index build, instead of IndexNotAvailableException (CASSANDRA-20402)
 * Fix Paxos repair interrupts running transactions (CASSANDRA-20469)
 * Various fixes in constraint framework (CASSANDRA-20481)
 * Add support in CAS for -= on numeric types, and fixed improper handling of empty bytes which lead to NPE (CASSANDRA-20477)
 * Do not fail to start a node with materialized views after they are turned off in config (CASSANDRA-20452)
 * Fix nodetool gcstats output, support human-readable units and more output formats (CASSANDRA-19022)
 * Various gossip to TCM upgrade fixes (CASSANDRA-20483)
 * Add nodetool command to abort failed nodetool cms initialize (CASSANDRA-20482)
 * Repair Paxos for the distributed metadata log when CMS membership changes (CASSANDRA-20467)
 * Reintroduce CASSANDRA-17411 in trunk (CASSANDRA-19346)
 * Add min/max/mean/percentiles to timer metrics vtable (CASSANDRA-20466)
 * Add support for time, date, timestamp types in scalar constraint (CASSANDRA-20274)
 * Add regular expression constraint (CASSANDRA-20275)
 * Improve constraints autocompletion (CASSANDRA-20341)
 * Add JVM version and Cassandra build date to nodetool version -v (CASSANDRA-19721)
 * Move all disk error logic to DiskErrorsHandler to enable pluggability (CASSANDRA-20363)
 * Fix marking an SSTable as suspected and BufferPool leakage in case of a corrupted SSTable read during a compaction (CASSANDRA-20396)
 * Add missed documentation for CREATE TABLE LIKE (CASSANDRA-20401)
 * Add OCTET_LENGTH constraint (CASSANDRA-20340)
 * Reduce memory allocations in miscellaneous places along the hot write path (CASSANDRA-20167)
 * Provide keystore_password_file and truststore_password_file options to read credentials from a file (CASSANDRA-13428)
 * Unregistering a node should also remove it from tokenMap if it is there and recalculate the placements (CASSANDRA-20346)
 * Fix PartitionUpdate.isEmpty deserialization issue to avoid potential EOFException (CASSANDRA-20345)
 * Avoid adding LEFT nodes to tokenMap on upgrade from gossip (CASSANDRA-20344)
 * Allow empty placements when deserializing cluster metadata (CASSANDRA-20343)
 * Reduce heap pressure when initializing CMS (CASSANDRA-20267)
 * Paxos Repair: NoSuchElementException on DistributedSchema.getKeyspaceMetadata (CASSANDRA-20320)
 * Improve performance of DistributedSchema.validate for large schemas (CASSANDRA-20360)
 * Add JSON constraint (CASSANDRA-20273)
 * Prevent invalid constraint combinations (CASSANDRA-20330)
 * Support CREATE TABLE LIKE WITH INDEXES (CASSANDRA-19965)
 * Invalidate relevant prepared statements on every change to TableMetadata (CASSANDRA-20318)
 * Add per type max size guardrails (CASSANDRA-19677)
 * Make it possible to abort all kinds of multi step operations (CASSANDRA-20217)
 * Do not leak non-Java exceptions when calling snapshot operations via JMX (CASSANDRA-20335)
 * Implement NOT_NULL constraint (CASSANDRA-20276)
 * Improve error messages for constraints (CASSANDRA-20266)
 * Add system_views.partition_key_statistics for querying SSTable metadata (CASSANDRA-20161)
 * CEP-42 - Add Constraints Framework (CASSANDRA-19947)
 * Add table metric PurgeableTombstoneScannedHistogram and a tracing event for scanned purgeable tombstones (CASSANDRA-20132)
 * Make sure we can parse the expanded CQL before writing it to the log or sending it to replicas (CASSANDRA-20218)
 * Add format_bytes and format_time functions (CASSANDRA-19546)
 * Fix error when trying to assign a tuple to target type not being a tuple (CASSANDRA-20237)
 * Fail CREATE TABLE LIKE statement if UDTs in target keyspace do not exist or they have different structure from ones in source keyspace (CASSANDRA-19966)
 * Support octet_length and length functions (CASSANDRA-20102)
 * Make JsonUtils serialize Instant always with the same format (CASSANDRA-20209)
 * Port Harry v2 to trunk (CASSANDRA-20200)
 * Enable filtering of snapshots on keyspace, table and snapshot name in nodetool listsnapshots (CASSANDRA-20151)
 * Create manifest upon loading where it does not exist or enrich it (CASSANDRA-20150)
 * Propagate true size of snapshot in SnapshotDetailsTabularData to not call JMX twice in nodetool listsnapshots (CASSANDRA-20149)
 * Implementation of CEP-43 - copying a table via CQL by CREATE TABLE LIKE (CASSANDRA-19964)
 * Periodically disconnect roles that are revoked or have LOGIN=FALSE set (CASSANDRA-19385)
 * AST library for CQL-based fuzz tests (CASSANDRA-20198)
 * Support audit logging for JMX operations (CASSANDRA-20128)
 * Enable sorting of nodetool status output (CASSANDRA-20104)
 * Support downgrading after CMS is initialized (CASSANDRA-20145)
 * Deprecate IEndpointSnitch (CASSANDRA-19488)
 * Check presence of a snapshot in a case-insensitive manner on macOS platform to prevent hardlinking failures (CASSANDRA-20146)
 * Enable JMX server configuration to be in cassandra.yaml (CASSANDRA-11695)
 * Parallelized UCS compactions (CASSANDRA-18802)
 * Avoid prepared statement invalidation race when committing schema changes (CASSANDRA-20116)
 * Restore optimization in MultiCBuilder around building one clustering (CASSANDRA-20129)
 * Consolidate all snapshot management to SnapshotManager and introduce SnapshotManagerMBean (CASSANDRA-18111)
 * Fix RequestFailureReason constants codes (CASSANDRA-20126)
 * Introduce SSTableSimpleScanner for compaction (CASSANDRA-20092)
 * Include column drop timestamp in alter table transformation (CASSANDRA-18961)
 * Make JMX SSL configurable in cassandra.yaml (CASSANDRA-18508)
 * Fix cqlsh CAPTURE command to save query results without trace details when TRACING is ON (CASSANDRA-19105)
 * Optionally prevent tombstone purging during repair (CASSANDRA-20071)
 * Add post-filtering support for the IN operator in SAI queries (CASSANDRA-20025)
 * Don’t finish ongoing decommission and move operations during startup (CASSANDRA-20040)
 * Nodetool reconfigure cms has correct return code when streaming fails (CASSANDRA-19972)
 * Reintroduce RestrictionSet#iterator() optimization around multi-column restrictions (CASSANDRA-20034)
 * Explicitly localize strings to Locale.US for internal implementation (CASSANDRA-19953)
 * Add -H option for human-friendly output in nodetool compactionhistory (CASSANDRA-20015)
 * Fix type check for referenced duration type for nested types (CASSANDRA-19890)
 * In simulation tests, correctly set the tokens of replacement nodes (CASSANDRA-19997)
 * During TCM upgrade, retain all properties of existing system tables (CASSANDRA-19992)
 * Properly cancel in-flight futures and reject requests in EpochAwareDebounce during shutdown (CASSANDRA-19848)
 * Provide clearer exception message on failing commitlog_disk_access_mode combinations (CASSANDRA-19812)
 * Add total space used for a keyspace to nodetool tablestats (CASSANDRA-19671)
 * Ensure Relation#toRestriction() handles ReversedType properly (CASSANDRA-19950)
 * Add JSON and YAML output option to nodetool gcstats (CASSANDRA-19771)
 * Introduce metadata serialization version V4 (CASSANDRA-19970)
 * Allow CMS reconfiguration to work around DOWN nodes (CASSANDRA-19943)
 * Make TableParams.Serializer set allowAutoSnapshots and incrementalBackups (CASSANDRA-19954)
 * Make sstabledump possible to show tombstones only (CASSANDRA-19939)
 * Ensure that RFP queries potentially stale replicas even with only key columns in the row filter (CASSANDRA-19938)
 * Allow nodes to change IP address while upgrading to TCM (CASSANDRA-19921)
 * Retain existing keyspace params on system tables after upgrade (CASSANDRA-19916)
 * Deprecate use of gossip state for paxos electorate verification (CASSANDRA-19904)
 * Update dtest-api to 0.0.17 to fix jvm17 crash in jvm-dtests (CASSANDRA-19239)
 * Add resource leak test and Update Netty to 4.1.113.Final to fix leak (CASSANDRA-19783)
 * Fix incorrect nodetool suggestion when gossip mode is running (CASSANDRA-19905)
 * SAI support for BETWEEN operator (CASSANDRA-19688)
 * Fix BETWEEN filtering for reversed clustering columns (CASSANDRA-19878)
 * Retry if node leaves CMS while committing a transformation (CASSANDRA-19872)
 * Add support for NOT operators in WHERE clauses. Fixed Three Valued Logic (CASSANDRA-18584)
 * Allow getendpoints for system tables and make sure getNaturalReplicas work for MetaStrategy (CASSANDRA-19846)
 * On upgrade, handle pre-existing tables with unexpected table ids (CASSANDRA-19845)
 * Reconfigure CMS before assassinate (CASSANDRA-19768)
 * Warn about unqualified prepared statement only if it is select or modification statement (CASSANDRA-18322)
 * Update legacy peers tables during node replacement (CASSANDRA-19782)
 * Refactor ColumnCondition (CASSANDRA-19620)
 * Allow configuring log format for Audit Logs (CASSANDRA-19792)
 * Support for noboolean rpm (centos7 compatible) packages removed (CASSANDRA-19787)
 * Allow threads waiting for the metadata log follower to be interrupted (CASSANDRA-19761)
 * Support dictionary lookup for CassandraPasswordValidator (CASSANDRA-19762)
 * Disallow denylisting keys in system_cluster_metadata (CASSANDRA-19713)
 * Fix gossip status after replacement (CASSANDRA-19712)
 * Ignore repair requests for system_cluster_metadata (CASSANDRA-19711)
 * Avoid ClassCastException when verifying tables with reversed partitioner (CASSANDRA-19710)
 * Always repair the full range when repairing system_cluster_metadata (CASSANDRA-19709)
 * Use table-specific partitioners during Paxos repair (CASSANDRA-19714)
 * Expose current compaction throughput in nodetool (CASSANDRA-13890)
 * CEP-24 Password validation / generation (CASSANDRA-17457)
 * Reconfigure CMS after replacement, bootstrap and move operations (CASSANDRA-19705)
 * Support querying LocalStrategy tables with any partitioner (CASSANDRA-19692)
 * Relax slow_query_log_timeout for MultiNodeSAITest (CASSANDRA-19693)
 * Audit Log entries are missing identity for mTLS connections (CASSANDRA-19669)
 * Add support for the BETWEEN operator in WHERE clauses (CASSANDRA-19604)
 * Replace Stream iteration with for-loop for SimpleRestriction::bindAndGetClusteringElements (CASSANDRA-19679)
 * Consolidate logging on trace level (CASSANDRA-19632)
 * Expand DDL statements on coordinator before submission to the CMS (CASSANDRA-19592)
 * Fix number of arguments of String.format() in various classes (CASSANDRA-19645)
 * Remove unused fields from config (CASSANDRA-19599)
 * Refactor Relation and Restriction hierarchies (CASSANDRA-19341)
 * Raise priority of TCM internode messages during critical operations (CASSANDRA-19517)
 * Add nodetool command to unregister LEFT nodes (CASSANDRA-19581)
 * Add cluster metadata id to gossip syn messages (CASSANDRA-19613)
 * Reduce heap usage occupied by the metrics (CASSANDRA-19567)
 * Improve handling of transient replicas during range movements (CASSANDRA-19344)
 * Enable debounced internode log requests to be cancelled at shutdown (CASSANDRA-19514)
 * Correctly set last modified epoch when combining multistep operations into a single step (CASSANDRA-19538)
 * Add new TriggersPolicy configuration to allow operators to disable triggers (CASSANDRA-19532)
 * Use Transformation.Kind.id in local and distributed log tables (CASSANDRA-19516)
 * Remove period field from ClusterMetadata and metadata log tables (CASSANDRA-19482)
 * Enrich system_views.pending_hints vtable with hints sizes (CASSANDRA-19486)
 * Expose all dropwizard metrics in virtual tables (CASSANDRA-14572)
 * Ensured that PropertyFileSnitchTest do not overwrite cassandra-toploogy.properties (CASSANDRA-19502)
 * Add option for MutualTlsAuthenticator to restrict the certificate validity period (CASSANDRA-18951)
 * Fix StorageService::constructRangeToEndpointMap for non-distributed keyspaces (CASSANDRA-19255)
 * Group nodetool cms commands into single command group (CASSANDRA-19393)
 * Register the measurements of the bootstrap process as Dropwizard metrics (CASSANDRA-19447)
 * Add LIST SUPERUSERS CQL statement (CASSANDRA-19417)
 * Modernize CQLSH datetime conversions (CASSANDRA-18879)
 * Harry model and in-JVM tests for partition-restricted 2i queries (CASSANDRA-18275)
 * Refactor cqlshmain global constants (CASSANDRA-19201)
 * Remove native_transport_port_ssl (CASSANDRA-19397)
 * Make nodetool reconfigurecms sync by default and add --cancel to be able to cancel ongoing reconfigurations (CASSANDRA-19216)
 * Expose auth mode in system_views.clients, nodetool clientstats, metrics (CASSANDRA-19366)
 * Remove sealed_periods and last_sealed_period tables (CASSANDRA-19189)
 * Improve setup and initialisation of LocalLog/LogSpec (CASSANDRA-19271)
 * Refactor structure of caching metrics and expose auth cache metrics via JMX (CASSANDRA-17062)
 * Allow CQL client certificate authentication to work without sending an AUTHENTICATE request (CASSANDRA-18857)
 * Extend nodetool tpstats and system_views.thread_pools with detailed pool parameters (CASSANDRA-19289)
 * Remove dependency on Sigar in favor of OSHI (CASSANDRA-16565)
 * Simplify the bind marker and Term logic (CASSANDRA-18813)
 * Limit cassandra startup to supported JDKs, allow higher JDKs by setting CASSANDRA_JDK_UNSUPPORTED (CASSANDRA-18688)
 * Standardize nodetool tablestats formatting of data units (CASSANDRA-19104)
 * Make nodetool tablestats use number of significant digits for time and average values consistently (CASSANDRA-19015)
 * Upgrade jackson to 2.15.3 and snakeyaml to 2.1 (CASSANDRA-18875)
 * Transactional Cluster Metadata [CEP-21] (CASSANDRA-18330)
 * Add ELAPSED command to cqlsh (CASSANDRA-18861)
 * Add the ability to disable bulk loading of SSTables (CASSANDRA-18781)
 * Clean up obsolete functions and simplify cql_version handling in cqlsh (CASSANDRA-18787)
Merged from 5.0:
 * Update cassandra-stress to support TLS 1.3 by default by auto-negotiation (CASSANDRA-21007)
 * Refactor SAI ANN query execution to use score ordered iterators for correctness and speed (CASSANDRA-20086)
 * Fix ConcurrentModificationException in compaction garbagecollect (CASSANDRA-21065)
 * Dynamically skip sharding L0 when SAI Vector index present (CASSANDRA-19661)
 * Optionally force IndexStatusManager to use the optimized index status format (CASSANDRA-21132)
 * Automatically disable zero-copy streaming for legacy sstables with old bloom filter format (CASSANDRA-21092)
 * Fix CQLSSTableWriter serialization of vector of date and time (CASSANDRA-20979)
 * Correctly calculate default for FailureDetector max interval (CASSANDRA-21025)
 * Adding missing configs in system_views.settings to be backward compatible (CASSANDRA-20863)
 * Heap dump should not be generated on handled exceptions (CASSANDRA-20974)
Merged from 4.1:
 * Fix ant generate-eclipse-files (CASSANDRA-21215)
 * Disk usage guardrail cannot be disabled when failure threshold is reached (CASSANDRA-21057)
 * ReadCommandController should close fast to avoid deadlock when building secondary index (CASSANDRA-19564)
 * Disk usage guardrail cannot be disabled when failure threshold is reached (CASSANDRA-21057)
 * ReadCommandController should close fast to avoid deadlock when building secondary index (CASSANDRA-19564)
 * Redact security-sensitive information in system_views.settings (CASSANDRA-20856)
 * Improve CommitLogSegmentReader to skip SyncBlocks correctly in case of CRC errors (CASSANDRA-20664)
 * Do not crash on first boot with data_disk_usage_max_disk_size set when data directory is not created yet (CASSANDRA-20787)
 * Rework / simplification of nodetool get/setguardrailsconfig commands (CASSANDRA-20778)
 * IntrusiveStack.accumulate is not accumulating correctly (CASSANDRA-20670)
 * Add nodetool get/setguardrailsconfig commands (CASSANDRA-19552)
 * Fix mixed mode paxos ttl commit hang (CASSANDRA-20514)
 * Fix paxos mixed mode infinite loop (CASSANDRA-20493)
 * Optionally skip exception logging on invalid legacy protocol magic exception (CASSANDRA-19483)
 * Fix SimpleClient ability to release acquired capacity (CASSANDRA-20202)
 * Fix WaitQueue.Signal.awaitUninterruptibly may block forever if invoking thread is interrupted (CASSANDRA-20084)
 * Run audit_logging_options through santiation and validation on startup (CASSANDRA-20208)
 * Enforce CQL message size limit on multiframe messages (CASSANDRA-20052)
 * Fix race condition in DecayingEstimatedHistogramReservoir during rescale (CASSANDRA-19365)
Merged from 4.0:
 * Add option to disable cqlsh history (CASSANDRA-21180)
 * Node does not send multiple inflight echos (CASSANDRA-18866)
 * Obsolete expired SSTables before compaction starts (CASSANDRA-19776)
 * Switch lz4-java to at.yawk.lz4 version due to CVE (CASSANDRA-21052)
 * Restrict BytesType compatibility to scalar types only (CASSANDRA-20982)
 * Backport fix to nodetool gcstats output for direct memory (CASSANDRA-21037)
 * ArrayIndexOutOfBoundsException with repaired data tracking and counters (CASSANDRA-20871)
 * Fix cleanup of old incremental repair sessions in case of owned token range changes or a table deleting (CASSANDRA-20877)
 * Fix memory leak in BufferPoolAllocator when a capacity needs to be extended (CASSANDRA-20753)
 * Updated dtest-api to 0.0.18 and removed JMX-related classes that now live in the dtest-api (CASSANDRA-20884)
 * Fix range queries on early-open BTI files (CASSANDRA-20976)
 * Avoid re-initializing underlying iterator in LazilyInitializedUnfilteredRowIterator after closing (CASSANDRA-20972)
 * Flush SAI segment builder when current SSTable writer is switched (CASSANDRA-20752)
 * Throw RTE instead of FSError when RTE is thrown from FileUtis.write in TOCComponent (CASSANDRA-20917)
 * Represent complex settings as JSON on system_views.settings table (CASSANDRA-20827)
 * Sort SSTable TOC entries for determinism (CASSANDRA-20494)
 * Do not source cassandra-env.sh unnecessarily in nodetool and other tooling (CASSANDRA-20745)
 * Make source distribution buildable by ant artifacts as doc/scripts/process-native-protocol-specs-in-docker.sh was not executable (CASSANDRA-20802)
 * SSTableIndexWriter#abort() should log more quietly in cases where an exception is not provided (CASSANDRA-20695)
 * Avoid availability gap between UP and queryability marking for already built SAI indexes on bounce (CASSANDRA-20732)
 * Make Commitlog flush data safely in Direct IO mode (CASSANDRA-20692)
 * Get SAI MemtableIndex refs before SSTableIndex refs at query time (CASSANDRA-20709)
 * Fix MAX_SEGMENT_SIZE < chunkSize in MmappedRegions::updateState (CASSANDRA-20636)
 * Full Java 17 support (CASSANDRA-20681)
 * Ensure replica filtering protection does not trigger unnecessary short read protection reads (CASSANDRA-20639)
 * Unified Compaction does not properly validate min and target sizes (CASSANDRA-20398)
 * Avoid lambda usage in TrieMemoryIndex range queries and ensure queue size tracking is per column (CASSANDRA-20668)
 * Avoid CQLSH throwing an exception loading .cqlshrc on non-supported platforms (CASSANDRA-20478)
 * Relax validation of snapshot name as a part of SSTable files path validation (CASSANDRA-20649)
 * Optimize initial skipping logic for SAI queries on large partitions (CASSANDRA-20191)
 * zero copy streaming allocates direct memory that isn't used, but does help to fragment the memory space (CASSANDRA-20577)
 * CQLSSTableWriter supports setting the format (BTI or Big) (CASSANDRA-20609)
 * Don't allocate in ThreadLocalReadAheadBuffer#close() (CASSANDRA-20551)
 * Ensure RowFilter#isMutableIntersection() properly evaluates numeric ranges on a single column (CASSANDRA-20566)
 * SAI marks an index as non-empty when a partial partition/row modifications is flushed due to repair (CASSANDRA-20567)
 * SAI fails queries when multiple columns exist and a non-indexed column is a composite with a map (CASSANDRA-19891)
 * Avoid purging deletions in RowFilter when reconciliation is required (CASSANDRA-20541)
 * Fixed multiple single-node SAI query bugs relating to static columns (CASSANDRA-20338)
 * Upgrade com.datastax.cassandra:cassandra-driver-core:3.11.5 to org.apache.cassandra:cassandra-driver-core:3.12.1 (CASSANDRA-17231)
 * Update netty to 4.1.119.Final and netty-tcnative to 2.0.70.Final (CASSANDRA-20314)
 * Serialization can lose complex deletions in a mutation with multiple collections in a row (CASSANDRA-20449)
 * Improve error messages when initializing auth classes (CASSANDRA-20368)
 * Prioritize legacy 2i over SAI for columns with multiple indexes (CASSANDRA-20334)
 * Ensure only offline tools can build IntervalTrees without first/last key fields (CASSANDRA-20407)
 * Improve disk access patterns during compaction and range reads (CASSANDRA-15452)
 * Improve IntervalTree build throughput (CASSANDRA-19596)
 * Avoid limit on RFP fetch in the case of an unresolved static row (CASSANDRA-20323)
 * Include materialized views to the output of DESCRIBE TABLE statements (CASSANDRA-20365)
 * Heap and GC jvm flags improvements (CASSANDRA-20296)
 * Fix unparseable YAML in default cassandra.yaml when uncommented for downstream tooling (CASSANDRA-20359)
 * Avoid fetching entire partitions on unresolved static rows in RFP when no static column predicates exist (CASSANDRA-20243)
 * Avoid indexing empty values for non-literals and types that do not allow them (CASSANDRA-20313)
 * Fix incorrect results of min / max in-built functions on clustering columns in descending order (CASSANDRA-20295)
 * Avoid possible consistency violations for SAI intersection queries over repaired index matches and multiple non-indexed column matches (CASSANDRA-20189)
 * Skip check for DirectIO when initializing tools (CASSANDRA-20289)
 * Avoid under-skipping during intersections when an iterator has mixed STATIC and WIDE keys (CASSANDRA-20258)
 * Correct the default behavior of compareTo() when comparing WIDE and STATIC PrimaryKeys (CASSANDRA-20238)
 * Make sure we can set parameters when configuring CassandraCIDRAuthorizer (CASSANDRA-20220)
 * Add selected SAI index state and query performance metrics to nodetool tablestats (CASSANDRA-20026)
 * Remove v30 and v3X from 5.x in-JVM upgrade tests (CASSANDRA-20103)
 * Avoid memory allocation in offheap_object's NativeCell.valueSize() and NativeClustering.dataSize() (CASSANDRA-20162)
 * Add flag to avoid invalidating key cache on sstable deletions (CASSANDRA-20068)
 * Interpret inet, bigint, varint, and decimal as non-reversed types for query construction and post-filtering (CASSANDRA-20100)
 * Streamline the serialized format for index status gossip messages (CASSANDRA-20058)
 * Batch clusterings into single SAI partition post-filtering reads (CASSANDRA-19497)
 * Ban the usage of "var" instead of full types in the production code (CASSANDRA-20038)
 * Suppress CVE-2024-45772, upgrade to lucene-core-9.12.0.jar (CASSANDRA-20024)
 * Use SinglePartitionReadCommand for index queries that use strict filtering (CASSANDRA-19968)
 * Always write local expiration time as an int to LivenessInfo digest (CASSANDRA-19989)
 * Enables IAuthenticator's to return own AuthenticateMessage (CASSANDRA-19984)
 * Use ParameterizedClass for all auth-related implementations (CASSANDRA-19946)
 * Correct out-of-date metrics and configuration documentation for SAI (CASSANDRA-19898)
 * Make configuration entries in memtable section order-independent (CASSANDRA-19906)
 * Add guardrail for enabling usage of VectorType (CASSANDRA-19903)
 * Set executable flag for shell scripts in .build directory for source artifact (CASSANDRA-19896)
 * Throw ConfigurationException when commitlog_disk_access_mode is direct but direct IO is not supported by filesystem (CASSANDRA-19812)
 * Memtable allocation type unslabbed_heap_buffers_logged will cause an assertion error for TrieMemtables and SegmentedTrieMemtables (CASSANDRA-19835)
 * Minor improvements in Cassandra shutdown and startup logs (CASSANDRA-19818)
 * Fix direct IO support always being evaluated to false upon the first start of a node (CASSANDRA-19779)
 * Deprecate and ignore use_deterministic_table_id (CASSANDRA-19809)
 * Prioritize built indexes in IndexStatusManager (CASSANDRA-19400)
 * Add java.base/java.lang.reflect among opens for jvm11-client.options (CASSANDRA-19780)
 * Obsolete expired SSTables before compaction starts (CASSANDRA-19776)
 * Switch lz4-java to at.yawk.lz4 version due to CVE (CASSANDRA-21052)
 * Restrict BytesType compatibility to scalar types only (CASSANDRA-20982)
 * Backport fix to nodetool gcstats output for direct memory (CASSANDRA-21037)
 * ArrayIndexOutOfBoundsException with repaired data tracking and counters (CASSANDRA-20871)
 * Fix cleanup of old incremental repair sessions in case of owned token range changes or a table deleting (CASSANDRA-20877)
 * Fix memory leak in BufferPoolAllocator when a capacity needs to be extended (CASSANDRA-20753)
 * Leveled Compaction doesn't validate maxBytesForLevel when the table is altered/created (CASSANDRA-20570)
 * Updated dtest-api to 0.0.18 and removed JMX-related classes that now live in the dtest-api (CASSANDRA-20884)
 * Fixed incorrect error message constant for keyspace name length validation (CASSANDRA-20915)
 * Prevent too long table names not fitting file names (CASSANDRA-20389)
 * Update Jackson to 2.19.2 (CASSANDRA-20848)
 * Update commons-lang3 to 3.18.0 (CASSANDRA-20849)
 * Add NativeTransportMaxConcurrentConnectionsPerIp to StorageProxyMBean (CASSANDRA-20642)
 * Make secondary index implementations notified about rows in fully expired SSTables in compaction (CASSANDRA-20829)
 * Ensure prepared_statement INSERT timestamp precedes eviction DELETE (CASSANDRA-19703)
 * Gossip doesn't converge due to race condition when updating EndpointStates multiple fields (CASSANDRA-20659)
 * Handle sstable metadata stats file getting a new mtime after compaction has finished (CASSANDRA-18119)
 * Honor MAX_PARALLEL_TRANSFERS correctly (CASSANDRA-20532)
 * Updating a column with a new TTL but same expiration time is non-deterministic and causes repair mismatches. (CASSANDRA-20561)
 * Avoid computing prepared statement size for unprepared batches (CASSANDRA-20556)
 * Fix Dropwizard Meter causes timeouts when infrequently used (CASSANDRA-19332)
 * Update OWASP dependency checker to version 12.1.0 (CASSANDRA-20501)
 * Suppress CVE-2025-25193 (CASSANDRA-20504)
 * Include in source tree and build packages a Snyk policy file that lists known false positives (CASSANDRA-20319)
 * Update zstd-jni to 1.5.7-2 (CASSANDRA-20453)
 * Suppress CVE-2024-12801 (CASSANDRA-20412)
 * Suppress CVE-2024-12798 (CASSANDRA-20408)
 * Support null column value tombstones in FQL batch statements (CASSANDRA-20397)
 * Update Zstd library to 1.5.7-1 (CASSANDRA-20367)
 * Fix premature auto-failing of long-running repairs (CASSANDRA-20312)
 * Fix autocompletion for role names/user names (CASSANDRA-20175)
 * Tighten up permissions in dc and cidr authorizers (CASSANDRA-20225)
 * CBUtil serialization of UTF8 does not handle all UTF8 properly (CASSANDRA-20234)
 * Make hint expiry use request start time rather than timeout time for TTL (CASSANDRA-20014)
 * Do not attach rows and partitions to QueryCancellationChecker when already attached (CASSANDRA-20135)
 * Allow hint delivery during schema mismatch (CASSANDRA-20188)
 * IndexOutOfBoundsException when accessing partition where the column was deleted (CASSANDRA-20108)
 * Enhance CQLSSTableWriter to notify clients on sstable production (CASSANDRA-19800)
 * Change the resolution of AbstractCommitLogService#lastSyncedAt to nanos to be aligned with later comparisons (CASSANDRA-20074)
 * Support UDTs and vectors as clustering keys in descending order (CASSANDRA-20050)
 * Fix CQL in snapshot's schema which did not contained UDTs used as reverse clustering columns (CASSANDRA-20036)
 * Add configurable batchlog endpoint strategies: random_remote, prefer_local, dynamic_remote, and dynamic (CASSANDRA-18120)
 * Fix bash-completion for debian distro (CASSANDRA-19999)
 * Ensure thread-safety for CommitLogArchiver in CommitLog (CASSANDRA-19960)
 * Fix text containing "/*" being interpreted as multiline comment in cqlsh (CASSANDRA-17667)
 * Fix indexing of a frozen collection that is the clustering key and reversed (CASSANDRA-19889)
 * Emit error when altering a table with non-frozen UDTs with nested non-frozen collections the same way as done upon table creation (CASSANDRA-19925)
 * Safer handling of out-of-range tokens (CASSANDRA-13704)
 * Fix memory leak in BTree.FastBuilder (CASSANDRA-19785)
 * Fix millisecond and microsecond precision for commit log replay (CASSANDRA-19448)
 * Improve accuracy of memtable heap usage tracking (CASSANDRA-17298)
 * Fix rendering UNSET collection types in query tracing (CASSANDRA-19880)
 * Fix latency reported by ideal consistency level monitoring (CASSANDRA-19651)
 * Do not spam log with SSLExceptions (CASSANDRA-18839)
Merged from 3.0
  * Tighten up permissions on system keyspaces (CASSANDRA-20090)

5.0.0
5.0-rc2
 * Fix direct IO support always being evaluated to false upon the first start of a node (CASSANDRA-19779)
 * Memtable allocation type unslabbed_heap_buffers_logged will cause an assertion error for TrieMemtables and SegmentedTrieMemtables (CASSANDRA-19835)
Merged from 4.0:
 * Use default commitlog settings in test YAMLs (CASSANDRA-19830)


5.0-rc1
 * Move bcpkix-jdk18on to build dependencies, update to 1.78 and explicitly enumerate transitive dependencies (CASSANDRA-19739)
 * Avoid streams in the common case for UpdateTransaction creation (CASSANDRA-19675)
 * Only wait until native_transport_timeout for dispatcher to finish (CASSANDRA-19697)
 * Disable chronicle analytics (CASSANDRA-19656)
 * Replace Stream iteration with for-loop for StorageProxy::updateCoordinatorWriteLatencyTableMetric (CASSANDRA-19676)
 * Enforce metric naming contract if scope is used in a metric name (CASSANDRA-19619)
 * Avoid reading of the same IndexInfo from disk many times for a large partition (CASSANDRA-19557)
 * Resolve the oldest hints just from descriptors and current writer if available (CASSANDRA-19600)
 * Optionally fail writes when SAI refuses to index a term value exceeding configured term max size (CASSANDRA-19493)
 * Vector search can restrict on clustering keys when filtering isn't required (CASSANDRA-19544)
 * Fix FBUtilities' parsing of gcp cos_containerd kernel versions (CASSANDRA-18594)
 * Clean up KeyRangeIterator classes (CASSANDRA-19428)
 * Warn clients about possible consistency violations for filtering queries against multiple mutable columns (CASSANDRA-19489)
 * Align buffer with commitlog segment size (CASSANDRA-19471)
 * Ensure SAI indexes empty byte buffers for types that allow them as a valid input (CASSANDRA-19461)
 * Deprecate Python 3.7 and earlier, but allow cqlsh to run with Python 3.6-3.11 (CASSANDRA-19467)
 * Set uuid_sstable_identifiers_enabled to true in cassandra-latest.yaml (CASSANDRA-19460)
 * Revert switching to approxTime in Dispatcher (CASSANDRA-19454)
 * Add an optimized default configuration to tests and make it available for new users (CASSANDRA-18753)
 * Fix remote JMX under Java17 (CASSANDRA-19453)
 * Avoid consistency violations for SAI intersections over unrepaired data at consistency levels requiring reconciliation (CASSANDRA-19018)
 * Fix NullPointerException in ANN+WHERE when adding rows in another partition (CASSANDRA-19404)
 * Record latencies for SAI post-filtering reads against local storage (CASSANDRA-18940)
 * Fix VectorMemoryIndex#update logic to compare vectors. Fix Index view (CASSANDRA-19168)
 * Deprecate native_transport_port_ssl (CASSANDRA-19392)
 * Update packaging shell includes (CASSANDRA-19283)
 * Fix data corruption in VectorCodec when using heap buffers (CASSANDRA-19167)
 * Avoid over-skipping of key iterators from static column indexes during mixed intersections (CASSANDRA-19278)
 * Make concurrent_index_builders configurable at runtime (CASSANDRA-19266)
 * Fix storage_compatibility_mode for streaming (CASSANDRA-19126)
 * Add support of vector type to cqlsh COPY command (CASSANDRA-19118)
 * Make CQLSSTableWriter to support building of SAI indexes (CASSANDRA-18714)
 * Append additional JVM options when using JDK17+ (CASSANDRA-19001)
 * Upgrade Python driver to 3.29.0 (CASSANDRA-19245)
 * Creating a SASI index after creating an SAI index does not break secondary index queries (CASSANDRA-18939)
 * Optionally fail when a non-partition-restricted query is issued against an index (CASSANDRA-18796)
 * Add a startup check to fail startup when using invalid configuration with certain Kernel and FS type (CASSANDRA-19196)
 * UCS min_sstable_size should not be lower than target_sstable_size lower bound (CASSANDRA-19112)
 * Fix the correspondingMessagingVersion of SSTable format and improve TTL overflow tests coverage (CASSANDRA-19197)
 * Fix resource cleanup after SAI query timeouts (CASSANDRA-19177)
 * Suppress CVE-2023-6481 (CASSANDRA-19184)
Merged from 4.1:
 * Add native transport deadline, an ultimate deadline for all tasks related to a specific request (CASSANDRA-19534)
 * Do not create a role if ALTER ROLE IF EXISTS operates on non-existing role (CASSANDRA-19749)
 * Use OpOrder in repairIterator to ensure we don't lose memtables mid-paxos repair (Cassandra-19668)
 * Refresh stale paxos commit (CASSANDRA-19617)
 * Reduce info logging from automatic paxos repair (CASSANDRA-19445)
 * Support legacy plain_text_auth section in credentials file removed unintentionally (CASSANDRA-19498)
Merged from 4.0:
 * Support null column value tombstones in FQL batch statements (CASSANDRA-20397)
 * Fix millisecond and microsecond precision for commit log replay (CASSANDRA-19448)
 * Improve accuracy of memtable heap usage tracking (CASSANDRA-17298)
 * Fix rendering UNSET collection types in query tracing (CASSANDRA-19880)
 * Fix latency reported by ideal consistency level monitoring (CASSANDRA-19651)
 * Use default commitlog settings in test YAMLs (CASSANDRA-19830)
 * Do not spam log with SSLExceptions (CASSANDRA-18839)
 * Fix schema.cql created by a snapshot after dropping more than one column (CASSANDRA-19747)
 * UnsupportedOperationException when reducing scope for LCS compactions (CASSANDRA-19704)
 * Make LWT conditions behavior on frozen and non-frozen columns consistent for null column values (CASSANDRA-19637)
 * Add timeout specifically for bootstrapping nodes (CASSANDRA-15439)
 * Bring Redhat packge dirs/ownership/perms in line with Debian package (CASSANDRA-19565)
Merged from 3.0:
 * Upgrade OWASP to 10.0.0 (CASSANDRA-19738)


4.1.5
 * Make queries visible to the "system_views.queries" virtual table at the coordinator level (CASSANDRA-19577)
 * Fix hints delivery for a node going down repeatedly (CASSANDRA-19495)
 * Do not go to disk for reading hints file sizes (CASSANDRA-19477)
 * Fix system_views.settings to handle array types (CASSANDRA-19475)
 * Fix StackOverflowError on ALTER after many previous schema changes (CASSANDRA-19166)
 * Memoize Cassandra verion (CASSANDRA-18902)
Merged from 4.0:
 * Fix millisecond and microsecond precision for commit log replay (CASSANDRA-19448)
 * Improve accuracy of memtable heap usage tracking (CASSANDRA-17298)
 * Fix rendering UNSET collection types in query tracing (CASSANDRA-19880)
 * Fix latency reported by ideal consistency level monitoring (CASSANDRA-19651)
 * Use default commitlog settings in test YAMLs (CASSANDRA-19830)
 * Do not spam log with SSLExceptions (CASSANDRA-18839)
 * Fix schema.cql created by a snapshot after dropping more than one column (CASSANDRA-19747)
 * UnsupportedOperationException when reducing scope for LCS compactions (CASSANDRA-19704)
 * Make LWT conditions behavior on frozen and non-frozen columns consistent for null column values (CASSANDRA-19637)
 * Bring Redhat package dirs/ownership/perms in line with Debian package (CASSANDRA-19565)
 * Make nodetool import congruent with the documentation by not relying on the folder structure of the imported SSTable files (CASSANDRA-19401)
 * IR may leak SSTables with pending repair when coming from streaming (CASSANDRA-19182)
 * Streaming exception race creates corrupt transaction log files that prevent restart (CASSANDRA-18736)
 * Fix CQL tojson timestamp output on negative timestamp values before Gregorian calendar reform in 1582 (CASSANDRA-19566)
 * Fix few types issues and implement types compatibility tests (CASSANDRA-19479)
 * Change logging to TRACE when failing to get peer certificate (CASSANDRA-19508)
 * Push LocalSessions info logs to debug (CASSANDRA-18335)
 * Filter remote DC replicas out when constructing the initial replica plan for the local read repair (CASSANDRA-19120)
 * Remove redundant code in StorageProxy#sendToHintedReplicas (CASSANDRA-19412)
 * Remove bashisms for mx4j tool in cassandra-env.sh (CASSANDRA-19416)
 * Add new concurrent_merkle_tree_requests config property to prevent OOM during multi-range and/or multi-table repairs (CASSANDRA-19336)
Merged from 3.11:
 * Move ClientWarn.State#warnings to a thread-safe list (CASSANDRA-19427)
Merged from 3.0:
 * Upgrade OWASP to 10.0.0 (CASSANDRA-19738)
 * Fix SCM URL link (CASSANDRA-19422)
 * Backport CASSANDRA-16418 to 3.x (CASSANDRA-18824)


5.0-beta1
 * Fix SAI intersection queries (CASSANDRA-19011)
 * Clone EndpointState before sending GossipShutdown message (CASSANDRA-19115)
 * SAI indexes are marked queryable during truncation (CASSANDRA-19032)
 * Enable Direct-IO feature for CommitLog files using Java native API's. (CASSANDRA-18464)
 * SAI fixes for composite partitions, and static and non-static rows intersections (CASSANDRA-19034)
 * Improve SAI IndexContext handling of indexed and non-indexed columns in queries (CASSANDRA-18166)
 * Fixed bug where UnifiedCompactionTask constructor was calling the wrong base constructor of CompactionTask (CASSANDRA-18757)
 * Fix SAI unindexed contexts not considering CONTAINS KEY (CASSANDRA-19040)
 * Ensure that empty SAI column indexes do not fail on validation after full-SSTable streaming (CASSANDRA-19017)
 * SAI in-memory index should check max term size (CASSANDRA-18926)
 * Set default disk_access_mode to mmap_index_only (CASSANDRA-19021)
 * Exclude net.java.dev.jna:jna dependency from dependencies of org.caffinitas.ohc:ohc-core (CASSANDRA-18992)
 * Add UCS sstable_growth and min_sstable_size options (CASSANDRA-18945)
 * Make cqlsh's min required Python version 3.7+ instead of 3.6+ (CASSANDRA-18960)
 * Fix incorrect seeking through the sstable iterator by IndexState (CASSANDRA-18932)
 * Upgrade Python driver to 3.28.0 (CASSANDRA-18960)
 * Add retries to IR messages (CASSANDRA-18962)
 * Add metrics and logging to repair retries (CASSANDRA-18952)
 * Remove deprecated code in Cassandra 1.x and 2.x (CASSANDRA-18959)
 * ClientRequestSize metrics should not treat CONTAINS restrictions as being equality-based (CASSANDRA-18896)
 * Add support for vector search in SAI (CASSANDRA-18715)
 * Remove crc_check_chance from CompressionParams (CASSANDRA-18872)
 * Fix schema loading of UDTs inside vectors inside UDTs (CASSANDRA-18964)
 * Add cqlsh autocompletion for the vector data type (CASSANDRA-18946)
 * Fix nodetool tablehistograms output to avoid printing repeated information and ensure at most two arguments (CASSANDRA-18955)
 * Change the checksum algorithm SAI-related files use from CRC32 to CRC32C (CASSANDRA-18836)
 * Correctly remove Index.Group from IndexRegistry (CASSANDRA-18905)
 * Fix vector type to support DDM's mask_default function (CASSANDRA-18889)
 * Remove unnecessary reporter-config3 dependency (CASSANDRA-18907)
 * Remove support for empty values on the vector data type (CASSANDRA-18876)
 * Upgrade Dropwizard Metrics to 4.2.19 (CASSANDRA-14667)
 * Upgrade caffeine cache and fix CIDR permissions cache invalidation (CASSANDRA-18805)
 * Remove deprecated properties in CompressionParams (CASSANDRA-18742)
 * Add support for repair coordinator to retry messages that timeout (CASSANDRA-18816)
 * Upgrade slf4j-api to 1.7.36 (CASSANDRA-18882)
 * Make the output of ON/OFF commands in cqlsh consistent (CASSANDRA-18547)
 * Do not create sstable files before registering in txn (CASSANDRA-18737)
 * Remove wrong assertion in SSTableLoader (CASSANDRA-18840)
 * Do not log stacktrace on mismatched cache and schema version and checksum error in AutoSavingCache (CASSANDRA-18862)
 * Remove wrong assertion in SSTableLoader (CASSANDRA-18840)
 * Fix accessing java.nio.Bits.TOTAL_CAPACITY in Java17 (CASSANDRA-18848)
 * Remove metrics-reporter-config dependency (CASSANDRA-18743)
 * Fix SAI's SegmentMetadata min and max primary keys (CASSANDRA-18734)
 * Remove commons-codec dependency (CASSANDRA-18772)
Merged from 4.1:
 * Internode legacy SSL storage port certificate is not hot reloaded on update (CASSANDRA-18681)
 * Nodetool paxos-only repair is no longer incremental (CASSANDRA-18466)
Merged from 4.0:
 * Support max SSTable size in sorted CQLSSTableWriter (CASSANDRA-18941)
 * Fix nodetool repair_admin summarize-pending command to not throw exception (CASSANDRA-19014)
 * Fix cassandra-stress in simplenative mode with prepared statements (CASSANDRA-18744)
 * Fix filtering system ks sstables for relocation on startup (CASSANDRA-18963)
 * Remove completed coordinator sessions (CASSANDRA-18903)
 * Gossip NPE due to shutdown event corrupting empty statuses (CASSANDRA-18913)
 * Update hdrhistogram to 2.1.12 (CASSANDRA-18893)
 * Improve performance of compactions when table does not have an index (CASSANDRA-18773)
 * JMH improvements - faster build and async profiler (CASSANDRA-18871)
 * Enable 3rd party JDK installations for Debian package (CASSANDRA-18844)
Merged from 3.11:
 * Revert CASSANDRA-18543 (CASSANDRA-18854)
Merged from 3.0:
 * Suppress CVE-2023-6378 (CASSANDRA-19142)
 * Do not set RPC_READY to false on transports shutdown in order to not fail counter updates for deployments with coordinator and storage nodes with transports turned off (CASSANDRA-18935)
 * Suppress CVE-2023-44487 (CASSANDRA-18943)
 * Implement the logic in bin/stop-server (CASSANDRA-18838)
 * Fix nodetool enable/disablebinary to correctly set rpc readiness in gossip (CASSANDRA-18935)
 * Implement the logic in bin/stop-server (CASSANDRA-18838)
 * Upgrade snappy-java to 1.1.10.4 (CASSANDRA-18878)
 * Add cqlshrc.sample and credentials.sample into Debian package (CASSANDRA-18818)


5.0-alpha1
 * Fix rpm installations to work with jdk17 (CASSANDRA-18817)
 * Fix Depends and Build-Depends for Java for Debian packages (CASSANDRA-18809)
 * Update command line flags --add-exports and --add-opens for JDK17 (CASSANDRA-18439)
 * Update commons-lang3 to 3.13.0 (CASSANDRA-18789)
 * Forbid SAI indexes with analysis options on primary key columns (CASSANDRA-18782)
 * Expose bootstrap failure state via JMX and nodetool info (CASSANDRA-18749)
 * Reduce size of per-SSTable index components for SAI (CASSANDRA-18673)
 * Remove unnecessary Netty dependencies after upgrade to version 4.1.96 (CASSANDRA-18729)
 * Prevent InaccessibleObjectException when the Leak Detector is traversing objects (CASSANDRA-18708)
 * Remove legacy command line options from cassandra-stress (CASSANDRA-18529)
 * Remove commitlog_sync_batch_window_in_ms (CASSANDRA-17161)
 * Upgrade JMH from 1.21 to 1.36 (CASSANDRA-18696)
 * Add guardrail for vector dimensions (CASSANDRA-18730)
Merged from 4.1:
 * Fixed the inconsistency between distributedKeyspaces and distributedAndLocalKeyspaces (CASSANDRA-18747)
 * Waiting indefinitely on ReceivedMessage response in StreamSession#receive() can cause deadlock (CASSANDRA-18733)
 * Allow empty keystore_password in encryption_options (CASSANDRA-18778)
Merged from 4.0:
 * Retrieve keyspaces metadata and schema version concistently in DescribeStatement (CASSANDRA-18921)
 * JMH improvements - faster build and async profiler (CASSANDRA-18871)
Merged from 3.11:
 * Fix NPE when using udfContext in UDF after a restart of a node (CASSANDRA-18739)
Merged from 3.0:
 * Add cqlshrc.sample and credentials.sample into Debian package (CASSANDRA-18818)
 * Refactor validation logic in StorageService.rebuild (CASSANDRA-18803)
 * Make alternation of a user type validate the same way as creation of a user type does (CASSANDRA-18585)
 * Fix missing speculative retries in tablestats (CASSANDRA-18767)
 * Fix Requires for Java for RPM package (CASSANDRA-18751)
 * Fix CQLSH online help topic link (CASSANDRA-17534)
 * Remove unused suppressions (CASSANDRA-18724)


5.0
 * Upgraded Netty to 4.1.96, added BouncyCastle dependency (CASSANDRA-17992)
 * Fix for (unsupported) big endian unaligned architecture, eg s390x (CASSANDRA-17723)
 * CIDR filtering authorizer (CASSANDRA-18592)
 * Remove 3.x from the versions checked for prepared statement behaviour (CASSANDRA-18695)
 * Add vector similarity functions (CASSANDRA-18640)
 * Lift MessagingService.minimum_version to 40 (CASSANDRA-18314)
 * Introduce pluggable crypto providers and default to AmazonCorrettoCryptoProvider (CASSANDRA-18624)
 * Improved DeletionTime serialization (CASSANDRA-18648)
 * CEP-7: Storage Attached Indexes (CASSANDRA-16052)
 * Add equals/hashCode override for ServerEncryptionOptions (CASSANDRA-18428)
 * Upgrade ECJ to version 3.33.0 (CASSANDRA-18190)
 * Fix ClassCastException  from jdk GaloisCounterMode when using JDK17 provider (CASSANDRA-18180)
 * Drop JDK8, add JDK17 (CASSANDRA-18255)
 * Remove WaitingOnFreeMemtableSpace and DroppedMutations metrics (CASSANDRA-18298)
 * Upgrade Jamm version to 0.4.0  (CASSANDRA-17884, CASSANDRA-16304, CASSANDRA-18329)
 * Remove legacy 3.0/3.11 buffer pool metrics (CASSANDRA-18313)
 * Add AzureSnitch (CASSANDRA-18646)
 * Implementation of the Unified Compaction Strategy as described in CEP-26 (CASSANDRA-18397)
 * Upgrade commons cli to 1.5.0 (CASSANDRA-18659)
 * Disable the deprecated keyspace/table thresholds and convert them to guardrails (CASSANDRA-18617)
 * Deprecate CloudstackSnitch and remove duplicate code in snitches (CASSANDRA-18438)
 * Add support for vectors in UDFs (CASSANDRA-18613)
 * Improve vector value validation errors (CASSANDRA-18652)
 * Upgrade Guava to 32.0.1 (CASSANDRA-18645)
 * Add duration and count of partition keys to sstablemetadata (CASSANDRA-18639)
 * Remove deprecated compaction_tombstone_warning_threshold and compaction_large_partition_warning_threshold from yaml (CASSANDRA-18626)
 * Enhance nodetool compactionstats with additional metrics (CASSANDRA-18305)
 * Added support for type VECTOR<type, dimension> (CASSANDRA-18504)
 * Expose bootstrap and decommission state to nodetool info (CASSANDRA-18555)
 * Fix SSTabledump errors when dumping data from index (CASSANDRA-17698)
 * Avoid unnecessary deserialization of terminal arguments when executing CQL functions (CASSANDRA-18566)
 * Remove dependency on pytz library for setting CQLSH timezones on Python version >= 3.9 (CASSANDRA-17433)
 * Extend maximum expiration date (CASSANDRA-14227)
 * Add guardrail for partition tombstones and deprecate compaction_tombstone_warning_threshold (CASSANDRA-17194)
 * Print header and statistics for cassandra-stress output with arbitrary frequency (CASSANDRA-12972)
 * CEP-25: Trie-indexed SSTable format (CASSANDRA-18398)
 * Make cassandra-stress able to read all credentials from a file (CASSANDRA-18544)
 * Add guardrail for partition size and deprecate compaction_large_partition_warning_threshold (CASSANDRA-18500)
 * Add HISTORY command for CQLSH (CASSANDRA-15046)
 * Fix sstable formats configuration (CASSANDRA-18441)
 * Add guardrail to bound timestamps (CASSANDRA-18352)
 * Add keyspace_name column to system_views.clients (CASSANDRA-18525)
 * Moved system properties and envs to CassandraRelevantProperties and CassandraRelevantEnv respectively (CASSANDRA-17797)
 * Add sstablepartitions offline tool to find large partitions in sstables (CASSANDRA-8720)
 * Replace usages of json-simple dependency by Jackson (CASSANDRA-16855)
 * When decommissioning should set Severity to limit traffic (CASSANDRA-18430)
 * For Java11 and Java17 remove -XX:-UseBiasedLocking as it is the default already (CASSANDRA-17869)
 * Upgrade commons-io to 2.11.0 (CASSANDRA-17364)
 * Node Draining Should Abort All Current SSTables Imports (CASSANDRA-18373)
 * Use snake case for the names of CQL native functions (CASSANDRA-18037)
 * Use jdk-dependent checkstyle version to check the source code (CASSANDRA-18262)
 * Provide summary of failed SessionInfo's in StreamResultFuture (CASSANDRA-17199)
 * CEP-20: Dynamic Data Masking (CASSANDRA-17940)
 * Add system_views.snapshots virtual table (CASSANDRA-18102)
 * Update OpenHFT dependencies (chronicle-queue, chronicle-core, chronicle-bytes, chronicle-wire, chronicle-threads) (CASSANDRA-18049)
 * Remove org.apache.cassandra.hadoop code (CASSANDRA-18323)
 * Remove deprecated CQL functions dateOf and unixTimestampOf (CASSANDRA-18328)
 * Remove DateTieredCompactionStrategy (CASSANDRA-18043)
 * Add system_views.max_sstable_size and system_views.max_sstable_duration tables (CASSANDRA-18333)
 * Extend implicit allow-filtering for virtual tables to clustering columns (CASSANDRA-18331)
 * Upgrade maven-shade-plugin to 3.4.1 to fix shaded dtest JAR build (CASSANDRA-18136)
 * Upgrade to Opcodes.ASM9 (CASSANDRA-17971)
 * Add MaxSSTableSize and MaxSSTableDuration metrics and propagate them together with local read/write ratio to tablestats (CASSANDRA-18283)
 * Add more logging around CompactionManager operations (CASSANDRA-18268)
 * Reduce memory allocations of calls to ByteBufer.duplicate() made in org.apache.cassandra.transport.CBUtil#writeValue (CASSANDRA-18212)
 * CEP-17: SSTable API (CASSANDRA-17056)
 * Gossip stateMapOrdering does not have correct ordering when both EndpointState are in the bootstrapping set (CASSANDRA-18292)
 * Snapshot only sstables containing mismatching ranges on preview repair mismatch (CASSANDRA-17561)
 * More accurate skipping of sstables in read path (CASSANDRA-18134)
 * Prepare for JDK17 experimental support (CASSANDRA-18179, CASSANDRA-18258)
 * Remove Scripted UDFs internals; hooks to be added later in CASSANDRA-17281 (CASSANDRA-18252)
 * Update JNA to 5.13.0 (CASSANDRA-18050)
 * Make virtual tables decide if they implicitly enable ALLOW FILTERING (CASSANDRA-18238)
 * Add row, tombstone, and sstable count to nodetool profileload (CASSANDRA-18022)
 * Coordinator level metrics for read response and mutation row and column counts (CASSANDRA-18155)
 * Add CQL functions for dynamic data masking (CASSANDRA-17941)
 * Print friendly error when nodetool attempts to connect to uninitialized server (CASSANDRA-11537)
 * Use G1GC by default, and update default G1GC settings (CASSANDRA-18027)
 * SimpleSeedProvider can resolve multiple IP addresses per DNS record (CASSANDRA-14361)
 * Remove mocking in InternalNodeProbe spying on StorageServiceMBean (CASSANDRA-18152)
 * Add compaction_properties column to system.compaction_history table and nodetool compactionhistory command (CASSANDRA-18061)
 * Remove ProtocolVersion entirely from the CollectionSerializer ecosystem (CASSANDRA-18114)
 * Fix serialization error in new getsstables --show-levels option (CASSANDRA-18140)
 * Use checked casts when reading vints as ints (CASSANDRA-18099)
 * Add Mutation Serialization Caching (CASSANDRA-17998)
 * Only reload compaction strategies if disk boundaries change (CASSANDRA-17874)
 * CEP-10: Simulator Java11 Support (CASSANDRA-17178)
 * Set the major compaction type correctly for compactionstats (CASSANDRA-18055)
 * Print exception message without stacktrace when nodetool commands fail on probe.getOwnershipWithPort() (CASSANDRA-18079)
 * Add option to print level in nodetool getsstables output (CASSANDRA-18023)
 * Implement a guardrail for not having zero default_time_to_live on tables with TWCS (CASSANDRA-18042)
 * Add CQL scalar functions for collection aggregation (CASSANDRA-18060)
 * Make cassandra.replayList property for CommitLogReplayer possible to react on keyspaces only (CASSANDRA-18044)
 * Add Mathematical functions (CASSANDRA-17221)
 * Make incremental backup configurable per table (CASSANDRA-15402)
 * Change shebangs of Python scripts to resolve Python 3 from env command (CASSANDRA-17832)
 * Add reasons to guardrail messages and consider guardrails in the error message for needed ALLOW FILTERING (CASSANDRA-17967)
 * Add support for CQL functions on collections, tuples and UDTs (CASSANDRA-17811)
 * Add flag to exclude nodes from local DC when running nodetool rebuild (CASSANDRA-17870)
 * Adding endpoint verification option to client_encryption_options (CASSANDRA-18034)
 * Replace 'wcwidth.py' with pypi module (CASSANDRA-17287)
 * Add nodetool forcecompact to remove tombstoned or ttl'd data ignoring GC grace for given table and partition keys (CASSANDRA-17711)
 * Offer IF (NOT) EXISTS in cqlsh completion for CREATE TYPE, DROP TYPE, CREATE ROLE and DROP ROLE (CASSANDRA-16640)
 * Nodetool bootstrap resume will now return an error if the operation fails (CASSANDRA-16491)
 * Disable resumable bootstrap by default (CASSANDRA-17679)
 * Include Git SHA in --verbose flag for nodetool version (CASSANDRA-17753)
 * Update Byteman to 4.0.20 and Jacoco to 0.8.8 (CASSANDRA-16413)
 * Add memtable option among possible tab completions for a table (CASSANDRA-17982)
 * Adds a trie-based memtable implementation (CASSANDRA-17240)
 * Further improves precision of memtable heap tracking (CASSANDRA-17240)
 * Fix formatting of metrics documentation (CASSANDRA-17961)
 * Keep sstable level when streaming for decommission and move (CASSANDRA-17969)
 * Add Unavailables metric for CASWrite in the docs (CASSANDRA-16357)
 * Make Cassandra logs able to be viewed in the virtual table system_views.system_logs (CASSANDRA-17946)
 * IllegalArgumentException in Gossiper#order due to concurrent mutations to elements being applied (CASSANDRA-17908)
 * Include estimated active compaction remaining write size when starting a new compaction (CASSANDRA-17931)
 * Mixed mode support for internode authentication during TLS upgrades (CASSANDRA-17923)
 * Revert Mockito downgrade from CASSANDRA-17750 (CASSANDRA-17496)
 * Add --older-than and --older-than-timestamp options for nodetool clearsnapshots (CASSANDRA-16860)
 * Fix "open RT bound as its last item" exception (CASSANDRA-17810)
 * Fix leak of non-standard Java types in JMX MBeans `org.apache.cassandra.db:type=StorageService`
   and `org.apache.cassandra.db:type=RepairService` as clients using JMX cannot handle them. More details in NEWS.txt (CASSANDRA-17668)
 * Deprecate Throwables.propagate usage (CASSANDRA-14218)
 * Allow disabling hotness persistence for high sstable counts (CASSANDRA-17868)
 * Prevent NullPointerException when changing neverPurgeTombstones from true to false (CASSANDRA-17897)
 * Add metrics around storage usage and compression (CASSANDRA-17898)
 * Remove usage of deprecated javax certificate classes (CASSANDRA-17867)
 * Make sure preview repairs don't optimise streams unless configured to (CASSANDRA-17865)
 * Optionally avoid hint transfer during decommission (CASSANDRA-17808)
 * Make disabling auto snapshot on selected tables possible (CASSANDRA-10383)
 * Introduce compaction priorities to prevent upgrade compaction inability to finish (CASSANDRA-17851)
 * Prevent a user from manually removing ephemeral snapshots (CASSANDRA-17757)
 * Remove dependency on Maven Ant Tasks (CASSANDRA-17750)
 * Update ASM(9.1 to 9.3), Mockito(1.10.10 to 1.12.13) and ByteBuddy(3.2.4 to 4.7.0) (CASSANDRA-17835)
 * Add the ability for operators to loosen the definition of "empty" for edge cases (CASSANDRA-17842)
 * Fix potential out of range exception on column index downsampling (CASSANDRA-17839)
 * Introduce target directory to vtable output for sstable_tasks and for compactionstats (CASSANDRA-13010)
 * Read/Write/Truncate throw RequestFailure in a race condition with callback timeouts, should return Timeout instead (CASSANDRA-17828)
 * Add ability to log load profiles at fixed intervals (CASSANDRA-17821)
 * Protect against Gossip backing up due to a quarantined endpoint without version information (CASSANDRA-17830)
 * NPE in org.apache.cassandra.cql3.Attributes.getTimeToLive (CASSANDRA-17822)
 * Add guardrail for column size (CASSANDRA-17151)
 * When doing a host replacement, we need to check that the node is a live node before failing with "Cannot replace a live node..." (CASSANDRA-17805)
 * Add support to generate a One-Shot heap dump on unhandled exceptions (CASSANDRA-17795)
 * Rate-limit new client connection auth setup to avoid overwhelming bcrypt (CASSANDRA-17812)
 * DataOutputBuffer#scratchBuffer can use off-heap or on-heap memory as a means to control memory allocations (CASSANDRA-16471)
 * Add ability to read the TTLs and write times of the elements of a collection and/or UDT (CASSANDRA-8877)
 * Removed Python < 2.7 support from formatting.py (CASSANDRA-17694)
 * Cleanup pylint issues with pylexotron.py (CASSANDRA-17779)
 * NPE bug in streaming checking if SSTable is being repaired (CASSANDRA-17801)
 * Users of NativeLibrary should handle lack of JNA appropriately when running in client mode (CASSANDRA-17794)
 * Warn on unknown directories found in system keyspace directory rather than kill node during startup checks (CASSANDRA-17777)
 * Log duplicate rows sharing a partition key found in verify and scrub (CASSANDRA-17789)
 * Add separate thread pool for Secondary Index building so it doesn't block compactions (CASSANDRA-17781)
 * Added JMX call to getSSTableCountPerTWCSBucket for TWCS (CASSANDRA-17774)
 * When doing a host replacement, -Dcassandra.broadcast_interval_ms is used to know when to check the ring but checks that the ring wasn't changed in -Dcassandra.ring_delay_ms, changes to ring delay should not depend on when we publish load stats (CASSANDRA-17776)
 * When bootstrap fails, CassandraRoleManager may attempt to do read queries that fail with "Cannot read from a bootstrapping node", and increments unavailables counters (CASSANDRA-17754)
 * Add guardrail to disallow DROP KEYSPACE commands (CASSANDRA-17767)
 * Remove ephemeral snapshot marker file and introduce a flag to SnapshotManifest (CASSANDRA-16911)
 * Add a virtual table that exposes currently running queries (CASSANDRA-15241)
 * Allow sstableloader to specify table without relying on path (CASSANDRA-16584)
 * Fix TestGossipingPropertyFileSnitch.test_prefer_local_reconnect_on_listen_address (CASSANDRA-17700)
 * Add ByteComparable API (CASSANDRA-6936)
 * Add guardrail for maximum replication factor (CASSANDRA-17500)
 * Increment CQLSH to version 6.2.0 for release 4.2 (CASSANDRA-17646)
 * Adding support to perform certificate based internode authentication (CASSANDRA-17661)
 * Option to disable CDC writes of repaired data (CASSANDRA-17666)
 * When a node is bootstrapping it gets the whole gossip state but applies in random order causing some cases where StorageService will fail causing an instance to not show up in TokenMetadata (CASSANDRA-17676)
 * Add CQLSH command SHOW REPLICAS (CASSANDRA-17577)
 * Add guardrail to allow disabling of SimpleStrategy (CASSANDRA-17647)
 * Change default directory permission to 750 in packaging (CASSANDRA-17470)
 * Adding support for TLS client authentication for internode communication (CASSANDRA-17513)
 * Add new CQL function maxWritetime (CASSANDRA-17425)
 * Add guardrail for ALTER TABLE ADD / DROP / REMOVE column operations (CASSANDRA-17495)
 * Rename DisableFlag class to EnableFlag on guardrails (CASSANDRA-17544)
Merged from 4.1:
 * Skip ColumnFamilyStore#topPartitions initialization when client or tool mode (CASSANDRA-18697)
Merged from 4.0:
 * Partial compaction can resurrect deleted data (CASSANDRA-18507)
Merged from 3.11:
 * Fix delayed SSTable release with unsafe_aggressive_sstable_expiration (CASSANDRA-18756)
 * Fix NPE when using udfContext in UDF after a restart of a node (CASSANDRA-18739)
Merged from 3.0:
 * CQLSH emits a warning when the server version doesn't match (CASSANDRA-18745)
 * Fix missing speculative retries in tablestats (CASSANDRA-18767)
 * Fix Requires for Java for RPM package (CASSANDRA-18751)
 * Fix CQLSH online help topic link (CASSANDRA-17534)
 * Remove unused suppressions (CASSANDRA-18724)


4.1.4
 * Fix StackOverflowError on ALTER after many previous schema changes (CASSANDRA-19166)
Merged from 4.0:
 * Fix NTS log message when an unrecognized strategy option is passed (CASSANDRA-18679)
 * Fix BulkLoader ignoring cipher suites options (CASSANDRA-18582)
 * Migrate Python optparse to argparse (CASSANDRA-17914)
Merged from 3.11:
Merged from 3.0:


4.1.3
Merged from 4.0:
 * Revert CASSANDRA-16718 (CASSANDRA-18560)
 * Upgrade snappy to 1.1.10.1 (CASSANDRA-18608)
 * Fix assertion error when describing mv as table (CASSANDRA-18596)
 * Track the amount of read data per row (CASSANDRA-18513)
 * Fix Down nodes counter in nodetool describecluster (CASSANDRA-18512)
 * Remove unnecessary shuffling of GossipDigests in Gossiper#makeRandomGossipDigest (CASSANDRA-18546)
Merged from 3.11:
 * Moved jflex from runtime to build dependencies (CASSANDRA-18664)
 * Fix CAST function for float to decimal (CASSANDRA-18647)
 * Suppress CVE-2022-45688 (CASSANDRA-18643)
 * Remove unrepaired SSTables from garbage collection when only_purge_repaired_tombstones is true (CASSANDRA-14204)
 * Wait for live endpoints in gossip waiting to settle (CASSANDRA-18543)
 * Fix error message handling when trying to use CLUSTERING ORDER with non-clustering column (CASSANDRA-17818
 * Add keyspace and table name to exception message during ColumnSubselection deserialization (CASSANDRA-18346)
Merged from 3.0:
 * Suppress CVE-2023-34462 (CASSANDRA-18649)
 * Add support for AWS Ec2 IMDSv2 (CASSANDRA-16555)
 * Suppress CVE-2023-35116 (CASSANDRA-18630)
 * Pass taskId from CompactionTask to system.compaction_history (CASSANDRA-12183)
 * Backport CASSANDRA-10508: Remove hard-coded SSL cipher suites (CASSANDRA-18575)
 * Suppress CVE-2023-2976 (CASSANDRA-18562)
 * Remove dh_python use in Debian packaging (CASSANDRA-18558)


4.1.2
 * NPE when deserializing malformed collections from client (CASSANDRA-18505)
 * Allow keystore and trustrore passwords to be nullable (CASSANDRA-18124)
 * Return snapshots with dots in their name in nodetool listsnapshots (CASSANDRA-18371)
 * Fix NPE when loading snapshots and data directory is one directory from root (CASSANDRA-18359)
 * Do not submit hints when hinted_handoff_enabled=false (CASSANDRA-18304)
 * Fix COPY ... TO STDOUT behavior in cqlsh (CASSANDRA-18353)
 * Remove six and Py2SaferScanner merge cruft (CASSANDRA-18354)
Merged from 4.0:
 * Improve nodetool enable{audit,fullquery}log (CASSANDRA-18550)
 * Report network cache info in nodetool (CASSANDRa-18400)
 * Partial compaction can resurrect deleted data (CASSANDRA-18507)
 * Allow internal address to change with reconnecting snitches (CASSANDRA-16718)
 * Fix quoting in toCqlString methods of UDTs and aggregates (CASSANDRA-17918)
 * Improve 'Not enough space for compaction' logging messages (CASSANDRA-18260)
 * Incremental repairs fail on mixed IPv4/v6 addresses serializing SyncRequest (CASSANDRA-18474)
 * Deadlock updating sstable metadata if disk boundaries need reloading (CASSANDRA-18443)
 * Fix nested selection of reversed collections (CASSANDRA-17913)
 * Update zstd-jni library to version 1.5.5 (CASSANDRA-18429)
Merged from 3.11:
 * Remove unnecessary String.format invocation in QueryProcessor when getting a prepared statement from cache (CASSANDRA-17202)
 * Fix the capital P usage in the CQL parser (CASSANDRA-17919)
Merged from 3.0:
 * Pass down all contact points to driver for cassandra-stress (CASSANDRA-18025)
 * Validate the existence of a datacenter in nodetool rebuild (CASSANDRA-14319)
 * Suppress CVE-2023-2251 (CASSANDRA-18497)
 * Do not remove SSTables when cause of FSReadError is OutOfMemoryError while using best_effort disk failure policy (CASSANDRA-18336)
 * Do not remove truncated_at entry in system.local while dropping an index (CASSANDRA-18105)


4.0.9
 * Update zstd-jni library to version 1.5.5 (CASSANDRA-18429)
 * Backport CASSANDRA-17205 to 4.0 branch - Remove self-reference in SSTableTidier (CASSANDRA-18332)
 * Avoid loading the preferred IP for BulkLoader streaming (CASSANDRA-18370)
 * Fix BufferPool incorrect memoryInUse when putUnusedPortion is used (CASSANDRA-18311)
 * Improve memtable allocator accounting when updating AtomicBTreePartition (CASSANDRA-18125)
 * Update zstd-jni to version 1.5.4-1 (CASSANDRA-18259)
 * Split and order IDEA workspace template VM_PARAMETERS (CASSANDRA-18242)
Merged from 3.11:
 * Fix sstable_count metric missing from tablestats json/yaml output (CASSANDRA-18448)
 * Suppress CVE-2022-45688 (CASSANDRA-18389)
 * Fix Splitter sometimes creating more splits than requested (CASSANDRA-18013)
Merged from 3.0:
 * Do not remove SSTables when cause of FSReadError is OutOfMemoryError while using best_effort disk failure policy (CASSANDRA-18336)
 * Do not remove truncated_at entry in system.local while dropping an index (CASSANDRA-18105)
 * Save host id to system.local and flush immediately after startup (CASSANDRA-18153)


4.1.1
 * Deprecate org.apache.cassandra.hadoop code (CASSANDRA-16984)
 * Fix too early schema version change in sysem local table (CASSANDRA-18291)
 * Fix copying of JAR of a trigger to temporary file (CASSANDRA-18264)
 * Fix possible NoSuchFileException when removing a snapshot (CASSANDRA-18211)
 * PaxosPrepare may add instances to the Electorate that are not in gossip (CASSANDRA-18194)
 * Fix PAXOS2_COMMIT_AND_PREPARE_RSP serialisation AssertionError (CASSANDRA-18164)
 * Streaming progress virtual table lock contention can trigger TCP_USER_TIMEOUT and fail streaming (CASSANDRA-18110)
 * Fix perpetual load of denylist on read in cases where denylist can never be loaded (CASSANDRA-18116)
Merged from 4.0:
 * Fix BufferPool incorrect memoryInUse when putUnusedPortion is used (CASSANDRA-18311)
 * Improve memtable allocator accounting when updating AtomicBTreePartition (CASSANDRA-18125)
 * Update zstd-jni to version 1.5.4-1 (CASSANDRA-18259)
 * Split and order IDEA workspace template VM_PARAMETERS (CASSANDRA-18242)
 * Log warning message on aggregation queries without key or on multiple keys (CASSANDRA-18219)
 * Fix the output of FQL dump tool to properly separate entries (CASSANDRA-18215)
 * Add cache type information for maximum memory usage warning message (CASSANDRA-18184)
 * Fix NPE in fqltool dump on null value (CASSANDRA-18113)
 * Improve unit tests performance (CASSANDRA-17427)
 * Connect to listen address when own broadcast address is requested (CASSANDRA-18200)
 * Add safeguard so cleanup fails when node has pending ranges (CASSANDRA-16418)
 * Fix legacy clustering serialization for paging with compact storage (CASSANDRA-17507)
 * Add support for python 3.11 (CASSANDRA-18088)
 * Fix formatting of duration in cqlsh (CASSANDRA-18141)
 * Fix sstable loading of keyspaces named snapshots or backups (CASSANDRA-14013)
 * Avoid ConcurrentModificationException in STCS/DTCS/TWCS.getSSTables (CASSANDRA-17977)
 * Restore internode custom tracing on 4.0's new messaging system (CASSANDRA-17981)
Merged from 3.11:
Merged from 3.0:
 * Fix the ordering of sstables when running sstableupgrade tool (CASSANDRA-18143)
 * Fix default file system error handler for disk_failure_policy die (CASSANDRA-18294)
 * Introduce check for names of test classes (CASSANDRA-17964)
 * Suppress CVE-2022-41915 (CASSANDRA-18147)
 * Suppress CVE-2021-1471, CVE-2021-3064, CVE-2021-4235 (CASSANDRA-18149)
 * Switch to snakeyaml's SafeConstructor (CASSANDRA-18150)
 * Expand build.dir property in rat targets (CASSANDRA-18183)
 * Suppress CVE-2022-41881 (CASSANDRA-18148)
 * Default role is created with zero timestamp (CASSANDRA-12525)
 * Suppress CVE-2021-37533 (CASSANDRA-18146)
 * Add to the IntelliJ Git Window issue navigation links to Cassandra's Jira (CASSANDRA-18126)
 * Avoid anticompaction mixing data from two different time windows with TWCS (CASSANDRA-17970)
 * Do not spam the logs with MigrationCoordinator not being able to pull schemas (CASSANDRA-18096)


4.1.0
 * Fix ContentionStrategy backoff and Clock.waitUntil (CASSANDRA-18086)
Merged from 4.0:
Merged from 3.11:
Merged from 3.0:
 * Fix incorrect resource name in LIST PERMISSION output (CASSANDRA-17848)
 * Suppress CVE-2022-41854 and similar (CASSANDRA-18083)


4.1-rc1
 * Avoid schema mismatch problems on memtable API misconfiguration (CASSANDRA-18040)
 * Start Paxos auto repair in CassandraDaemon (CASSANDRA-18029)
 * Restore streaming_keep_alive_period on the netty control streaming channel (CASSANDRA-17768)
 * Move Schema.FORCE_LOAD_KEYSPACES and Schema.FORCE_LOAD_KEYSPACES_PROP to CassandraRelevantProps (CASSANDRA-17783)
 * Add --resolve-ip option to nodetool gossipinfo (CASSANDRA-17934)
 * Allow pre-V5 global limit on bytes in flight to revert to zero asynchronously in RateLimitingTest (CASSANDRA-17927)
Merged from 4.0:
 * Backport CASSANDRA-17205 to 4.0 branch - Remove self-reference in SSTableTidier (CASSANDRA-18332)
 * Avoid loading the preferred IP for BulkLoader streaming (CASSANDRA-18370)
 * Harden parsing of boolean values in CQL in PropertyDefinitions (CASSANDRA-17878)
 * Fix error message about type hints (CASSANDRA-17915)
 * Fix possible race condition on repair snapshots (CASSANDRA-17955)
 * Fix ASM bytecode version inconsistency (CASSANDRA-17873)
 * Remove empty cq4 files in log directory to not fail the startup of BinLog (CASSANDRA-17933)
 * Fix multiple BufferPool bugs (CASSANDRA-16681)
 * Fix StorageService.getNativeaddress handling of IPv6 addresses (CASSANDRA-17945)
Merged from 3.11:
 * Fix Splitter sometimes creating more splits than requested (CASSANDRA-18013)
 * Suppress CVE-2022-42003 and CVE-2022-42004 (CASSANDRA-17966)
 * Make LongBufferPoolTest insensitive to timing (CASSANDRA-16681)
Merged from 3.0:
 * Fix running Ant rat targets without git (CASSANDRA-17974)
 * Harden JMX by resolving beanshooter issues (CASSANDRA-17921)
 * Suppress CVE-2019-2684 (CASSANDRA-17965)
 * Fix auto-completing "WITH" when creating a materialized view (CASSANDRA-17879)


4.1-beta1
 * We should not emit deprecation warning on startup for `key_cache_save_period`, `row_cache_save_period`, `counter_cache_save_period` (CASSANDRA-17904)
 * upsert with adder support is not consistent with numbers and strings in LWT (CASSANDRA-17857)
 * Fix race and return after failing connections (CASSANDRA-17618)
 * Speculative execution threshold unit mismatch (CASSANDRA-17877)
 * Fix BulkLoader to load entireSSTableThrottle and entireSSTableInterDcThrottle (CASSANDRA-17677)
 * Fix a race condition where a keyspace can be oopened while it is being removed (CASSANDRA-17658)
 * DatabaseDescriptor will set the default failure detector during client initialization (CASSANDRA-17782)
 * Avoid initializing schema via SystemKeyspace.getPreferredIP() with the BulkLoader tool (CASSANDRA-17740)
 * Improve JMX methods signatures, fix JMX and config backward compatibility (CASSANDRA-17725)
 * Fix sstable_preemptive_open_interval disabled value. sstable_preemptive_open_interval = null backward compatible with
   sstable_preemptive_open_interval_in_mb = -1 (CASSANDRA-17737)
 * Remove usages of Path#toFile() in the snapshot apparatus (CASSANDRA-17769)
 * Fix Settings Virtual Table to update paxos_variant after startup and rename enable_uuid_sstable_identifiers to
   uuid_sstable_identifiers_enabled as per our config naming conventions (CASSANDRA-17738)
 * index_summary_resize_interval_in_minutes = -1 is equivalent to index_summary_resize_interval being set to null or
   disabled. JMX MBean IndexSummaryManager, setResizeIntervalInMinutes method still takes resizeIntervalInMinutes = -1 for disabled (CASSANDRA-17735)
 * min_tracked_partition_size_bytes parameter from 4.1 alpha1 was renamed to min_tracked_partition_size (CASSANDRA-17733)
 * Remove commons-lang dependency during build runtime (CASSANDRA-17724)
 * Relax synchronization on StreamSession#onError() to avoid deadlock (CASSANDRA-17706)
 * Fix AbstractCell#toString throws MarshalException for cell in collection (CASSANDRA-17695)
 * Add new vtable output option to compactionstats (CASSANDRA-17683)
 * Fix commitLogUpperBound initialization in AbstractMemtableWithCommitlog (CASSANDRA-17587)
 * Fix widening to long in getBatchSizeFailThreshold (CASSANDRA-17650)
 * Fix widening from mebibytes to bytes in IntMebibytesBound (CASSANDRA-17716)
 * Revert breaking change in nodetool clientstats and expose cient options through nodetool clientstats --client-options. (CASSANDRA-17715)
 * Fix missed nowInSec values in QueryProcessor (CASSANDRA-17458)
 * Revert removal of withBufferSizeInMB(int size) in CQLSSTableWriter.Builder class and deprecate it in favor of withBufferSizeInMiB(int size) (CASSANDRA-17675)
 * Remove expired snapshots of dropped tables after restart (CASSANDRA-17619)
Merged from 4.0:
 * Mitigate direct buffer memory OOM on replacements (CASSANDRA-17895)
 * Fix repair failure on assertion if two peers have overlapping mismatching ranges (CASSANDRA-17900)
 * Better handle null state in Gossip schema migration to avoid NPE (CASSANDRA-17864)
 * HintedHandoffAddRemoveNodesTest now accounts for the fact that StorageMetrics.totalHints is not updated synchronously w/ writes (CASSANDRA-16679)
 * Avoid getting hanging repairs due to repair message timeouts (CASSANDRA-17613)
 * Prevent infinite loop in repair coordinator on FailSession (CASSANDRA-17834)
 * Fix race condition on updating cdc size and advancing to next segment (CASSANDRA-17792)
 * Add 'noboolean' rpm build for older distros like CentOS7 (CASSANDRA-17765)
 * Fix default value for compaction_throughput_mb_per_sec in Config class to match  the one in cassandra.yaml (CASSANDRA-17790)
 * Fix Setting Virtual Table - update after startup config properties gc_log_threshold_in_ms, gc_warn_threshold_in_ms,
   conf.index_summary_capacity_in_mb, prepared_statements_cache_size_mb, key_cache_size_in_mb, counter_cache_size_in_mb
   (CASSANDRA-17737)
 * Fix Settings Virtual Table - index_summary_resize_interval and index_summary_capacity were not updated after startup (CASSANDRA-17735)
 * Clean up ScheduledExecutors, CommitLog, and MessagingService shutdown for in-JVM dtests (CASSANDRA-17731)
 * Remove extra write to system table for prepared statements (CASSANDRA-17764)
 * SSL storage port in sstableloader is deprecated (CASSANDRA-17602)
 * Fix counter write timeouts at ONE (CASSANDRA-17411)
 * Fix NPE in getLocalPrimaryRangeForEndpoint (CASSANDRA-17680)
 * Allow Java 11 to satisfy RPM/Debian packaging (CASSANDRA-17669)
 * Ensure FileStreamTask cannot compromise shared channel proxy for system table when interrupted (CASSANDRA-17663)
 * silence benign SslClosedEngineException (CASSANDRA-17565)
Merged from 3.11:
 * Fix potential IndexOutOfBoundsException in PagingState in mixed mode clusters (CASSANDRA-17840)
 * Document usage of closed token intervals in manual compaction (CASSANDRA-17575)
 * Creating of a keyspace on insufficient number of replicas should filter out gosspping-only members (CASSANDRA-17759)
 * Suppress CVE-2022-25857 and other snakeyaml CVEs (CASSANDRA-17907)
Merged from 3.0:
 * Improve libjemalloc resolution in bin/cassandra (CASSANDRA-15767)
 * Fix restarting of services on gossipping-only member (CASSANDRA-17752)
 * Fix scrubber falling into infinite loop when the last partition is broken (CASSANDRA-17862)
 * Fix resetting schema (CASSANDRA-17819)


4.1-alpha1
 * Handle config parameters upper bound on startup; Fix auto_snapshot_ttl and paxos_purge_grace_period min unit validations (CASSANDRA-17571)
 * Fix leak of non-standard Java types in our Exceptions as clients using JMX are unable to handle them.
   Remove useless validation that leads to unnecessary additional read of cassandra.yaml on startup (CASSANDRA-17638)
 * Fix repair_request_timeout_in_ms and remove paxos_auto_repair_threshold_mb (CASSANDRA-17557)
 * Incremental repair leaks SomeRepairFailedException after switch away from flatMap (CASSANDRA-17620)
 * StorageService read threshold get methods throw NullPointerException due to not handling null configs (CASSANDRA-17593)
 * Rename truncate_drop guardrail to drop_truncate_table (CASSANDRA-17592)
 * nodetool enablefullquerylog can NPE when directory has no files (CASSANDRA-17595)
 * Add auto_snapshot_ttl configuration (CASSANDRA-16790)
 * List snapshots of dropped tables (CASSANDRA-16843)
 * Add information whether sstables are dropped to SchemaChangeListener (CASSANDRA-17582)
 * Add a pluggable memtable API (CEP-11 / CASSANDRA-17034)
 * Save sstable id as string in activity table (CASSANDRA-17585)
 * Implement startup check to prevent Cassandra to potentially spread zombie data (CASSANDRA-17180)
 * Allow failing startup on duplicate config keys (CASSANDRA-17379)
 * Migrate threshold for minimum keyspace replication factor to guardrails (CASSANDRA-17212)
 * Add guardrail to disallow TRUNCATE and DROP TABLE commands (CASSANDRA-17558)
 * Add plugin support for CQLSH (CASSANDRA-16456)
 * Add guardrail to disallow querying with ALLOW FILTERING (CASSANDRA-17370)
 * Enhance SnakeYAML properties to be reusable outside of YAML parsing, support camel case conversion to snake case, and add support to ignore properties (CASSANDRA-17166)
 * nodetool compact should support using a key string to find the range to avoid operators having to manually do this (CASSANDRA-17537)
 * Add guardrail for data disk usage (CASSANDRA-17150)
 * Tool to list data paths of existing tables (CASSANDRA-17568)
 * Migrate track_warnings to more standard naming conventions and use latest configuration types rather than long (CASSANDRA-17560)
 * Add support for CONTAINS and CONTAINS KEY in conditional UPDATE and DELETE statement (CASSANDRA-10537)
 * Migrate advanced config parameters to the new Config types (CASSANDRA-17431)
 * Make null to be meaning disabled and leave 0 as a valid value for permissions_update_interval, roles_update_interval, credentials_update_interval (CASSANDRA-17431)
 * Fix typo in Config annotation (CASSANDRA-17431)
 * Made Converters type safe and fixed a few cases where converters used the wrong type (CASSANDRA-17431)
 * Fix null bug in DataStorageSpec and DurationSpec and require units to be added when providing 0 value (CASSANDRA-17431)
 * Shutdown ScheduledExecutors as part of node drainage (CASSANDRA-17493)
 * Provide JMX endpoint to allow transient logging of blocking read repairs (CASSANDRA-17471)
 * Add guardrail for GROUP BY queries (CASSANDRA-17509)
 * make pylib PEP and pylint compliant (CASSANDRA-17546)
 * Add support for vnodes in jvm-dtest (CASSANDRA-17332)
 * Remove guardrails global enable flag (CASSANDRA-17499)
 * Clients using JMX are unable to handle non-standard java types but we leak this into our interfaces (CASSANDRA-17527)
 * Remove stress server functionality (CASSANDRA-17535)
 * Reduce histogram snapshot long[] allocation overhead during speculative read and write threshold updates (CASSANDRA-17523)
 * Add guardrail for creation of secondary indexes (CASSANDRA-17498)
 * Add guardrail to disallow creation of uncompressed tables (CASSANDRA-17504)
 * Add guardrail to disallow creation of new COMPACT STORAGE tables (CASSANDRA-17522)
 * repair vtables should expose a completed field due to lack of filtering options in CQL (CASSANDRA-17520)
 * remove outdated code from cqlsh (CASSANDRA-17490)
 * remove support for deprecated version specific TLS in Python 3.6 (CASSANDRA-17365)
 * Add support for IF EXISTS and IF NOT EXISTS in ALTER statements (CASSANDRA-16916)
 * resolve several pylint issues in cqlsh.py and pylib (CASSANDRA-17480)
 * Streaming sessions longer than 3 minutes fail with timeout (CASSANDRA-17510)
 * Add ability to track state in repair (CASSANDRA-15399)
 * Remove unused 'parse' module (CASSANDRA-17484)
 * change six functions in cqlshlib to native Python 3 (CASSANDRA-17417)
 * reduce hot-path object allocations required to record local/remote requests against the client request metrics (CASSANDRA-17424)
 * Disallow removing DC from system_auth while nodes are active in the DC (CASSANDRA-17478)
 * Add guardrail for the number of fields per UDT (CASSANDRA-17385)
 * Allow users to change cqlsh history location using env variable (CASSANDRA-17448)
 * Add required -f option to use nodetool verify and standalone sstableverify (CASSANDRA-17017)
 * Add support for UUID based sstable generation identifiers (CASSANDRA-17048)
 * Log largest memtable flush at info instead of debug (CASSANDRA-17472)
 * Add native transport rate limiter options to example cassandra.yaml, and expose metric for dispatch rate (CASSANDRA-17423)
 * Add diagnostic events for guardrails (CASSANDRA-17197)
 * Pre hashed passwords in CQL (CASSANDRA-17334)
 * Increase cqlsh version (CASSANDRA-17432)
 * Update SUPPORTED_UPGRADE_PATHS to include 3.0 and 3.x to 4.1 paths and remove obsolete tests (CASSANDRA-17362)
 * Support DELETE in CQLSSTableWriter (CASSANDRA-14797)
 * Failed inbound internode authentication failures generate ugly warning with stack trace (CASSANDRA-17068)
 * Expose gossip information in system_views.gossip_info virtual table (CASSANDRA-17002)
 * Add guardrails for collection items and size (CASSANDRA-17153)
 * Improve guardrails messages (CASSANDRA-17430)
 * Remove all usages of junit.framework and ban them via Checkstyle (CASSANDRA-17316)
 * Add guardrails for read/write consistency levels (CASSANDRA-17188)
 * Add guardrail for SELECT IN terms and their cartesian product (CASSANDRA-17187)
 * remove unused imports in cqlsh.py and cqlshlib (CASSANDRA-17413)
 * deprecate property windows_timer_interval (CASSANDRA-17404)
 * Expose streaming as a vtable (CASSANDRA-17390)
 * Expose all client options via system_views.clients and nodetool clientstats (CASSANDRA-16378)
 * Make startup checks configurable (CASSANDRA-17220)
 * Add guardrail for number of partition keys on IN queries (CASSANDRA-17186)
 * update Python test framework from nose to pytest (CASSANDRA-17293)
 * Fix improper CDC commit log segments deletion in non-blocking mode (CASSANDRA-17233)
 * Add support for string concatenations through the + operator (CASSANDRA-17190)
 * Limit the maximum hints size per host (CASSANDRA-17142)
 * Add a virtual table for exposing batch metrics (CASSANDRA-17225)
 * Flatten guardrails config (CASSANDRA-17353)
 * Instance failed to start up due to NPE in StartupClusterConnectivityChecker (CASSANDRA-17347)
 * add the shorter version of version flag (-v) in cqlsh (CASSANDRA-17236)
 * Make vtables accessible via internode messaging (CASSANDRA-17295)
 * Add support for PEM based key material for SSL (CASSANDRA-17031)
 * Standardize storage configuration parameters' names. Support unit suffixes. (CASSANDRA-15234)
 * Remove support for Windows (CASSANDRA-16956)
 * Runtime-configurable YAML option to prohibit USE statements (CASSANDRA-17318)
 * When streaming sees a ClosedChannelException this triggers the disk failure policy (CASSANDRA-17116)
 * Add a virtual table for exposing prepared statements metrics (CASSANDRA-17224)
 * Remove python 2.x support from cqlsh (CASSANDRA-17242)
 * Prewarm role and credential caches to avoid timeouts at startup (CASSANDRA-16958)
 * Make capacity/validity/updateinterval/activeupdate for Auth Caches configurable via nodetool (CASSANDRA-17063)
 * Added startup check for read_ahead_kb setting (CASSANDRA-16436)
 * Avoid unecessary array allocations and initializations when performing query checks (CASSANDRA-17209)
 * Add guardrail for list operations that require read before write (CASSANDRA-17154)
 * Migrate thresholds for number of keyspaces and tables to guardrails (CASSANDRA-17195)
 * Remove self-reference in SSTableTidier (CASSANDRA-17205)
 * Add guardrail for query page size (CASSANDRA-17189)
 * Allow column_index_size_in_kb to be configurable through nodetool (CASSANDRA-17121)
 * Emit a metric for number of local read and write calls
 * Add non-blocking mode for CDC writes (CASSANDRA-17001)
 * Add guardrails framework (CASSANDRA-17147)
 * Harden resource management on SSTable components to prevent future leaks (CASSANDRA-17174)
 * Make nodes more resilient to local unrelated files during startup (CASSANDRA-17082)
 * repair prepare message would produce a wrong error message if network timeout happened rather than reply wait timeout (CASSANDRA-16992)
 * Log queries that fail on timeout or unavailable errors up to once per minute by default (CASSANDRA-17159)
 * Refactor normal/preview/IR repair to standardize repair cleanup and error handling of failed RepairJobs (CASSANDRA-17069)
 * Log missing peers in StartupClusterConnectivityChecker (CASSANDRA-17130)
 * Introduce separate rate limiting settings for entire SSTable streaming (CASSANDRA-17065)
 * Implement Virtual Tables for Auth Caches (CASSANDRA-16914)
 * Actively update auth cache in the background (CASSANDRA-16957)
 * Add unix time conversion functions (CASSANDRA-17029)
 * JVMStabilityInspector.forceHeapSpaceOomMaybe should handle all non-heap OOMs rather than only supporting direct only (CASSANDRA-17128)
 * Forbid other Future implementations with checkstyle (CASSANDRA-17055)
 * commit log was switched from non-daemon to daemon threads, which causes the JVM to exit in some case as no non-daemon threads are active (CASSANDRA-17085)
 * Add a Denylist to block reads and writes on specific partition keys (CASSANDRA-12106)
 * v4+ protocol did not clean up client warnings, which caused leaking the state (CASSANDRA-17054)
 * Remove duplicate toCQLString in ReadCommand (CASSANDRA-17023)
 * Ensure hint window is persistent across restarts of a node (CASSANDRA-14309)
 * Allow to GRANT or REVOKE multiple permissions in a single statement (CASSANDRA-17030)
 * Allow to grant permission for all tables in a keyspace (CASSANDRA-17027)
 * Log time spent writing keys during compaction (CASSANDRA-17037)
 * Make nodetool compactionstats and sstable_tasks consistent (CASSANDRA-16976)
 * Add metrics and logging around index summary redistribution (CASSANDRA-17036)
 * Add configuration options for minimum allowable replication factor and default replication factor (CASSANDRA-14557)
 * Expose information about stored hints via a nodetool command and a virtual table (CASSANDRA-14795)
 * Add broadcast_rpc_address to system.local (CASSANDRA-11181)
 * Add support for type casting in WHERE clause components and in the values of INSERT/UPDATE statements (CASSANDRA-14337)
 * add credentials file support to CQLSH (CASSANDRA-16983)
 * Skip remaining bytes in the Envelope buffer when a ProtocolException is thrown to avoid double decoding (CASSANDRA-17026)
 * Allow reverse iteration of resources during permissions checking (CASSANDRA-17016)
 * Add feature to verify correct ownership of attached locations on disk at startup (CASSANDRA-16879)
 * Make SSLContext creation pluggable/extensible (CASSANDRA-16666)
 * Add soft/hard limits to local reads to protect against reading too much data in a single query (CASSANDRA-16896)
 * Avoid token cache invalidation for removing a non-member node (CASSANDRA-15290)
 * Allow configuration of consistency levels on auth operations (CASSANDRA-12988)
 * Add number of sstables in a compaction to compactionstats output (CASSANDRA-16844)
 * Upgrade Caffeine to 2.9.2 (CASSANDRA-15153)
 * Allow DELETE and TRUNCATE to work on Virtual Tables if the implementation allows it (CASSANDRA-16806)
 * Include SASI components to snapshots (CASSANDRA-15134)
 * Fix missed wait latencies in the output of `nodetool tpstats -F` (CASSANDRA-16938)
 * Reduce native transport max frame size to 16MB (CASSANDRA-16886)
 * Add support for filtering using IN restrictions (CASSANDRA-14344)
 * Provide a nodetool command to invalidate auth caches (CASSANDRA-16404)
 * Catch read repair timeout exceptions and add metric (CASSANDRA-16880)
 * Exclude Jackson 1.x transitive dependency of hadoop* provided dependencies (CASSANDRA-16854)
 * Add client warnings and abort to tombstone and coordinator reads which go past a low/high watermark (CASSANDRA-16850)
 * Add TTL support to nodetool snapshots (CASSANDRA-16789)
 * Allow CommitLogSegmentReader to optionally skip sync marker CRC checks (CASSANDRA-16842)
 * allow blocking IPs from updating metrics about traffic (CASSANDRA-16859)
 * Request-Based Native Transport Rate-Limiting (CASSANDRA-16663)
 * Implement nodetool getauditlog command (CASSANDRA-16725)
 * Clean up repair code (CASSANDRA-13720)
 * Background schedule to clean up orphaned hints files (CASSANDRA-16815)
 * Modify SecondaryIndexManager#indexPartition() to retrieve only columns for which indexes are actually being built (CASSANDRA-16776)
 * Batch the token metadata update to improve the speed (CASSANDRA-15291)
 * Reduce the log level on "expected" repair exceptions (CASSANDRA-16775)
 * Make JMXTimer expose attributes using consistent time unit (CASSANDRA-16760)
 * Remove check on gossip status from DynamicEndpointSnitch::updateScores (CASSANDRA-11671)
 * Fix AbstractReadQuery::toCQLString not returning valid CQL (CASSANDRA-16510)
 * Log when compacting many tombstones (CASSANDRA-16780)
 * Display bytes per level in tablestats for LCS tables (CASSANDRA-16799)
 * Add isolated flush timer to CommitLogMetrics and ensure writes correspond to single WaitingOnCommit data points (CASSANDRA-16701)
 * GossiperTest.testHasVersion3Nodes didn't take into account trunk version changes, fixed to rely on latest version (CASSANDRA-16651)
 * Update JNA library to 5.9.0 and snappy-java to version 1.1.8.4 (CASSANDRA-17040)
Merged from 4.0:
 * Utilise BTree improvements to reduce garbage and improve throughput (CASSANDRA-15511)
Merged from 3.11:
Merged from 3.0:
 * Fix writetime and ttl functions forbidden for collections instead of multicell columns (CASSANDRA-17628)
 * Fix issue where frozen maps may not be serialized in the correct order (CASSANDRA-17623)
 * Suppress CVE-2022-24823 (CASSANDRA-17633)
 * fsync TOC and digest files (CASSANDRA-10709)


4.0.4
 * Optimise BTree build,update and transform operations (CASSANDRA-15510)
 * Clean up schema migration coordinator and tests (CASSANDRA-17533)
 * Shut repair task executor down without interruption to avoid compromising shared channel proxies (CASSANDRA-17466)
 * Generate valid KEYSPACE / MATERIALIZED VIEW for CQL for views (CASSANDRA-17266)
 * Fix timestamp tz parsing (CASSANDRA-17467)
 * Suppress CVE-2021-44521 from driver (CASSANDRA-17459)
 * Upgrade jackson to 2.13.2 (CASSANDRA-17460)
 * Make sstableloader honour native port option (CASSANDRA-17210)
 * Reject snapshot names with special character (CASSANDRA-15297)
 * Fix ObjectSizes implementation and usages (CASSANDRA-17402)
 * Fix race condition bug during local session repair (CASSANDRA-17335)
 * Fix ignored streaming encryption settings in sstableloader (CASSANDRA-17367)
 * Streaming tasks handle empty SSTables correctly (CASSANDRA-16349)
 * Prevent SSTableLoader from doing unnecessary work (CASSANDRA-16349)
Merged from 3.11:
 * Upgrade jackson-databind to 2.13.2.2 (CASSANDRA-17556)
 * Upgrade slf4j to 1.7.25 (CASSANDRA-17474)
 * Upgrade jackson to 2.13.2 (CASSANDRA-17492)
 * emit warning on keyspace creation when replication factor is bigger than the number of nodes (CASSANDRA-16747)
 * Fix snapshot true size calculation (CASSANDRA-17267)
 * Validate existence of DCs when repairing (CASSANDRA-17407)
 * dropping of a materialized view creates a snapshot with dropped- prefix (CASSANDRA-17415)
Merged from 3.0:
 * fsync TOC and digest files (CASSANDRA-10709)
 * Fix URISyntaxException in nodetool with updated Java (CASSANDRA-17581)
 * Schema mutations may not be completed on drain (CASSANDRA-17524)
 * Fix data corruption in AbstractCompositeType due to static boolean byte buffers (CASSANDRA-14752)
 * Add procps dependency to RPM/Debian packages (CASSANDRA-17516)
 * Suppress CVE-2021-44521 (CASSANDRA-17492)
 * ConnectionLimitHandler may leaks connection count if remote connection drops (CASSANDRA-17252)
 * Require ant >= 1.10 (CASSANDRA-17428)
 * Disallow CONTAINS for UPDATE and DELETE (CASSANDRA-15266)
 * Suppress inapplicable CVEs (CASSANDRA-17368)
 * Fix flaky test - test_cqlsh_completion.TestCqlshCompletion (CASSANDRA-17338)
 * Fixed TestCqlshOutput failing tests (CASSANDRA-17386)
 * Lazy transaction log replica creation allows incorrect replica content divergence during anticompaction (CASSANDRA-17273)
 * LeveledCompactionStrategy disk space check improvements (CASSANDRA-17272)


4.0.3
 * Deprecate otc_coalescing_strategy, otc_coalescing_window_us, otc_coalescing_enough_coalesced_messages,
   otc_backlog_expiration_interval_ms (CASSANDRA-17377)
 * Improve start up processing of Incremental Repair information read from system.repairs (CASSANDRA-17342)
 * Extend operator control over the UDF threading model for CVE-2021-44521 (CASSANDRA-17352)
 * Full Java 11 support (CASSANDRA-16894)
 * Remove unused 'geomet' package from cqlsh path (CASSANDRA-17271)
 * Removed unused 'cql' dependency (CASSANDRA-17247)
 * Don't block gossip when clearing repair snapshots (CASSANDRA-17168)
 * Deduplicate warnings for deprecated parameters (changed names) (CASSANDRA-17160)
 * Update ant-junit to version 1.10.12 (CASSANDRA-17218)
 * Add droppable tombstone metrics to nodetool tablestats (CASSANDRA-16308)
 * Fix disk failure triggered when enabling FQL on an unclean directory (CASSANDRA-17136)
 * Fixed broken classpath when multiple jars in build directory (CASSANDRA-17129)
 * DebuggableThreadPoolExecutor does not propagate client warnings (CASSANDRA-17072)
 * internode_send_buff_size_in_bytes and internode_recv_buff_size_in_bytes have new names. Backward compatibility with the old names added (CASSANDRA-17141)
 * Remove unused configuration parameters from cassandra.yaml (CASSANDRA-17132)
 * Queries performed with NODE_LOCAL consistency level do not update request metrics (CASSANDRA-17052)
 * Fix multiple full sources can be select unexpectedly for bootstrap streaming (CASSANDRA-16945)
 * Fix cassandra.yaml formatting of parameters (CASSANDRA-17131)
 * Add backward compatibility for CQLSSTableWriter Date fields (CASSANDRA-17117)
 * Push initial client connection messages to trace (CASSANDRA-17038)
 * Correct the internode message timestamp if sending node has wrapped (CASSANDRA-16997)
 * Avoid race causing us to return null in RangesAtEndpoint (CASSANDRA-16965)
 * Avoid rewriting all sstables during cleanup when transient replication is enabled (CASSANDRA-16966)
 * Prevent CQLSH from failure on Python 3.10 (CASSANDRA-16987)
 * Avoid trying to acquire 0 permits from the rate limiter when taking snapshot (CASSANDRA-16872)
 * Remove all the state pollution between tests in SSTableReaderTest (CASSANDRA-16888)
 * Delay auth setup until after gossip has settled to avoid unavailables on startup (CASSANDRA-16783)
 * org.apache.cassandra.db.rows.ArrayCell#unsharedHeapSizeExcludingData includes data twice (CASSANDRA-16900)
 * Fix clustering order logic in CREATE MATERIALIZED VIEW (CASSANDRA-16898)
 * Exclude Jackson 1.x transitive dependency of hadoop* provided dependencies (CASSANDRA-16854)
 * Tolerate missing DNS entry when completing a host replacement (CASSANDRA-16873)
 * Harden PrunableArrayQueue against Pruner implementations that might throw exceptions (CASSANDRA-16866)
 * Move RepairedDataInfo to the execution controller rather than the ReadCommand to avoid unintended sharing (CASSANDRA-16721)
 * Bump zstd-jni version to 1.5.0-4 (CASSANDRA-16884)
 * Remove assumption that all urgent messages are small (CASSANDRA-16877)
 * ArrayClustering.unsharedHeapSize does not include the data so undercounts the heap size (CASSANDRA-16845)
 * Improve help, doc and error messages about sstabledump -k and -x arguments (CASSANDRA-16818)
 * Add repaired/unrepaired bytes back to nodetool (CASSANDRA-15282)
 * Upgrade lz4-java to 1.8.0 to add RH6 support back (CASSANDRA-16753)
 * Improve DiagnosticEventService.publish(event) logging message of events (CASSANDRA-16749)
 * Cleanup dependency scopes (CASSANDRA-16704)
 * Make JmxHistogram#getRecentValues() and JmxTimer#getRecentValues() thread-safe (CASSANDRA-16707)
Merged from 3.11:
 * Upgrade jackson-databind to 2.13.2.2 (CASSANDRA-17556)
 * Upgrade slf4j to 1.7.25 (CASSANDRA-17474)
 * Upgrade jackson to 2.13.2 (CASSANDRA-17492)
 * emit warning on keyspace creation when replication factor is bigger than the number of nodes (CASSANDRA-16747)
 * Fix snapshot true size calculation (CASSANDRA-17267)
 * dropping of a materialized view creates a snapshot with dropped- prefix (CASSANDRA-17415)
 * Validate existence of DCs when repairing (CASSANDRA-17407)
 * Add key validation to ssstablescrub (CASSANDRA-16969)
 * Update Jackson from 2.9.10 to 2.12.5 (CASSANDRA-16851)
 * Make assassinate more resilient to missing tokens (CASSANDRA-16847)
 * Validate SASI tokenizer options before adding index to schema (CASSANDRA-15135)
 * Fixup scrub output when no data post-scrub and clear up old use of row, which really means partition (CASSANDRA-16835)
 * Reduce thread contention in CommitLogSegment and HintsBuffer (CASSANDRA-16072)
 * Make cqlsh use the same set of reserved keywords than the server uses (CASSANDRA-15663)
 * Optimize bytes skipping when reading SSTable files (CASSANDRA-14415)
 * Enable tombstone compactions when unchecked_tombstone_compaction is set in TWCS (CASSANDRA-14496)
 * Read only the required SSTables for single partition queries (CASSANDRA-16737)
Merged from 3.0:
 * Schema mutations may not be completed on drain (CASSANDRA-17524)
 * Fix data corruption in AbstractCompositeType due to static boolean byte buffers (CASSANDRA-14752)
 * Add procps dependency to RPM/Debian packages (CASSANDRA-17516)
 * Suppress CVE-2021-44521 (CASSANDRA-17492)
 * ConnectionLimitHandler may leaks connection count if remote connection drops (CASSANDRA-17252)
 * Require ant >= 1.10 (CASSANDRA-17428)
 * Disallow CONTAINS for UPDATE and DELETE (CASSANDRA-15266)
 * Suppress inapplicable CVEs (CASSANDRA-17368)
 * Fix flaky test - test_cqlsh_completion.TestCqlshCompletion (CASSANDRA-17338)
 * Fixed TestCqlshOutput failing tests (CASSANDRA-17386)
 * Lazy transaction log replica creation allows incorrect replica content divergence during anticompaction (CASSANDRA-17273)
 * LeveledCompactionStrategy disk space check improvements (CASSANDRA-17272)
 * Fix conversion from megabits to bytes in streaming rate limiter (CASSANDRA-17243)
 * Upgrade logback to 1.2.9 (CASSANDRA-17204)
 * Avoid race in AbstractReplicationStrategy endpoint caching (CASSANDRA-16673)
 * Fix abort when window resizing during cqlsh COPY (CASSANDRA-15230)
 * Fix slow keycache load which blocks startup for tables with many sstables (CASSANDRA-14898)
 * Fix rare NPE caused by batchlog replay / node decomission races (CASSANDRA-17049)
 * Allow users to view permissions of the roles they created (CASSANDRA-16902)
 * Fix failure handling in inter-node communication (CASSANDRA-16334)
 * Log more information when a node runs out of commitlog space (CASSANDRA-11323)
 * Don't take snapshots when truncating system tables (CASSANDRA-16839)
 * Make -Dtest.methods consistently optional in all Ant test targets (CASSANDRA-17014)
 * Immediately apply stream throughput, considering negative values as unthrottled (CASSANDRA-16959)
 * Do not release new SSTables in offline transactions (CASSANDRA-16975)
 * ArrayIndexOutOfBoundsException in FunctionResource#fromName (CASSANDRA-16977, CASSANDRA-16995)
 * CVE-2015-0886 Security vulnerability in jbcrypt is addressed (CASSANDRA-9384)
 * Avoid useless SSTable reads during single partition queries (CASSANDRA-16944)
 * Debian init respects CASSANDRA_HEAPDUMP_DIR (CASSANDRA-13843)
 * Catch UnsatisfiedLinkError in WindowsTimer (CASSANDRA-16085)
 * Avoid removing batch when it's not created during view replication (CASSANDRA-16175)
 * Make the addition of regular column to COMPACT tables throw an InvalidRequestException (CASSANDRA-14564)
 * Make the addition of regular column to COMPACT tables throw an InvalidRequestException (CASSANDRA-14564)
 * Fix secondary indexes on primary key columns skipping some writes (CASSANDRA-16868)
 * Use JMX to validate nodetool --jobs parameter (CASSANDRA-16104)
 * Handle properly UnsatisfiedLinkError in NativeLibrary#getProcessID() (CASSANDRA-16578)
 * Remove mutation data from error log message (CASSANDRA-16817)
 * Binary releases no longer bundle the apidocs (javadoc) (CASSANDRA-16557)
 * Migrate dependency handling from maven-ant-tasks to resolver-ant-tasks, removing lib/ directory from version control (CASSANDRA-16557)
 * Don't allow seeds to replace without using unsafe (CASSANDRA-14463)
 * Calculate time remaining correctly for all compaction types in compactionstats (CASSANDRA-14701)
 * Receipt of gossip shutdown notification updates TokenMetadata (CASSANDRA-16796)
 * Count bloom filter misses correctly (CASSANDRA-12922)
 * Reject token() in MV WHERE clause (CASSANDRA-13464)
 * Ensure java executable is on the path (CASSANDRA-14325)
 * Clean transaction log leftovers at the beginning of sstablelevelreset and sstableofflinerelevel (CASSANDRA-12519)


4.0.0
 * Avoid signaling DigestResolver until the minimum number of responses are guaranteed to be visible (CASSANDRA-16807)
 * Fix pre-4.0 FWD_FRM parameter serializer (CASSANDRA-16808)
 * Fix fwd to/from headers in DC write forwarding (CASSANDRA-16797)
 * Fix CassandraVersion::compareTo (CASSANDRA-16794)
 * BinLog does not close chronicle queue leaving this to GC to cleanup (CASSANDRA-16774)


4.0-rc2
 * Improved password obfuscation (CASSANDRA-16801)
 * Avoid memoizing the wrong min cluster version during upgrades (CASSANDRA-16759)
 * Obfuscate passwords in statements in QueryEvents (CASSANDRA-16669)
 * Fix queries on empty partitions with static data (CASSANDRA-16686)
 * Keep python driver in artifacts (CASSANDRA-16700)
 * Improve AuditLogging documentation and logback.xml(CASSANDRA-16682)
 * Spin up SEPWorker threads whenever we grow the number of work permits(CASSANDRA-16668)
 * Add a warning to cqlsh 6.0.0 that DESCRIBE does not work with a Cassandra 3.x servers (CASSANDRA-16652)
 * cqlsh: fix DESC TYPE with non-ascii character in the identifier (CASSANDRA-16400)
 * Remove drivers dependency and bring cql_keywords_reserved on server side (CASSANDRA-16659)
 * Fix in-browser "help", Python 3 (CASSANDRA-16658)
 * Fix DROP COMPACT STORAGE for counters (CASSANDRA-16653)
 * Add back validation for AlterTableStatements (CASSANDRA-16643)
 * Fix cqlsh encoding error with unicode in multi-line statement (CASSANDRA-16539)
 * Fix race in fat client removal (CASSANDRA-16238)
 * Test org.apache.cassandra.net.AsyncPromiseTest FAILED (CASSANDRA-16596)
Merged from 3.11:
 * Fix LeveledCompactionStrategy compacts last level throw an ArrayIndexOutOfBoundsException (CASSANDRA-15669)
 * Maps $CASSANDRA_LOG_DIR to cassandra.logdir java property when executing nodetool (CASSANDRA-16199)
 * Nodetool garbagecollect should retain SSTableLevel for LCS (CASSANDRA-16634)
 * Ignore stale acks received in the shadow round (CASSANDRA-16588)
Merged from 3.0:
 * Handle correctly the exceptions thrown by custom QueryHandler constructors (CASSANDRA-16703)
 * Adding columns via ALTER TABLE can generate corrupt sstables (CASSANDRA-16735)
 * Add flag to disable ALTER...DROP COMPACT STORAGE statements (CASSANDRA-16733)
 * CQL shell should prefer newer TLS version by default (CASSANDRA-16695)
 * Ensure that existing empty rows are properly returned (CASSANDRA-16671)
 * Failure to execute queries should emit a KPI other than read timeout/unavailable so it can be alerted/tracked (CASSANDRA-16581)
 * Don't wait on schema versions from replacement target when replacing a node (CASSANDRA-16692)
 * StandaloneVerifier does not fail when unable to verify SSTables, it only fails if Corruption is thrown (CASSANDRA-16683)
 * Fix bloom filter false ratio calculation by including true negatives (CASSANDRA-15834)
 * Prevent loss of commit log data when moving sstables between nodes (CASSANDRA-16619)
 * Fix materialized view builders inserting truncated data (CASSANDRA-16567)


4.0-rc1
 * Allow for setting buffer max capacity to increase it dynamically as needed (CASSANDRA-16524)
 * Harden internode message resource limit accounting against serialization failures (CASSANDRA-16616)
 * Add back the source release of python driver in tree to avoid fetching from GitHub APIs (CASSANDRA-16599)
 * Fix false unavailable for queries due to cluster topology changes (CASSANDRA-16545)
 * Fixed a race condition issue in nodetool repair where we poll for the error before seeing the error notification, leading to a less meaningful message (CASSANDRA-16585)
 * Fix mixed cluster GROUP BY queries (CASSANDRA-16582)
 * Upgrade jflex to 1.8.2 (CASSANDRA-16576)
 * Binary releases no longer bundle the apidocs (javadoc) (CASSANDRA-15561)
 * Fix Streaming Repair metrics (CASSANDRA-16190)
 * Scheduled (delayed) schema pull tasks should not run after MIGRATION stage shutdown during decommission (CASSANDRA-16495)
 * When behind a firewall trunk is not buildable, need to allow overriding URLs (CASSANDRA-16563)
 * Make sure sstables with moved starts are removed correctly in LeveledGenerations (CASSANDRA-16552)
 * Fix race between secondary index building and active compactions tracking (CASSANDRA-16554)
 * Migrate dependency handling from maven-ant-tasks to resolver-ant-tasks, removing lib/ directory from version control (CASSANDRA-16391)
 * Fix 4.0 node sending a repair prepare message to a 3.x node breaking the connection (CASSANDRA-16542)
 * Removed synchronized modifier from StreamSession#onChannelClose to prevent deadlocking on flush (CASSANDRA-15892)
 * Throw IOE in AbstractType.writeValue if value has wrong fixed length (CASSANDRA-16500)
 * Execute background refreshing of auth caches on a dedicated executor (CASSANDRA-15177)
 * Update bundled java and python drivers to 3.11.0 and 3.25.0 respectively (CASSANDRA-13951)
 * Add io.netty.tryReflectionSetAccessible=true to j11 server options in order to enable netty to use Unsafe direct byte buffer construction (CASSANDRA-16493)
 * Make cassandra-stress -node support host:port notation (CASSANDRA-16529)
 * Better handle legacy gossip application states during (and after) upgrades (CASSANDRA-16525)
 * Mark StreamingMetrics.ActiveOutboundStreams as deprecated (CASSANDRA-11174)
 * Increase the cqlsh version number (CASSANDRA-16509)
 * Fix the CQL generated for the views.where_clause column when some identifiers require quoting (CASSANDRA-16479)
 * Send FAILED_SESSION_MSG on shutdown and on in-progress repairs during startup (CASSANDRA-16425)
 * Reinstate removed ApplicationState padding (CASSANDRA-16484)
 * Expose data dirs to ColumnFamilyStoreMBean (CASSANDRA-16335)
 * Add possibility to copy SSTables in SSTableImporter instead of moving them (CASSANDRA-16407)
 * Fix DESCRIBE statement for CUSTOM indices with options (CASSANDRA-16482)
 * Fix cassandra-stress JMX connection (CASSANDRA-16473)
 * Avoid processing redundant application states on endpoint changes (CASSANDRA-16381)
 * Prevent parent repair sessions leak (CASSANDRA-16446)
 * Fix timestamp issue in SinglePartitionSliceCommandTest testPartitionD…eletionRowDeletionTie (CASSANDRA-16443)
 * Promote protocol V5 out of beta (CASSANDRA-14973)
 * Fix incorrect encoding for strings can be UTF8 (CASSANDRA-16429)
 * Fix node unable to join when RF > N in multi-DC with added warning (CASSANDRA-16296)
 * Add an option to nodetool tablestats to check sstable location correctness (CASSANDRA-16344)
 * Unable to ALTER KEYSPACE while decommissioned/assassinated nodes are in gossip (CASSANDRA-16422)
 * Metrics backward compatibility restored after CASSANDRA-15066 (CASSANDRA-16083)
 * Reduce new reserved keywords introduced since 3.0 (CASSANDRA-16439)
 * Improve system tables handling in case of disk failures (CASSANDRA-14793)
 * Add access and datacenters to unreserved keywords (CASSANDRA-16398)
 * Fix nodetool ring, status output when DNS resolution or port printing are in use (CASSANDRA-16283)
 * Upgrade Jacoco to 0.8.6 (for Java 11 support) (CASSANDRA-16365)
 * Move excessive repair debug loggings to trace level (CASSANDRA-16406)
 * Restore validation of each message's protocol version (CASSANDRA-16374)
 * Upgrade netty and chronicle-queue dependencies to get Auditing and native library loading working on arm64 architectures (CASSANDRA-16384,CASSANDRA-16392)
 * Release StreamingTombstoneHistogramBuilder spool when switching writers (CASSANDRA-14834)
 * Correct memtable on-heap size calculations to match actual use (CASSANDRA-16318)
 * Fix client notifications in CQL protocol v5 (CASSANDRA-16353)
 * Too defensive check when picking sstables for preview repair (CASSANDRA-16284)
 * Ensure pre-negotiation native protocol responses have correct stream id (CASSANDRA-16376)
 * Fix check for -Xlog in cassandra-env.sh (CASSANDRA-16279)
 * SSLFactory should initialize SSLContext before setting protocols (CASSANDRA-16362)
 * Restore sasi dependencies jflex, snowball-stemmer, and concurrent-trees, in the cassandra-all pom (CASSANDRA-16303)
 * Fix DecimalDeserializer#toString OOM (CASSANDRA-14925)
Merged from 3.11:
 * Add autocomplete and error messages for provide_overlapping_tombstones (CASSANDRA-16350)
 * Upgrade jackson-databind to 2.9.10.8 (CASSANDRA-16462)
 * Fix digest computation for queries with fetched but non queried columns (CASSANDRA-15962)
 * Reduce amount of allocations during batch statement execution (CASSANDRA-16201)
 * Update jflex-1.6.0.jar to match upstream (CASSANDRA-16393)
Merged from 3.0:
 * Don't wait for schema migrations from removed nodes (CASSANDRA-16577)
 * Ignore trailing zeros in hint files (CASSANDRA-16523)
 * Refuse DROP COMPACT STORAGE if some 2.x sstables are in use (CASSANDRA-15897)
 * Fix ColumnFilter::toString not returning a valid CQL fragment (CASSANDRA-16483)
 * Fix ColumnFilter behaviour to prevent digest mitmatches during upgrades (CASSANDRA-16415)
 * Update debian packaging for python3 (CASSANDRA-16396)
 * Avoid pushing schema mutations when setting up distributed system keyspaces locally (CASSANDRA-16387)
 * Prevent unbounded number of pending flushing tasks (CASSANDRA-16261)
 * Improve empty hint file handling during startup (CASSANDRA-16162)
 * Fix skipping on pre-3.0 created compact storage sstables due to missing primary key liveness (CASSANDRA-16226)
 * Allow empty string in collections with COPY FROM in cqlsh (CASSANDRA-16372)
Merged from 2.2:
 * Remove ant targets list-jvm-dtests and ant list-jvm-upgrade-dtests (CASSANDRA-16519)
 * Fix centos packaging for arm64, >=4.0 rpm's now require python3 (CASSANDRA-16477)
 * Make TokenMetadata's ring version increments atomic (CASSANDRA-16286)


4.0-beta4
 * DROP COMPACT STORAGE should invalidate prepared statements still using CompactTableMetadata (CASSANDRA-16361)
 * Update default num_tokens to 16 and allocate_tokens_for_local_replication_factor to 3 (CASSANDRA-13701)
 * Remove use of String.intern() (CASSANDRA-15810)
 * Fix the missing bb position in ByteBufferAccessor.getUnsignedShort (CASSANDRA-16249)
 * Make sure OOM errors are rethrown on truncation failure (CASSANDRA-16254)
 * Send back client warnings when creating too many tables/keyspaces (CASSANDRA-16309)
 * Add dedicated tcp user timeout for streaming connection (CASSANDRA-16143)
 * Add generatetokens script for offline token allocation strategy generation (CASSANDRA-16205)
 * Remove Windows scripts (CASSANDRA-16171)
 * Improve checksumming and compression in protocol V5 (CASSANDRA-15299)
 * Optimised repair streaming improvements (CASSANDRA-16274)
 * Update jctools dependency to 3.1.0 (CASSANDRA-16255)
 * 'SSLEngine closed already' exception on failed outbound connection (CASSANDRA-16277)
 * Drain and/or shutdown might throw because of slow messaging service shutdown (CASSANDRA-16276)
 * Upgrade JNA to 5.6.0, dropping support for <=glibc-2.6 systems (CASSANDRA-16212)
 * Add saved Host IDs to TokenMetadata at startup (CASSANDRA-16246)
 * Ensure that CacheMetrics.requests is picked up by the metric reporter (CASSANDRA-16228)
 * Add a ratelimiter to snapshot creation and deletion (CASSANDRA-13019)
 * Produce consistent tombstone for reads to avoid digest mistmatch (CASSANDRA-15369)
 * Fix SSTableloader issue when restoring a table named backups (CASSANDRA-16235)
 * Invalid serialized size for responses caused by increasing message time by 1ms which caused extra bytes in size calculation (CASSANDRA-16103)
 * Throw BufferOverflowException from DataOutputBuffer for better visibility (CASSANDRA-16214)
 * TLS connections to the storage port on a node without server encryption configured causes java.io.IOException accessing missing keystore (CASSANDRA-16144)
 * Internode messaging catches OOMs and does not rethrow (CASSANDRA-15214)
 * When a table attempts to clean up metrics, it was cleaning up all global table metrics (CASSANDRA-16095)
 * Bring back the accepted encryption protocols list as configurable option (CASSANDRA-13325)
 * DigestResolver.getData throws AssertionError since dataResponse is null (CASSANDRA-16097)
 * Cannot replace_address /X because it doesn't exist in gossip (CASSANDRA-16213)
 * cqlsh row_id resets on page boundaries (CASSANDRA-16160)
Merged from 3.11:
 * SASI's `max_compaction_flush_memory_in_mb` settings over 100GB revert to default of 1GB (CASSANDRA-16071)
Merged from 3.0:
 * Extend the exclusion of replica filtering protection to other indices instead of just SASI (CASSANDRA-16311)
 * Synchronize transaction logs for JBOD (CASSANDRA-16225)
 * Fix the counting of cells per partition (CASSANDRA-16259)
 * Fix serial read/non-applying CAS linearizability (CASSANDRA-12126)
 * Avoid potential NPE in JVMStabilityInspector (CASSANDRA-16294)
 * Improved check of num_tokens against the length of initial_token (CASSANDRA-14477)
 * Fix a race condition on ColumnFamilyStore and TableMetrics (CASSANDRA-16228)
 * Remove the SEPExecutor blocking behavior (CASSANDRA-16186)
 * Wait for schema agreement when bootstrapping (CASSANDRA-15158)
 * Prevent invoking enable/disable gossip when not in NORMAL (CASSANDRA-16146)
 * Raise Dynamic Snitch Default Badness Threshold to 1.0 (CASSANDRA-16285)
Merged from 2.2:
 * Fix the histogram merge of the table metrics (CASSANDRA-16259)


4.0-beta3
 * Segregate Network and Chunk Cache BufferPools and Recirculate Partially Freed Chunks (CASSANDRA-15229)
 * Fail truncation requests when they fail on a replica (CASSANDRA-16208)
 * Move compact storage validation earlier in startup process (CASSANDRA-16063)
 * Fix ByteBufferAccessor cast exceptions are thrown when trying to query a virtual table (CASSANDRA-16155)
 * Consolidate node liveness check for forced repair (CASSANDRA-16113)
 * Use unsigned short in ValueAccessor.sliceWithShortLength (CASSANDRA-16147)
 * Abort repairs when getting a truncation request (CASSANDRA-15854)
 * Remove bad assert when getting active compactions for an sstable (CASSANDRA-15457)
 * Avoid failing compactions with very large partitions (CASSANDRA-15164)
 * Prevent NPE in StreamMessage in type lookup (CASSANDRA-16131)
 * Avoid invalid state transition exception during incremental repair (CASSANDRA-16067)
 * Allow zero padding in timestamp serialization (CASSANDRA-16105)
 * Add byte array backed cells (CASSANDRA-15393)
 * Correctly handle pending ranges with adjacent range movements (CASSANDRA-14801)
 * Avoid adding locahost when streaming trivial ranges (CASSANDRA-16099)
 * Add nodetool getfullquerylog (CASSANDRA-15988)
 * Fix yaml format and alignment in tpstats (CASSANDRA-11402)
 * Avoid trying to keep track of RTs for endpoints we won't write to during read repair (CASSANDRA-16084)
 * When compaction gets interrupted, the exception should include the compactionId (CASSANDRA-15954)
 * Make Table/Keyspace Metric Names Consistent With Each Other (CASSANDRA-15909)
 * Mutating sstable component may race with entire-sstable-streaming(ZCS) causing checksum validation failure (CASSANDRA-15861)
 * NPE thrown while updating speculative execution time if keyspace is removed during task execution (CASSANDRA-15949)
 * Show the progress of data streaming and index build (CASSANDRA-15406)
 * Add flag to disable chunk cache and disable by default (CASSANDRA-16036)
 * Upgrade to snakeyaml >= 1.26 version for CVE-2017-18640 fix (CASSANDRA-16150)
Merged from 3.11:
 * Fix ColumnFilter to avoid querying cells of unselected complex columns (CASSANDRA-15977)
 * Fix memory leak in CompressedChunkReader (CASSANDRA-15880)
 * Don't attempt value skipping with mixed version cluster (CASSANDRA-15833)
 * Use IF NOT EXISTS for index and UDT create statements in snapshot schema files (CASSANDRA-13935)
 * Make sure LCS handles duplicate sstable added/removed notifications correctly (CASSANDRA-14103)
Merged from 3.0:
 * Avoid marking shutting down nodes as up after receiving gossip shutdown message (CASSANDRA-16094)
 * Handle unexpected columns due to schema races (CASSANDRA-15899)
 * Add flag to ignore unreplicated keyspaces during repair (CASSANDRA-15160)
Merged from 2.2:
 * Package tools/bin scripts as executable (CASSANDRA-16151)
 * Fixed a NullPointerException when calling nodetool enablethrift (CASSANDRA-16127)
 * Automatically drop compact storage on tables for which it is safe (CASSANDRA-16048)
 * Fixed NullPointerException for COMPACT STORAGE tables with null clustering (CASSANDRA-16241)


4.0-beta2
 * Add addition incremental repair visibility to nodetool repair_admin (CASSANDRA-14939)
 * Always access system properties and environment variables via the new CassandraRelevantProperties and CassandraRelevantEnv classes (CASSANDRA-15876)
 * Remove deprecated HintedHandOffManager (CASSANDRA-15939)
 * Prevent repair from overrunning compaction (CASSANDRA-15817)
 * fix cqlsh COPY functions in Python 3.8 on Mac (CASSANDRA-16053)
 * Strip comment blocks from cqlsh input before processing statements (CASSANDRA-15802)
 * Fix unicode chars error input (CASSANDRA-15990)
 * Improved testability for CacheMetrics and ChunkCacheMetrics (CASSANDRA-15788)
 * Handle errors in StreamSession#prepare (CASSANDRA-15852)
 * FQL replay should have options to ignore DDL statements (CASSANDRA-16039)
 * Remove COMPACT STORAGE internals (CASSANDRA-13994)
 * Make TimestampSerializer accept fractional seconds of varying precision (CASSANDRA-15976)
 * Improve cassandra-stress logging when using a profile file that doesn't exist (CASSANDRA-14425)
 * Improve logging for socket connection/disconnection (CASSANDRA-15980)
 * Throw FSWriteError upon write failures in order to apply DiskFailurePolicy (CASSANDRA-15928)
 * Forbid altering UDTs used in partition keys (CASSANDRA-15933)
 * Fix version parsing logic when upgrading from 3.0 (CASSANDRA-15973)
 * Optimize NoSpamLogger use in hot paths (CASSANDRA-15766)
 * Verify sstable components on startup (CASSANDRA-15945)
 * Resolve JMX output inconsistencies from CASSANDRA-7544 storage-port-configurable-per-node (CASSANDRA-15937)
Merged from 3.11:
 * Correctly interpret SASI's `max_compaction_flush_memory_in_mb` setting in megabytes not bytes (CASSANDRA-16071)
 * Fix short read protection for GROUP BY queries (CASSANDRA-15459)
 * stop_paranoid disk failure policy is ignored on CorruptSSTableException after node is up (CASSANDRA-15191)
 * Frozen RawTuple is not annotated with frozen in the toString method (CASSANDRA-15857)
Merged from 3.0:
 * Fix gossip shutdown order (CASSANDRA-15816)
 * Remove broken 'defrag-on-read' optimization (CASSANDRA-15432)
 * Check for endpoint collision with hibernating nodes (CASSANDRA-14599)
 * Operational improvements and hardening for replica filtering protection (CASSANDRA-15907)
 * Fix empty/null json string representation (CASSANDRA-15896)
 * Handle difference in timestamp precision between java8 and java11 in LogFIle.java (CASSANDRA-16050)
Merged from 2.2:
 * Fix CQL parsing of collections when the column type is reversed (CASSANDRA-15814)
Merged from 2.1:
 * Only allow strings to be passed to JMX authentication (CASSANDRA-16077)


4.0-beta1
 * Remove BackPressureStrategy (CASSANDRA-15375)
 * Improve messaging on indexing frozen collections (CASSANDRA-15908)
 * USING_G1 is incorrectly set in cassandra-env.sh if G1 is explicitly disabled with -UseG1GC (CASSANDRA-15931)
 * Update compaction_throughput_mb_per_sec throttle default to 64 (CASSANDRA-14902)
 * Add option to disable compaction at startup (CASSANDRA-15927)
 * FBUtilities.getJustLocalAddress falls back to lo ip on misconfigured nodes (CASSANDRA-15901)
 * Close channel and reduce buffer allocation during entire sstable streaming with SSL (CASSANDRA-15900)
 * Prune expired messages less frequently in internode messaging (CASSANDRA-15700)
 * Fix Ec2Snitch handling of legacy mode for dc names matching both formats, eg "us-west-2" (CASSANDRA-15878)
 * Add support for server side DESCRIBE statements (CASSANDRA-14825)
 * Fail startup if -Xmn is set when the G1 garbage collector is used (CASSANDRA-15839)
 * generateSplits method replaced the generateRandomTokens for ReplicationAwareTokenAllocator. (CASSANDRA-15877)
 * Several mbeans are not unregistered when dropping a keyspace and table (CASSANDRA-14888)
 * Update defaults for server and client TLS settings (CASSANDRA-15262)
 * Differentiate follower/initator in StreamMessageHeader (CASSANDRA-15665)
 * Add a startup check to detect if LZ4 uses java rather than native implementation (CASSANDRA-15884)
 * Fix missing topology events when running multiple nodes on the same network interface (CASSANDRA-15677)
 * Create config.yml.MIDRES (CASSANDRA-15712)
 * Fix handling of fully purged static rows in repaired data tracking (CASSANDRA-15848)
 * Prevent validation request submission from blocking ANTI_ENTROPY stage (CASSANDRA-15812)
 * Add fqltool and auditlogviewer to rpm and deb packages (CASSANDRA-14712)
 * Include DROPPED_COLUMNS in schema digest computation (CASSANDRA-15843)
 * Fix Cassandra restart from rpm install (CASSANDRA-15830)
 * Improve handling of 2i initialization failures (CASSANDRA-13606)
 * Add completion_ratio column to sstable_tasks virtual table (CASANDRA-15759)
 * Add support for adding custom Verbs (CASSANDRA-15725)
 * Speed up entire-file-streaming file containment check and allow entire-file-streaming for all compaction strategies (CASSANDRA-15657,CASSANDRA-15783)
 * Provide ability to configure IAuditLogger (CASSANDRA-15748)
 * Fix nodetool enablefullquerylog blocking param parsing (CASSANDRA-15819)
 * Add isTransient to SSTableMetadataView (CASSANDRA-15806)
 * Fix tools/bin/fqltool for all shells (CASSANDRA-15820)
 * Fix clearing of legacy size_estimates (CASSANDRA-15776)
 * Update port when reconnecting to pre-4.0 SSL storage (CASSANDRA-15727)
 * Only calculate dynamicBadnessThreshold once per loop in DynamicEndpointSnitch (CASSANDRA-15798)
 * Cleanup redundant nodetool commands added in 4.0 (CASSANDRA-15256)
 * Update to Python driver 3.23 for cqlsh (CASSANDRA-15793)
 * Add tunable initial size and growth factor to RangeTombstoneList (CASSANDRA-15763)
 * Improve debug logging in SSTableReader for index summary (CASSANDRA-15755)
 * bin/sstableverify should support user provided token ranges (CASSANDRA-15753)
 * Improve logging when mutation passed to commit log is too large (CASSANDRA-14781)
 * replace LZ4FastDecompressor with LZ4SafeDecompressor (CASSANDRA-15560)
 * Fix buffer pool NPE with concurrent release due to in-progress tiny pool eviction (CASSANDRA-15726)
 * Avoid race condition when completing stream sessions (CASSANDRA-15666)
 * Flush with fast compressors by default (CASSANDRA-15379)
 * Fix CqlInputFormat regression from the switch to system.size_estimates (CASSANDRA-15637)
 * Allow sending Entire SSTables over SSL (CASSANDRA-15740)
 * Fix CQLSH UTF-8 encoding issue for Python 2/3 compatibility (CASSANDRA-15739)
 * Fix batch statement preparation when multiple tables and parameters are used (CASSANDRA-15730)
 * Fix regression with traceOutgoingMessage printing message size (CASSANDRA-15687)
 * Ensure repaired data tracking reads a consistent amount of data across replicas (CASSANDRA-15601)
 * Fix CQLSH to avoid arguments being evaluated (CASSANDRA-15660)
 * Correct Visibility and Improve Safety of Methods in LatencyMetrics (CASSANDRA-15597)
 * Allow cqlsh to run with Python2.7/Python3.6+ (CASSANDRA-15659,CASSANDRA-15573)
 * Improve logging around incremental repair (CASSANDRA-15599)
 * Do not check cdc_raw_directory filesystem space if CDC disabled (CASSANDRA-15688)
 * Replace array iterators with get by index (CASSANDRA-15394)
 * Minimize BTree iterator allocations (CASSANDRA-15389)
Merged from 3.11:
 * Fix cqlsh output when fetching all rows in batch mode (CASSANDRA-15905)
 * Upgrade Jackson to 2.9.10 (CASSANDRA-15867)
 * Fix CQL formatting of read command restrictions for slow query log (CASSANDRA-15503)
Merged from 3.0:
 * Avoid hinted handoff per-host throttle being arounded to 0 in large cluster (CASSANDRA-15859)
 * Avoid emitting empty range tombstones from RangeTombstoneList (CASSANDRA-15924)
 * Avoid thread starvation, and improve compare-and-swap performance, in the slab allocators (CASSANDRA-15922)
 * Add token to tombstone warning and error messages (CASSANDRA-15890)
 * Fixed range read concurrency factor computation and capped as 10 times tpc cores (CASSANDRA-15752)
 * Catch exception on bootstrap resume and init native transport (CASSANDRA-15863)
 * Fix replica-side filtering returning stale data with CL > ONE (CASSANDRA-8272, CASSANDRA-8273)
 * Rely on snapshotted session infos on StreamResultFuture.maybeComplete to avoid race conditions (CASSANDRA-15667)
 * EmptyType doesn't override writeValue so could attempt to write bytes when expected not to (CASSANDRA-15790)
 * Fix index queries on partition key columns when some partitions contains only static data (CASSANDRA-13666)
 * Avoid creating duplicate rows during major upgrades (CASSANDRA-15789)
 * liveDiskSpaceUsed and totalDiskSpaceUsed get corrupted if IndexSummaryRedistribution gets interrupted (CASSANDRA-15674)
 * Fix Debian init start/stop (CASSANDRA-15770)
 * Fix infinite loop on index query paging in tables with clustering (CASSANDRA-14242)
 * Fix chunk index overflow due to large sstable with small chunk length (CASSANDRA-15595)
 * Allow selecting static column only when querying static index (CASSANDRA-14242)
 * cqlsh return non-zero status when STDIN CQL fails (CASSANDRA-15623)
 * Don't skip sstables in slice queries based only on local min/max/deletion timestamp (CASSANDRA-15690)
Merged from 2.2:
 * Fix nomenclature of allow and deny lists (CASSANDRA-15862)
 * Remove generated files from source artifact (CASSANDRA-15849)
 * Remove duplicated tools binaries from tarballs (CASSANDRA-15768)
 * Duplicate results with DISTINCT queries in mixed mode (CASSANDRA-15501)
Merged from 2.1:
 * Fix writing of snapshot manifest when the table has table-backed secondary indexes (CASSANDRA-10968)


4.0-alpha4
 * Add client request size server metrics (CASSANDRA-15704)
 * Add additional logging around FileUtils and compaction leftover cleanup (CASSANDRA-15705)
 * Mark system_views/system_virtual_schema as non-alterable keyspaces in cqlsh (CASSANDRA-15711)
 * Fail incremental repair if an old version sstable is involved (CASSANDRA-15612)
 * Fix overflows on StreamingTombstoneHistogramBuilder produced by large deletion times (CASSANDRA-14773)
 * Mark system_views/system_virtual_schema as system keyspaces in cqlsh (CASSANDRA-15706)
 * Avoid unnecessary collection/iterator allocations during btree construction (CASSANDRA-15390)
 * Repair history tables should have TTL and TWCS (CASSANDRA-12701)
 * Fix cqlsh erroring out on Python 3.7 due to webbrowser module being absent (CASSANDRA-15572)
 * Fix IMH#acquireCapacity() to return correct Outcome when endpoint reserve runs out (CASSANDRA-15607)
 * Fix nodetool describering output (CASSANDRA-15682)
 * Only track ideal CL failure when request CL met (CASSANDRA-15696)
 * Fix flaky CoordinatorMessagingTest and docstring in OutboundSink and ConsistentSession (CASSANDRA-15672)
 * Fix force compaction of wrapping ranges (CASSANDRA-15664)
 * Expose repair streaming metrics (CASSANDRA-15656)
 * Set now in seconds in the future for validation repairs (CASSANDRA-15655)
 * Emit metric on preview repair failure (CASSANDRA-15654)
 * Use more appropriate logging levels (CASSANDRA-15661)
 * Fixed empty check in TrieMemIndex due to potential state inconsistency in ConcurrentSkipListMap (CASSANDRA-15526)
 * Added UnleveledSSTables global and table level metric (CASSANDRA-15620)
 * Added Virtual Table exposing Cassandra relevant system properties (CASSANDRA-15616, CASSANDRA-15643)
 * Improve the algorithmic token allocation in case racks = RF (CASSANDRA-15600)
 * Fix ConnectionTest.testAcquireReleaseOutbound (CASSANDRA-15308)
 * Include finalized pending sstables in preview repair (CASSANDRA-15553)
 * Reverted to the original behavior of CLUSTERING ORDER on CREATE TABLE (CASSANDRA-15271)
 * Correct inaccurate logging message (CASSANDRA-15549)
 * Unset GREP_OPTIONS (CASSANDRA-14487)
 * Update to Python driver 3.21 for cqlsh (CASSANDRA-14872)
 * Fix missing Keyspaces in cqlsh describe output (CASSANDRA-15576)
 * Fix multi DC nodetool status output (CASSANDRA-15305)
 * updateCoordinatorWriteLatencyTableMetric can produce misleading metrics (CASSANDRA-15569)
 * Make cqlsh and cqlshlib Python 2 & 3 compatible (CASSANDRA-10190)
 * Improve the description of nodetool listsnapshots command (CASSANDRA-14587)
 * allow embedded cassandra launched from a one-jar or uno-jar (CASSANDRA-15494)
 * Update hppc library to version 0.8.1 (CASSANDRA-12995)
 * Limit the dependencies used by UDFs/UDAs (CASSANDRA-14737)
 * Make native_transport_max_concurrent_requests_in_bytes updatable (CASSANDRA-15519)
 * Cleanup and improvements to IndexInfo/ColumnIndex (CASSANDRA-15469)
 * Potential Overflow in DatabaseDescriptor Functions That Convert Between KB/MB & Bytes (CASSANDRA-15470)
Merged from 3.11:
 * Allow sstableloader to use SSL on the native port (CASSANDRA-14904)
Merged from 3.0:
 * cqlsh return non-zero status when STDIN CQL fails (CASSANDRA-15623)
 * Don't skip sstables in slice queries based only on local min/max/deletion timestamp (CASSANDRA-15690)
 * Memtable memory allocations may deadlock (CASSANDRA-15367)
 * Run evictFromMembership in GossipStage (CASSANDRA-15592)
Merged from 2.2:
 * Duplicate results with DISTINCT queries in mixed mode (CASSANDRA-15501)
 * Disable JMX rebinding (CASSANDRA-15653)
Merged from 2.1:
 * Fix parse error in cqlsh COPY FROM and formatting for map of blobs (CASSANDRA-15679)
 * Fix Commit log replays when static column clustering keys are collections (CASSANDRA-14365)
 * Fix Red Hat init script on newer systemd versions (CASSANDRA-15273)
 * Allow EXTRA_CLASSPATH to work on tar/source installations (CASSANDRA-15567)


4.0-alpha3
 * Restore monotonic read consistency guarantees for blocking read repair (CASSANDRA-14740)
 * Separate exceptions for CAS write timeout exceptions caused by contention and unkown result (CASSANDRA-15350)
 * Fix in-jvm dtest java 11 compatibility (CASSANDRA-15463)
 * Remove joda time dependency (CASSANDRA-15257)
 * Exclude purgeable tombstones from repaired data tracking (CASSANDRA-15462)
 * Exclude legacy counter shards from repaired data tracking (CASSANDRA-15461)
 * Make it easier to add trace headers to messages (CASSANDRA-15499)
 * Fix and optimise partial compressed sstable streaming (CASSANDRA-13938)
 * Improve error when JVM 11 can't access required modules (CASSANDRA-15468)
 * Better handling of file deletion failures by DiskFailurePolicy (CASSANDRA-15143)
 * Prevent read repair mutations from increasing read timeout (CASSANDRA-15442)
 * Document 4.0 system keyspace changes, bump generations (CASSANDRA-15454)
 * Make it possible to disable STCS-in-L0 during runtime (CASSANDRA-15445)
 * Removed obsolete OldNetworkTopologyStrategy (CASSANDRA-13990)
 * Align record header of FQL and audit binary log (CASSANDRA-15076)
 * Shuffle forwarding replica for messages to non-local DC (CASSANDRA-15318)
 * Optimise native protocol ASCII string encoding (CASSANDRA-15410)
 * Make sure all exceptions are propagated in DebuggableThreadPoolExecutor (CASSANDRA-15332)
 * Make it possible to resize concurrent read / write thread pools at runtime (CASSANDRA-15277)
 * Close channels on error (CASSANDRA-15407)
 * Integrate SJK into nodetool (CASSANDRA-12197)
 * Ensure that empty clusterings with kind==CLUSTERING are Clustering.EMPTY (CASSANDRA-15498)
 * The flag 'cross_node_timeout' has been set as true by default. This change
   is done under the assumption that users have setup NTP on their clusters or
   otherwise synchronize their clocks, and that clocks are mostly in sync, since
   this is a requirement for general correctness of last write wins. (CASSANDRA-15216)
Merged from 3.11:
 * Fix bad UDT sstable metadata serialization headers written by C* 3.0 on upgrade and in sstablescrub (CASSANDRA-15035)
 * Fix nodetool compactionstats showing extra pending task for TWCS - patch implemented (CASSANDRA-15409)
 * Fix SELECT JSON formatting for the "duration" type (CASSANDRA-15075)
 * Update nodetool help stop output (CASSANDRA-15401)
Merged from 3.0:
 * Fix race condition when setting bootstrap flags (CASSANDRA-14878)
 * Run in-jvm upgrade dtests in circleci (CASSANDRA-15506)
 * Include updates to static column in mutation size calculations (CASSANDRA-15293)
 * Fix point-in-time recoevery ignoring timestamp of updates to static columns (CASSANDRA-15292)
 * GC logs are also put under $CASSANDRA_LOG_DIR (CASSANDRA-14306)
 * Fix sstabledump's position key value when partitions have multiple rows (CASSANDRA-14721)
 * Avoid over-scanning data directories in LogFile.verify() (CASSANDRA-15364)
 * Bump generations and document changes to system_distributed and system_traces in 3.0, 3.11
   (CASSANDRA-15441)
 * Fix system_traces creation timestamp; optimise system keyspace upgrades (CASSANDRA-15398)
 * Make sure index summary redistribution does not start when compactions are paused (CASSANDRA-15265)
 * Fix NativeLibrary.tryOpenDirectory callers for Windows (CASSANDRA-15426)
Merged from 2.2:
 * Fix SELECT JSON output for empty blobs (CASSANDRA-15435)
 * In-JVM DTest: Set correct internode message version for upgrade test (CASSANDRA-15371)
 * In-JVM DTest: Support NodeTool in dtest (CASSANDRA-15429)
 * Added data modeling documentation (CASSANDRA-15443)


4.0-alpha2
 * Fix SASI non-literal string comparisons (range operators) (CASSANDRA-15169)
 * Upgrade Guava to 27, and to java-driver 3.6.0 (from 3.4.0-SNAPSHOT) (CASSANDRA-14655)
 * Extract an AbstractCompactionController to allow for custom implementations (CASSANDRA-15286)
 * Move chronicle-core version from snapshot to stable, and include carrotsearch in generated pom.xml (CASSANDRA-15321)
 * Untangle RepairMessage sub-hierarchy of messages, use new messaging (more) correctly (CASSANDRA-15163)
 * Add `allocate_tokens_for_local_replication_factor` option for token allocation (CASSANDRA-15260)
 * Add Alibaba Cloud Platform snitch (CASSANDRA-15092)
Merged from 3.0:
 * Fix various data directory prefix matching issues (CASSANDRA-13974)
 * Minimize clustering values in metadata collector (CASSANDRA-15400)
 * Make sure index summary redistribution does not start when compactions are paused (CASSANDRA-15265)
 * Add ability to cap max negotiable protocol version (CASSANDRA-15193)
 * Gossip tokens on startup if available (CASSANDRA-15335)
 * Fix resource leak in CompressedSequentialWriter (CASSANDRA-15340)
 * Fix bad merge that reverted CASSANDRA-14993 (CASSANDRA-15289)
 * Add support for network topology and query tracing for inJVM dtest (CASSANDRA-15319)


4.0-alpha1
 * Inaccurate exception message with nodetool snapshot (CASSANDRA-15287)
 * Fix InternodeOutboundMetrics overloaded bytes/count mixup (CASSANDRA-15186)
 * Enhance & reenable RepairTest with compression=off and compression=on (CASSANDRA-15272)
 * Improve readability of Table metrics Virtual tables units (CASSANDRA-15194)
 * Fix error with non-existent table for nodetool tablehistograms (CASSANDRA-14410)
 * Avoid result truncation in decimal operations (CASSANDRA-15232)
 * Catch non-IOException in FileUtils.close to make sure that all resources are closed (CASSANDRA-15225)
 * Align load column in nodetool status output (CASSANDRA-14787)
 * CassandraNetworkAuthorizer uses cached roles info (CASSANDRA-15089)
 * Introduce optional timeouts for idle client sessions (CASSANDRA-11097)
 * Fix AlterTableStatement dropped type validation order (CASSANDRA-15203)
 * Update Netty dependencies to latest, clean up SocketFactory (CASSANDRA-15195)
 * Native Transport - Apply noSpamLogger to ConnectionLimitHandler (CASSANDRA-15167)
 * Reduce heap pressure during compactions (CASSANDRA-14654)
 * Support building Cassandra with JDK 11 (CASSANDRA-15108)
 * Use quilt to patch cassandra.in.sh in Debian packaging (CASSANDRA-14710)
 * Take sstable references before calculating approximate key count (CASSANDRA-14647)
 * Restore snapshotting of system keyspaces on version change (CASSANDRA-14412)
 * Fix AbstractBTreePartition locking in java 11 (CASSANDRA-14607)
 * SimpleClient should pass connection properties as options (CASSANDRA-15056)
 * Set repaired data tracking flag on range reads if enabled (CASSANDRA-15019)
 * Calculate pending ranges for BOOTSTRAP_REPLACE correctly (CASSANDRA-14802)
 * Make TableCQLHelper reuse the single quote pattern (CASSANDRA-15033)
 * Add Zstd compressor (CASSANDRA-14482)
 * Fix IR prepare anti-compaction race (CASSANDRA-15027)
 * Fix SimpleStrategy option validation (CASSANDRA-15007)
 * Don't try to cancel 2i compactions when starting anticompaction (CASSANDRA-15024)
 * Avoid NPE in RepairRunnable.recordFailure (CASSANDRA-15025)
 * SSL Cert Hot Reloading should check for sanity of the new keystore/truststore before loading it (CASSANDRA-14991)
 * Avoid leaking threads when failing anticompactions and rate limit anticompactions (CASSANDRA-15002)
 * Validate token() arguments early instead of throwing NPE at execution (CASSANDRA-14989)
 * Add a new tool to dump audit logs (CASSANDRA-14885)
 * Fix generating javadoc with Java11 (CASSANDRA-14988)
 * Only cancel conflicting compactions when starting anticompactions and sub range compactions (CASSANDRA-14935)
 * Use a stub IndexRegistry for non-daemon use cases (CASSANDRA-14938)
 * Don't enable client transports when bootstrap is pending (CASSANDRA-14525)
 * Make antiCompactGroup throw exception on error and anticompaction non cancellable
   again (CASSANDRA-14936)
 * Catch empty/invalid bounds in SelectStatement (CASSANDRA-14849)
 * Auto-expand replication_factor for NetworkTopologyStrategy (CASSANDRA-14303)
 * Transient Replication: support EACH_QUORUM (CASSANDRA-14727)
 * BufferPool: allocating thread for new chunks should acquire directly (CASSANDRA-14832)
 * Send correct messaging version in internode messaging handshake's third message (CASSANDRA-14896)
 * Make Read and Write Latency columns consistent for proxyhistograms and tablehistograms (CASSANDRA-11939)
 * Make protocol checksum type option case insensitive (CASSANDRA-14716)
 * Forbid re-adding static columns as regular and vice versa (CASSANDRA-14913)
 * Audit log allows system keyspaces to be audited via configuration options (CASSANDRA-14498)
 * Lower default chunk_length_in_kb from 64kb to 16kb (CASSANDRA-13241)
 * Startup checker should wait for count rather than percentage (CASSANDRA-14297)
 * Fix incorrect sorting of replicas in SimpleStrategy.calculateNaturalReplicas (CASSANDRA-14862)
 * Partitioned outbound internode TCP connections can occur when nodes restart (CASSANDRA-14358)
 * Don't write to system_distributed.repair_history, system_traces.sessions, system_traces.events in mixed version 3.X/4.0 clusters (CASSANDRA-14841)
 * Avoid running query to self through messaging service (CASSANDRA-14807)
 * Allow using custom script for chronicle queue BinLog archival (CASSANDRA-14373)
 * Transient->Full range movements mishandle consistency level upgrade (CASSANDRA-14759)
 * ReplicaCollection follow-up (CASSANDRA-14726)
 * Transient node receives full data requests (CASSANDRA-14762)
 * Enable snapshot artifacts publish (CASSANDRA-12704)
 * Introduce RangesAtEndpoint.unwrap to simplify StreamSession.addTransferRanges (CASSANDRA-14770)
 * LOCAL_QUORUM may speculate to non-local nodes, resulting in Timeout instead of Unavailable (CASSANDRA-14735)
 * Avoid creating empty compaction tasks after truncate (CASSANDRA-14780)
 * Fail incremental repair prepare phase if it encounters sstables from un-finalized sessions (CASSANDRA-14763)
 * Add a check for receiving digest response from transient node (CASSANDRA-14750)
 * Fail query on transient replica if coordinator only expects full data (CASSANDRA-14704)
 * Remove mentions of transient replication from repair path (CASSANDRA-14698)
 * Fix handleRepairStatusChangedNotification to remove first then add (CASSANDRA-14720)
 * Allow transient node to serve as a repair coordinator (CASSANDRA-14693)
 * DecayingEstimatedHistogramReservoir.EstimatedHistogramReservoirSnapshot returns wrong value for size() and incorrectly calculates count (CASSANDRA-14696)
 * AbstractReplicaCollection equals and hash code should throw due to conflict between order sensitive/insensitive uses (CASSANDRA-14700)
 * Detect inconsistencies in repaired data on the read path (CASSANDRA-14145)
 * Add checksumming to the native protocol (CASSANDRA-13304)
 * Make AuthCache more easily extendable (CASSANDRA-14662)
 * Extend RolesCache to include detailed role info (CASSANDRA-14497)
 * Add fqltool compare (CASSANDRA-14619)
 * Add fqltool replay (CASSANDRA-14618)
 * Log keyspace in full query log (CASSANDRA-14656)
 * Transient Replication and Cheap Quorums (CASSANDRA-14404)
 * Log server-generated timestamp and nowInSeconds used by queries in FQL (CASSANDRA-14675)
 * Add diagnostic events for read repairs (CASSANDRA-14668)
 * Use consistent nowInSeconds and timestamps values within a request (CASSANDRA-14671)
 * Add sampler for query time and expose with nodetool (CASSANDRA-14436)
 * Clean up Message.Request implementations (CASSANDRA-14677)
 * Disable old native protocol versions on demand (CASANDRA-14659)
 * Allow specifying now-in-seconds in native protocol (CASSANDRA-14664)
 * Improve BTree build performance by avoiding data copy (CASSANDRA-9989)
 * Make monotonic read / read repair configurable (CASSANDRA-14635)
 * Refactor CompactionStrategyManager (CASSANDRA-14621)
 * Flush netty client messages immediately by default (CASSANDRA-13651)
 * Improve read repair blocking behavior (CASSANDRA-10726)
 * Add a virtual table to expose settings (CASSANDRA-14573)
 * Fix up chunk cache handling of metrics (CASSANDRA-14628)
 * Extend IAuthenticator to accept peer SSL certificates (CASSANDRA-14652)
 * Incomplete handling of exceptions when decoding incoming messages (CASSANDRA-14574)
 * Add diagnostic events for user audit logging (CASSANDRA-13668)
 * Allow retrieving diagnostic events via JMX (CASSANDRA-14435)
 * Add base classes for diagnostic events (CASSANDRA-13457)
 * Clear view system metadata when dropping keyspace (CASSANDRA-14646)
 * Allocate ReentrantLock on-demand in java11 AtomicBTreePartitionerBase (CASSANDRA-14637)
 * Make all existing virtual tables use LocalPartitioner (CASSANDRA-14640)
 * Revert 4.0 GC alg back to CMS (CASANDRA-14636)
 * Remove hardcoded java11 jvm args in idea workspace files (CASSANDRA-14627)
 * Update netty to 4.1.128 (CASSANDRA-14633)
 * Add a virtual table to expose thread pools (CASSANDRA-14523)
 * Add a virtual table to expose caches (CASSANDRA-14538, CASSANDRA-14626)
 * Fix toDate function for timestamp arguments (CASSANDRA-14502)
 * Stream entire SSTables when possible (CASSANDRA-14556)
 * Cell reconciliation should not depend on nowInSec (CASSANDRA-14592)
 * Add experimental support for Java 11 (CASSANDRA-9608)
 * Make PeriodicCommitLogService.blockWhenSyncLagsNanos configurable (CASSANDRA-14580)
 * Improve logging in MessageInHandler's constructor (CASSANDRA-14576)
 * Set broadcast address in internode messaging handshake (CASSANDRA-14579)
 * Wait for schema agreement prior to building MVs (CASSANDRA-14571)
 * Make all DDL statements idempotent and not dependent on global state (CASSANDRA-13426)
 * Bump the hints messaging version to match the current one (CASSANDRA-14536)
 * OffsetAwareConfigurationLoader doesn't set ssl storage port causing bind errors in CircleCI (CASSANDRA-14546)
 * Report why native_transport_port fails to bind (CASSANDRA-14544)
 * Optimize internode messaging protocol (CASSANDRA-14485)
 * Internode messaging handshake sends wrong messaging version number (CASSANDRA-14540)
 * Add a virtual table to expose active client connections (CASSANDRA-14458)
 * Clean up and refactor client metrics (CASSANDRA-14524)
 * Nodetool import row cache invalidation races with adding sstables to tracker (CASSANDRA-14529)
 * Fix assertions in LWTs after TableMetadata was made immutable (CASSANDRA-14356)
 * Abort compactions quicker (CASSANDRA-14397)
 * Support light-weight transactions in cassandra-stress (CASSANDRA-13529)
 * Make AsyncOneResponse use the correct timeout (CASSANDRA-14509)
 * Add option to sanity check tombstones on reads/compactions (CASSANDRA-14467)
 * Add a virtual table to expose all running sstable tasks (CASSANDRA-14457)
 * Let nodetool import take a list of directories (CASSANDRA-14442)
 * Avoid unneeded memory allocations / cpu for disabled log levels (CASSANDRA-14488)
 * Implement virtual keyspace interface (CASSANDRA-7622)
 * nodetool import cleanup and improvements (CASSANDRA-14417)
 * Bump jackson version to >= 2.9.5 (CASSANDRA-14427)
 * Allow nodetool toppartitions without specifying table (CASSANDRA-14360)
 * Audit logging for database activity (CASSANDRA-12151)
 * Clean up build artifacts in docs container (CASSANDRA-14432)
 * Minor network authz improvements (Cassandra-14413)
 * Automatic sstable upgrades (CASSANDRA-14197)
 * Replace deprecated junit.framework.Assert usages with org.junit.Assert (CASSANDRA-14431)
 * Cassandra-stress throws NPE if insert section isn't specified in user profile (CASSSANDRA-14426)
 * List clients by protocol versions `nodetool clientstats --by-protocol` (CASSANDRA-14335)
 * Improve LatencyMetrics performance by reducing write path processing (CASSANDRA-14281)
 * Add network authz (CASSANDRA-13985)
 * Use the correct IP/Port for Streaming when localAddress is left unbound (CASSANDRA-14389)
 * nodetool listsnapshots is missing local system keyspace snapshots (CASSANDRA-14381)
 * Remove StreamCoordinator.streamExecutor thread pool (CASSANDRA-14402)
 * Rename nodetool --with-port to --print-port to disambiguate from --port (CASSANDRA-14392)
 * Client TOPOLOGY_CHANGE messages have wrong port. (CASSANDRA-14398)
 * Add ability to load new SSTables from a separate directory (CASSANDRA-6719)
 * Eliminate background repair and probablistic read_repair_chance table options
   (CASSANDRA-13910)
 * Bind to correct local address in 4.0 streaming (CASSANDRA-14362)
 * Use standard Amazon naming for datacenter and rack in Ec2Snitch (CASSANDRA-7839)
 * Abstract write path for pluggable storage (CASSANDRA-14118)
 * nodetool describecluster should be more informative (CASSANDRA-13853)
 * Compaction performance improvements (CASSANDRA-14261)
 * Refactor Pair usage to avoid boxing ints/longs (CASSANDRA-14260)
 * Add options to nodetool tablestats to sort and limit output (CASSANDRA-13889)
 * Rename internals to reflect CQL vocabulary (CASSANDRA-14354)
 * Add support for hybrid MIN(), MAX() speculative retry policies
   (CASSANDRA-14293, CASSANDRA-14338, CASSANDRA-14352)
 * Fix some regressions caused by 14058 (CASSANDRA-14353)
 * Abstract repair for pluggable storage (CASSANDRA-14116)
 * Add meaningful toString() impls (CASSANDRA-13653)
 * Add sstableloader option to accept target keyspace name (CASSANDRA-13884)
 * Move processing of EchoMessage response to gossip stage (CASSANDRA-13713)
 * Add coordinator write metric per CF (CASSANDRA-14232)
 * Correct and clarify SSLFactory.getSslContext method and call sites (CASSANDRA-14314)
 * Handle static and partition deletion properly on ThrottledUnfilteredIterator (CASSANDRA-14315)
 * NodeTool clientstats should show SSL Cipher (CASSANDRA-14322)
 * Add ability to specify driver name and version (CASSANDRA-14275)
 * Abstract streaming for pluggable storage (CASSANDRA-14115)
 * Forced incremental repairs should promote sstables if they can (CASSANDRA-14294)
 * Use Murmur3 for validation compactions (CASSANDRA-14002)
 * Comma at the end of the seed list is interpretated as localhost (CASSANDRA-14285)
 * Refactor read executor and response resolver, abstract read repair (CASSANDRA-14058)
 * Add optional startup delay to wait until peers are ready (CASSANDRA-13993)
 * Add a few options to nodetool verify (CASSANDRA-14201)
 * CVE-2017-5929 Security vulnerability and redefine default log rotation policy (CASSANDRA-14183)
 * Use JVM default SSL validation algorithm instead of custom default (CASSANDRA-13259)
 * Better document in code InetAddressAndPort usage post 7544, incorporate port into UUIDGen node (CASSANDRA-14226)
 * Fix sstablemetadata date string for minLocalDeletionTime (CASSANDRA-14132)
 * Make it possible to change neverPurgeTombstones during runtime (CASSANDRA-14214)
 * Remove GossipDigestSynVerbHandler#doSort() (CASSANDRA-14174)
 * Add nodetool clientlist (CASSANDRA-13665)
 * Revert ProtocolVersion changes from CASSANDRA-7544 (CASSANDRA-14211)
 * Non-disruptive seed node list reload (CASSANDRA-14190)
 * Nodetool tablehistograms to print statics for all the tables (CASSANDRA-14185)
 * Migrate dtests to use pytest and python3 (CASSANDRA-14134)
 * Allow storage port to be configurable per node (CASSANDRA-7544)
 * Make sub-range selection for non-frozen collections return null instead of empty (CASSANDRA-14182)
 * BloomFilter serialization format should not change byte ordering (CASSANDRA-9067)
 * Remove unused on-heap BloomFilter implementation (CASSANDRA-14152)
 * Delete temp test files on exit (CASSANDRA-14153)
 * Make PartitionUpdate and Mutation immutable (CASSANDRA-13867)
 * Fix CommitLogReplayer exception for CDC data (CASSANDRA-14066)
 * Fix cassandra-stress startup failure (CASSANDRA-14106)
 * Remove initialDirectories from CFS (CASSANDRA-13928)
 * Fix trivial log format error (CASSANDRA-14015)
 * Allow sstabledump to do a json object per partition (CASSANDRA-13848)
 * Add option to optimise merkle tree comparison across replicas (CASSANDRA-3200)
 * Remove unused and deprecated methods from AbstractCompactionStrategy (CASSANDRA-14081)
 * Fix Distribution.average in cassandra-stress (CASSANDRA-14090)
 * Support a means of logging all queries as they were invoked (CASSANDRA-13983)
 * Presize collections (CASSANDRA-13760)
 * Add GroupCommitLogService (CASSANDRA-13530)
 * Parallelize initial materialized view build (CASSANDRA-12245)
 * Make LWTs send resultset metadata on every request (CASSANDRA-13992)
 * Fix flaky indexWithFailedInitializationIsNotQueryableAfterPartialRebuild (CASSANDRA-13963)
 * Introduce leaf-only iterator (CASSANDRA-9988)
 * Upgrade Guava to 23.3 and Airline to 0.8 (CASSANDRA-13997)
 * Allow only one concurrent call to StatusLogger (CASSANDRA-12182)
 * Refactoring to specialised functional interfaces (CASSANDRA-13982)
 * Speculative retry should allow more friendly params (CASSANDRA-13876)
 * Throw exception if we send/receive repair messages to incompatible nodes (CASSANDRA-13944)
 * Replace usages of MessageDigest with Guava's Hasher (CASSANDRA-13291)
 * Add nodetool cmd to print hinted handoff window (CASSANDRA-13728)
 * Fix some alerts raised by static analysis (CASSANDRA-13799)
 * Checksum sstable metadata (CASSANDRA-13321, CASSANDRA-13593)
 * Add result set metadata to prepared statement MD5 hash calculation (CASSANDRA-10786)
 * Refactor GcCompactionTest to avoid boxing (CASSANDRA-13941)
 * Expose recent histograms in JmxHistograms (CASSANDRA-13642)
 * Fix buffer length comparison when decompressing in netty-based streaming (CASSANDRA-13899)
 * Properly close StreamCompressionInputStream to release any ByteBuf (CASSANDRA-13906)
 * Add SERIAL and LOCAL_SERIAL support for cassandra-stress (CASSANDRA-13925)
 * LCS needlessly checks for L0 STCS candidates multiple times (CASSANDRA-12961)
 * Correctly close netty channels when a stream session ends (CASSANDRA-13905)
 * Update lz4 to 1.4.0 (CASSANDRA-13741)
 * Optimize Paxos prepare and propose stage for local requests (CASSANDRA-13862)
 * Throttle base partitions during MV repair streaming to prevent OOM (CASSANDRA-13299)
 * Use compaction threshold for STCS in L0 (CASSANDRA-13861)
 * Fix problem with min_compress_ratio: 1 and disallow ratio < 1 (CASSANDRA-13703)
 * Add extra information to SASI timeout exception (CASSANDRA-13677)
 * Add incremental repair support for --hosts, --force, and subrange repair (CASSANDRA-13818)
 * Rework CompactionStrategyManager.getScanners synchronization (CASSANDRA-13786)
 * Add additional unit tests for batch behavior, TTLs, Timestamps (CASSANDRA-13846)
 * Add keyspace and table name in schema validation exception (CASSANDRA-13845)
 * Emit metrics whenever we hit tombstone failures and warn thresholds (CASSANDRA-13771)
 * Make netty EventLoopGroups daemon threads (CASSANDRA-13837)
 * Race condition when closing stream sessions (CASSANDRA-13852)
 * NettyFactoryTest is failing in trunk on macOS (CASSANDRA-13831)
 * Allow changing log levels via nodetool for related classes (CASSANDRA-12696)
 * Add stress profile yaml with LWT (CASSANDRA-7960)
 * Reduce memory copies and object creations when acting on ByteBufs (CASSANDRA-13789)
 * Simplify mx4j configuration (Cassandra-13578)
 * Fix trigger example on 4.0 (CASSANDRA-13796)
 * Force minumum timeout value (CASSANDRA-9375)
 * Use netty for streaming (CASSANDRA-12229)
 * Use netty for internode messaging (CASSANDRA-8457)
 * Add bytes repaired/unrepaired to nodetool tablestats (CASSANDRA-13774)
 * Don't delete incremental repair sessions if they still have sstables (CASSANDRA-13758)
 * Fix pending repair manager index out of bounds check (CASSANDRA-13769)
 * Don't use RangeFetchMapCalculator when RF=1 (CASSANDRA-13576)
 * Don't optimise trivial ranges in RangeFetchMapCalculator (CASSANDRA-13664)
 * Use an ExecutorService for repair commands instead of new Thread(..).start() (CASSANDRA-13594)
 * Fix race / ref leak in anticompaction (CASSANDRA-13688)
 * Expose tasks queue length via JMX (CASSANDRA-12758)
 * Fix race / ref leak in PendingRepairManager (CASSANDRA-13751)
 * Enable ppc64le runtime as unsupported architecture (CASSANDRA-13615)
 * Improve sstablemetadata output (CASSANDRA-11483)
 * Support for migrating legacy users to roles has been dropped (CASSANDRA-13371)
 * Introduce error metrics for repair (CASSANDRA-13387)
 * Refactoring to primitive functional interfaces in AuthCache (CASSANDRA-13732)
 * Update metrics to 3.1.5 (CASSANDRA-13648)
 * batch_size_warn_threshold_in_kb can now be set at runtime (CASSANDRA-13699)
 * Avoid always rebuilding secondary indexes at startup (CASSANDRA-13725)
 * Upgrade JMH from 1.13 to 1.19 (CASSANDRA-13727)
 * Upgrade SLF4J from 1.7.7 to 1.7.25 (CASSANDRA-12996)
 * Default for start_native_transport now true if not set in config (CASSANDRA-13656)
 * Don't add localhost to the graph when calculating where to stream from (CASSANDRA-13583)
 * Make CDC availability more deterministic via hard-linking (CASSANDRA-12148)
 * Allow skipping equality-restricted clustering columns in ORDER BY clause (CASSANDRA-10271)
 * Use common nowInSec for validation compactions (CASSANDRA-13671)
 * Improve handling of IR prepare failures (CASSANDRA-13672)
 * Send IR coordinator messages synchronously (CASSANDRA-13673)
 * Flush system.repair table before IR finalize promise (CASSANDRA-13660)
 * Fix column filter creation for wildcard queries (CASSANDRA-13650)
 * Add 'nodetool getbatchlogreplaythrottle' and 'nodetool setbatchlogreplaythrottle' (CASSANDRA-13614)
 * fix race condition in PendingRepairManager (CASSANDRA-13659)
 * Allow noop incremental repair state transitions (CASSANDRA-13658)
 * Run repair with down replicas (CASSANDRA-10446)
 * Added started & completed repair metrics (CASSANDRA-13598)
 * Added started & completed repair metrics (CASSANDRA-13598)
 * Improve secondary index (re)build failure and concurrency handling (CASSANDRA-10130)
 * Improve calculation of available disk space for compaction (CASSANDRA-13068)
 * Change the accessibility of RowCacheSerializer for third party row cache plugins (CASSANDRA-13579)
 * Allow sub-range repairs for a preview of repaired data (CASSANDRA-13570)
 * NPE in IR cleanup when columnfamily has no sstables (CASSANDRA-13585)
 * Fix Randomness of stress values (CASSANDRA-12744)
 * Allow selecting Map values and Set elements (CASSANDRA-7396)
 * Fast and garbage-free Streaming Histogram (CASSANDRA-13444)
 * Update repairTime for keyspaces on completion (CASSANDRA-13539)
 * Add configurable upper bound for validation executor threads (CASSANDRA-13521)
 * Bring back maxHintTTL propery (CASSANDRA-12982)
 * Add testing guidelines (CASSANDRA-13497)
 * Add more repair metrics (CASSANDRA-13531)
 * RangeStreamer should be smarter when picking endpoints for streaming (CASSANDRA-4650)
 * Avoid rewrapping an exception thrown for cache load functions (CASSANDRA-13367)
 * Log time elapsed for each incremental repair phase (CASSANDRA-13498)
 * Add multiple table operation support to cassandra-stress (CASSANDRA-8780)
 * Fix incorrect cqlsh results when selecting same columns multiple times (CASSANDRA-13262)
 * Fix WriteResponseHandlerTest is sensitive to test execution order (CASSANDRA-13421)
 * Improve incremental repair logging (CASSANDRA-13468)
 * Start compaction when incremental repair finishes (CASSANDRA-13454)
 * Add repair streaming preview (CASSANDRA-13257)
 * Cleanup isIncremental/repairedAt usage (CASSANDRA-13430)
 * Change protocol to allow sending key space independent of query string (CASSANDRA-10145)
 * Make gc_log and gc_warn settable at runtime (CASSANDRA-12661)
 * Take number of files in L0 in account when estimating remaining compaction tasks (CASSANDRA-13354)
 * Skip building views during base table streams on range movements (CASSANDRA-13065)
 * Improve error messages for +/- operations on maps and tuples (CASSANDRA-13197)
 * Remove deprecated repair JMX APIs (CASSANDRA-11530)
 * Fix version check to enable streaming keep-alive (CASSANDRA-12929)
 * Make it possible to monitor an ideal consistency level separate from actual consistency level (CASSANDRA-13289)
 * Outbound TCP connections ignore internode authenticator (CASSANDRA-13324)
 * Cleanup ParentRepairSession after repairs (CASSANDRA-13359)
 * Upgrade snappy-java to 1.1.2.6 (CASSANDRA-13336)
 * Incremental repair not streaming correct sstables (CASSANDRA-13328)
 * Upgrade the jna version to 4.3.0 (CASSANDRA-13300)
 * Add the currentTimestamp, currentDate, currentTime and currentTimeUUID functions (CASSANDRA-13132)
 * Remove config option index_interval (CASSANDRA-10671)
 * Reduce lock contention for collection types and serializers (CASSANDRA-13271)
 * Make it possible to override MessagingService.Verb ids (CASSANDRA-13283)
 * Avoid synchronized on prepareForRepair in ActiveRepairService (CASSANDRA-9292)
 * Adds the ability to use uncompressed chunks in compressed files (CASSANDRA-10520)
 * Don't flush sstables when streaming for incremental repair (CASSANDRA-13226)
 * Remove unused method (CASSANDRA-13227)
 * Fix minor bugs related to #9143 (CASSANDRA-13217)
 * Output warning if user increases RF (CASSANDRA-13079)
 * Remove pre-3.0 streaming compatibility code for 4.0 (CASSANDRA-13081)
 * Add support for + and - operations on dates (CASSANDRA-11936)
 * Fix consistency of incrementally repaired data (CASSANDRA-9143)
 * Increase commitlog version (CASSANDRA-13161)
 * Make TableMetadata immutable, optimize Schema (CASSANDRA-9425)
 * Refactor ColumnCondition (CASSANDRA-12981)
 * Parallelize streaming of different keyspaces (CASSANDRA-4663)
 * Improved compactions metrics (CASSANDRA-13015)
 * Speed-up start-up sequence by avoiding un-needed flushes (CASSANDRA-13031)
 * Use Caffeine (W-TinyLFU) for on-heap caches (CASSANDRA-10855)
 * Thrift removal (CASSANDRA-11115)
 * Remove pre-3.0 compatibility code for 4.0 (CASSANDRA-12716)
 * Add column definition kind to dropped columns in schema (CASSANDRA-12705)
 * Add (automate) Nodetool Documentation (CASSANDRA-12672)
 * Update bundled cqlsh python driver to 3.7.0 (CASSANDRA-12736)
 * Reject invalid replication settings when creating or altering a keyspace (CASSANDRA-12681)
 * Clean up the SSTableReader#getScanner API wrt removal of RateLimiter (CASSANDRA-12422)
 * Use new token allocation for non bootstrap case as well (CASSANDRA-13080)
 * Avoid byte-array copy when key cache is disabled (CASSANDRA-13084)
 * Require forceful decommission if number of nodes is less than replication factor (CASSANDRA-12510)
 * Allow IN restrictions on column families with collections (CASSANDRA-12654)
 * Log message size in trace message in OutboundTcpConnection (CASSANDRA-13028)
 * Add timeUnit Days for cassandra-stress (CASSANDRA-13029)
 * Add mutation size and batch metrics (CASSANDRA-12649)
 * Add method to get size of endpoints to TokenMetadata (CASSANDRA-12999)
 * Expose time spent waiting in thread pool queue (CASSANDRA-8398)
 * Conditionally update index built status to avoid unnecessary flushes (CASSANDRA-12969)
 * cqlsh auto completion: refactor definition of compaction strategy options (CASSANDRA-12946)
 * Add support for arithmetic operators (CASSANDRA-11935)
 * Add histogram for delay to deliver hints (CASSANDRA-13234)
 * Fix cqlsh automatic protocol downgrade regression (CASSANDRA-13307)
 * Changing `max_hint_window_in_ms` at runtime (CASSANDRA-11720)
 * Trivial format error in StorageProxy (CASSANDRA-13551)
 * Nodetool repair can hang forever if we lose the notification for the repair completing/failing (CASSANDRA-13480)
 * Anticompaction can cause noisy log messages (CASSANDRA-13684)
 * Switch to client init for sstabledump (CASSANDRA-13683)
 * CQLSH: Don't pause when capturing data (CASSANDRA-13743)
 * nodetool clearsnapshot requires --all to clear all snapshots (CASSANDRA-13391)
 * Correctly count range tombstones in traces and tombstone thresholds (CASSANDRA-8527)
 * cqlshrc.sample uses incorrect option for time formatting (CASSANDRA-14243)
 * Multi-version in-JVM dtests (CASSANDRA-14937)
 * Allow instance class loaders to be garbage collected for inJVM dtest (CASSANDRA-15170)


3.11.6
 * Fix bad UDT sstable metadata serialization headers written by C* 3.0 on upgrade and in sstablescrub (CASSANDRA-15035)
 * Fix nodetool compactionstats showing extra pending task for TWCS - patch implemented (CASSANDRA-15409)
 * Fix SELECT JSON formatting for the "duration" type (CASSANDRA-15075)
 * Fix LegacyLayout to have same behavior as 2.x when handling unknown column names (CASSANDRA-15081)
 * Update nodetool help stop output (CASSANDRA-15401)
Merged from 3.0:
 * Run in-jvm upgrade dtests in circleci (CASSANDRA-15506)
 * Include updates to static column in mutation size calculations (CASSANDRA-15293)
 * Fix point-in-time recoevery ignoring timestamp of updates to static columns (CASSANDRA-15292)
 * GC logs are also put under $CASSANDRA_LOG_DIR (CASSANDRA-14306)
 * Fix sstabledump's position key value when partitions have multiple rows (CASSANDRA-14721)
 * Avoid over-scanning data directories in LogFile.verify() (CASSANDRA-15364)
 * Bump generations and document changes to system_distributed and system_traces in 3.0, 3.11
   (CASSANDRA-15441)
 * Fix system_traces creation timestamp; optimise system keyspace upgrades (CASSANDRA-15398)
 * Fix various data directory prefix matching issues (CASSANDRA-13974)
 * Minimize clustering values in metadata collector (CASSANDRA-15400)
 * Avoid over-trimming of results in mixed mode clusters (CASSANDRA-15405)
 * validate value sizes in LegacyLayout (CASSANDRA-15373)
 * Ensure that tracing doesn't break connections in 3.x/4.0 mixed mode by default (CASSANDRA-15385)
 * Make sure index summary redistribution does not start when compactions are paused (CASSANDRA-15265)
 * Ensure legacy rows have primary key livenessinfo when they contain illegal cells (CASSANDRA-15365)
 * Fix race condition when setting bootstrap flags (CASSANDRA-14878)
Merged from 2.2:
 * Fix SELECT JSON output for empty blobs (CASSANDRA-15435)
 * In-JVM DTest: Set correct internode message version for upgrade test (CASSANDRA-15371)
 * In-JVM DTest: Support NodeTool in dtest (CASSANDRA-15429)
 * Fix NativeLibrary.tryOpenDirectory callers for Windows (CASSANDRA-15426)


3.11.5
 * Fix cassandra-env.sh to use $CASSANDRA_CONF to find cassandra-jaas.config (CASSANDRA-14305)
 * Fixed nodetool cfstats printing index name twice (CASSANDRA-14903)
 * Add flag to disable SASI indexes, and warnings on creation (CASSANDRA-14866)
Merged from 3.0:
 * Fix LegacyLayout RangeTombstoneList IndexOutOfBoundsException when upgrading and RangeTombstone bounds are asymmetric (CASSANDRA-15172)
 * Fix NPE when using allocate_tokens_for_keyspace on new DC/rack (CASSANDRA-14952)
 * Filter sstables earlier when running cleanup (CASSANDRA-15100)
 * Use mean row count instead of mean column count for index selectivity calculation (CASSANDRA-15259)
 * Avoid updating unchanged gossip states (CASSANDRA-15097)
 * Prevent recreation of previously dropped columns with a different kind (CASSANDRA-14948)
 * Prevent client requests from blocking on executor task queue (CASSANDRA-15013)
 * Toughen up column drop/recreate type validations (CASSANDRA-15204)
 * LegacyLayout should handle paging states that cross a collection column (CASSANDRA-15201)
 * Prevent RuntimeException when username or password is empty/null (CASSANDRA-15198)
 * Multiget thrift query returns null records after digest mismatch (CASSANDRA-14812)
 * Handle paging states serialized with a different version than the session's (CASSANDRA-15176)
 * Throw IOE instead of asserting on unsupporter peer versions (CASSANDRA-15066)
 * Update token metadata when handling MOVING/REMOVING_TOKEN events (CASSANDRA-15120)
 * Add ability to customize cassandra log directory using $CASSANDRA_LOG_DIR (CASSANDRA-15090)
 * Fix assorted gossip races and add related runtime checks (CASSANDRA-15059)
 * cassandra-stress works with frozen collections: list and set (CASSANDRA-14907)
 * Fix handling FS errors on writing and reading flat files - LogTransaction and hints (CASSANDRA-15053)
 * Avoid double closing the iterator to avoid overcounting the number of requests (CASSANDRA-15058)
 * Improve `nodetool status -r` speed (CASSANDRA-14847)
 * Improve merkle tree size and time on heap (CASSANDRA-14096)
 * Add missing commands to nodetool_completion (CASSANDRA-14916)
 * Anti-compaction temporarily corrupts sstable state for readers (CASSANDRA-15004)
Merged from 2.2:
 * Handle exceptions during authentication/authorization (CASSANDRA-15041)
 * Support cross version messaging in in-jvm upgrade dtests (CASSANDRA-15078)
 * Fix index summary redistribution cancellation (CASSANDRA-15045)
 * Refactor Circle CI configuration (CASSANDRA-14806)
 * Fixing invalid CQL in security documentation (CASSANDRA-15020)


3.11.4
 * Make stop-server.bat wait for Cassandra to terminate (CASSANDRA-14829)
 * Correct sstable sorting for garbagecollect and levelled compaction (CASSANDRA-14870)
Merged from 3.0:
 * Improve merkle tree size and time on heap (CASSANDRA-14096)
 * Severe concurrency issues in STCS,DTCS,TWCS,TMD.Topology,TypeParser
 * Add a script to make running the cqlsh tests in cassandra repo easier (CASSANDRA-14951)
 * If SizeEstimatesRecorder misses a 'onDropTable' notification, the size_estimates table will never be cleared for that table. (CASSANDRA-14905)
 * Streaming needs to synchronise access to LifecycleTransaction (CASSANDRA-14554)
 * Fix cassandra-stress write hang with default options (CASSANDRA-14616)
 * Netty epoll IOExceptions caused by unclean client disconnects being logged at INFO (CASSANDRA-14909)
 * Unfiltered.isEmpty conflicts with Row extends AbstractCollection.isEmpty (CASSANDRA-14588)
 * RangeTombstoneList doesn't properly clean up mergeable or superseded rts in some cases (CASSANDRA-14894)
 * Fix handling of collection tombstones for dropped columns from legacy sstables (CASSANDRA-14912)
 * Throw exception if Columns serialized subset encode more columns than possible (CASSANDRA-14591)
 * Drop/add column name with different Kind can result in corruption (CASSANDRA-14843)
 * Fix missing rows when reading 2.1 SSTables with static columns in 3.0 (CASSANDRA-14873)
 * Move TWCS message 'No compaction necessary for bucket size' to Trace level (CASSANDRA-14884)
 * Sstable min/max metadata can cause data loss (CASSANDRA-14861)
 * Dropped columns can cause reverse sstable iteration to return prematurely (CASSANDRA-14838)
 * Legacy sstables with  multi block range tombstones create invalid bound sequences (CASSANDRA-14823)
 * Expand range tombstone validation checks to multiple interim request stages (CASSANDRA-14824)
 * Reverse order reads can return incomplete results (CASSANDRA-14803)
 * Avoid calling iter.next() in a loop when notifying indexers about range tombstones (CASSANDRA-14794)
 * Fix purging semi-expired RT boundaries in reversed iterators (CASSANDRA-14672)
 * DESC order reads can fail to return the last Unfiltered in the partition (CASSANDRA-14766)
 * Fix corrupted collection deletions for dropped columns in 3.0 <-> 2.{1,2} messages (CASSANDRA-14568)
 * Fix corrupted static collection deletions in 3.0 <-> 2.{1,2} messages (CASSANDRA-14568)
 * Handle failures in parallelAllSSTableOperation (cleanup/upgradesstables/etc) (CASSANDRA-14657)
 * Improve TokenMetaData cache populating performance avoid long locking (CASSANDRA-14660)
 * Backport: Flush netty client messages immediately (not by default) (CASSANDRA-13651)
 * Fix static column order for SELECT * wildcard queries (CASSANDRA-14638)
 * sstableloader should use discovered broadcast address to connect intra-cluster (CASSANDRA-14522)
 * Fix reading columns with non-UTF names from schema (CASSANDRA-14468)
Merged from 2.2:
 * CircleCI docker image should bake in more dependencies (CASSANDRA-14985)
 * MigrationManager attempts to pull schema from different major version nodes (CASSANDRA-14928)
 * Returns null instead of NaN or Infinity in JSON strings (CASSANDRA-14377)
Merged from 2.1:
 * Paged Range Slice queries with DISTINCT can drop rows from results (CASSANDRA-14956)
 * Update release checksum algorithms to SHA-256, SHA-512 (CASSANDRA-14970)


3.11.3
 * Validate supported column type with SASI analyzer (CASSANDRA-13669)
 * Remove BTree.Builder Recycler to reduce memory usage (CASSANDRA-13929)
 * Reduce nodetool GC thread count (CASSANDRA-14475)
 * Fix New SASI view creation during Index Redistribution (CASSANDRA-14055)
 * Remove string formatting lines from BufferPool hot path (CASSANDRA-14416)
 * Detect OpenJDK jvm type and architecture (CASSANDRA-12793)
 * Don't use guava collections in the non-system keyspace jmx attributes (CASSANDRA-12271)
 * Allow existing nodes to use all peers in shadow round (CASSANDRA-13851)
 * Fix cqlsh to read connection.ssl cqlshrc option again (CASSANDRA-14299)
 * Downgrade log level to trace for CommitLogSegmentManager (CASSANDRA-14370)
 * CQL fromJson(null) throws NullPointerException (CASSANDRA-13891)
 * Serialize empty buffer as empty string for json output format (CASSANDRA-14245)
 * Allow logging implementation to be interchanged for embedded testing (CASSANDRA-13396)
 * SASI tokenizer for simple delimiter based entries (CASSANDRA-14247)
 * Fix Loss of digits when doing CAST from varint/bigint to decimal (CASSANDRA-14170)
 * RateBasedBackPressure unnecessarily invokes a lock on the Guava RateLimiter (CASSANDRA-14163)
 * Fix wildcard GROUP BY queries (CASSANDRA-14209)
Merged from 3.0:
 * Fix corrupted static collection deletions in 3.0 -> 2.{1,2} messages (CASSANDRA-14568)
 * Fix potential IndexOutOfBoundsException with counters (CASSANDRA-14167)
 * Always close RT markers returned by ReadCommand#executeLocally() (CASSANDRA-14515)
 * Reverse order queries with range tombstones can cause data loss (CASSANDRA-14513)
 * Fix regression of lagging commitlog flush log message (CASSANDRA-14451)
 * Add Missing dependencies in pom-all (CASSANDRA-14422)
 * Cleanup StartupClusterConnectivityChecker and PING Verb (CASSANDRA-14447)
 * Cassandra not starting when using enhanced startup scripts in windows (CASSANDRA-14418)
 * Fix progress stats and units in compactionstats (CASSANDRA-12244)
 * Better handle missing partition columns in system_schema.columns (CASSANDRA-14379)
 * Delay hints store excise by write timeout to avoid race with decommission (CASSANDRA-13740)
 * Add missed CQL keywords to documentation (CASSANDRA-14359)
 * Fix unbounded validation compactions on repair / revert CASSANDRA-13797 (CASSANDRA-14332)
 * Avoid deadlock when running nodetool refresh before node is fully up (CASSANDRA-14310)
 * Handle all exceptions when opening sstables (CASSANDRA-14202)
 * Handle incompletely written hint descriptors during startup (CASSANDRA-14080)
 * Handle repeat open bound from SRP in read repair (CASSANDRA-14330)
 * Use zero as default score in DynamicEndpointSnitch (CASSANDRA-14252)
 * Respect max hint window when hinting for LWT (CASSANDRA-14215)
 * Adding missing WriteType enum values to v3, v4, and v5 spec (CASSANDRA-13697)
 * Don't regenerate bloomfilter and summaries on startup (CASSANDRA-11163)
 * Fix NPE when performing comparison against a null frozen in LWT (CASSANDRA-14087)
 * Log when SSTables are deleted (CASSANDRA-14302)
 * Fix batch commitlog sync regression (CASSANDRA-14292)
 * Write to pending endpoint when view replica is also base replica (CASSANDRA-14251)
 * Chain commit log marker potential performance regression in batch commit mode (CASSANDRA-14194)
 * Fully utilise specified compaction threads (CASSANDRA-14210)
 * Pre-create deletion log records to finish compactions quicker (CASSANDRA-12763)
Merged from 2.2:
 * Fix compaction failure caused by reading un-flushed data (CASSANDRA-12743)
 * Use Bounds instead of Range for sstables in anticompaction (CASSANDRA-14411)
 * Fix JSON queries with IN restrictions and ORDER BY clause (CASSANDRA-14286)
 * CQL fromJson(null) throws NullPointerException (CASSANDRA-13891)
Merged from 2.1:
 * Check checksum before decompressing data (CASSANDRA-14284)


3.11.2
 * Fix ReadCommandTest (CASSANDRA-14234)
 * Remove trailing period from latency reports at keyspace level (CASSANDRA-14233)
 * Backport CASSANDRA-13080: Use new token allocation for non bootstrap case as well (CASSANDRA-14212)
 * Remove dependencies on JVM internal classes from JMXServerUtils (CASSANDRA-14173)
 * Add DEFAULT, UNSET, MBEAN and MBEANS to `ReservedKeywords` (CASSANDRA-14205)
 * Print correct snitch info from nodetool describecluster (CASSANDRA-13528)
 * Enable CDC unittest (CASSANDRA-14141)
 * Acquire read lock before accessing CompactionStrategyManager fields (CASSANDRA-14139)
 * Avoid invalidating disk boundaries unnecessarily (CASSANDRA-14083)
 * Avoid exposing compaction strategy index externally (CASSANDRA-14082)
 * Fix imbalanced disks when replacing node with same address with JBOD (CASSANDRA-14084)
 * Reload compaction strategies when disk boundaries are invalidated (CASSANDRA-13948)
 * Remove OpenJDK log warning (CASSANDRA-13916)
 * Prevent compaction strategies from looping indefinitely (CASSANDRA-14079)
 * Cache disk boundaries (CASSANDRA-13215)
 * Add asm jar to build.xml for maven builds (CASSANDRA-11193)
 * Round buffer size to powers of 2 for the chunk cache (CASSANDRA-13897)
 * Update jackson JSON jars (CASSANDRA-13949)
 * Avoid locks when checking LCS fanout and if we should defrag (CASSANDRA-13930)
Merged from 3.0:
 * Fix unit test failures in ViewComplexTest (CASSANDRA-14219)
 * Add MinGW uname check to start scripts (CASSANDRA-12840)
 * Use the correct digest file and reload sstable metadata in nodetool verify (CASSANDRA-14217)
 * Handle failure when mutating repaired status in Verifier (CASSANDRA-13933)
 * Set encoding for javadoc generation (CASSANDRA-14154)
 * Fix index target computation for dense composite tables with dropped compact storage (CASSANDRA-14104)
 * Improve commit log chain marker updating (CASSANDRA-14108)
 * Extra range tombstone bound creates double rows (CASSANDRA-14008)
 * Fix SStable ordering by max timestamp in SinglePartitionReadCommand (CASSANDRA-14010)
 * Accept role names containing forward-slash (CASSANDRA-14088)
 * Optimize CRC check chance probability calculations (CASSANDRA-14094)
 * Fix cleanup on keyspace with no replicas (CASSANDRA-13526)
 * Fix updating base table rows with TTL not removing materialized view entries (CASSANDRA-14071)
 * Reduce garbage created by DynamicSnitch (CASSANDRA-14091)
 * More frequent commitlog chained markers (CASSANDRA-13987)
 * Fix serialized size of DataLimits (CASSANDRA-14057)
 * Add flag to allow dropping oversized read repair mutations (CASSANDRA-13975)
 * Fix SSTableLoader logger message (CASSANDRA-14003)
 * Fix repair race that caused gossip to block (CASSANDRA-13849)
 * Tracing interferes with digest requests when using RandomPartitioner (CASSANDRA-13964)
 * Add flag to disable materialized views, and warnings on creation (CASSANDRA-13959)
 * Don't let user drop or generally break tables in system_distributed (CASSANDRA-13813)
 * Provide a JMX call to sync schema with local storage (CASSANDRA-13954)
 * Mishandling of cells for removed/dropped columns when reading legacy files (CASSANDRA-13939)
 * Deserialise sstable metadata in nodetool verify (CASSANDRA-13922)
Merged from 2.2:
 * Fix the inspectJvmOptions startup check (CASSANDRA-14112)
 * Fix race that prevents submitting compaction for a table when executor is full (CASSANDRA-13801)
 * Rely on the JVM to handle OutOfMemoryErrors (CASSANDRA-13006)
 * Grab refs during scrub/index redistribution/cleanup (CASSANDRA-13873)
Merged from 2.1:
 * Protect against overflow of local expiration time (CASSANDRA-14092)
 * RPM package spec: fix permissions for installed jars and config files (CASSANDRA-14181)
 * More PEP8 compliance for cqlsh


3.11.1
 * Fix the computation of cdc_total_space_in_mb for exabyte filesystems (CASSANDRA-13808)
 * AbstractTokenTreeBuilder#serializedSize returns wrong value when there is a single leaf and overflow collisions (CASSANDRA-13869)
 * Add a compaction option to TWCS to ignore sstables overlapping checks (CASSANDRA-13418)
 * BTree.Builder memory leak (CASSANDRA-13754)
 * Revert CASSANDRA-10368 of supporting non-pk column filtering due to correctness (CASSANDRA-13798)
 * Add a skip read validation flag to cassandra-stress (CASSANDRA-13772)
 * Fix cassandra-stress hang issues when an error during cluster connection happens (CASSANDRA-12938)
 * Better bootstrap failure message when blocked by (potential) range movement (CASSANDRA-13744)
 * "ignore" option is ignored in sstableloader (CASSANDRA-13721)
 * Deadlock in AbstractCommitLogSegmentManager (CASSANDRA-13652)
 * Duplicate the buffer before passing it to analyser in SASI operation (CASSANDRA-13512)
 * Properly evict pstmts from prepared statements cache (CASSANDRA-13641)
Merged from 3.0:
 * Improve TRUNCATE performance (CASSANDRA-13909)
 * Implement short read protection on partition boundaries (CASSANDRA-13595)
 * Fix ISE thrown by UPI.Serializer.hasNext() for some SELECT queries (CASSANDRA-13911)
 * Filter header only commit logs before recovery (CASSANDRA-13918)
 * AssertionError prepending to a list (CASSANDRA-13149)
 * Fix support for SuperColumn tables (CASSANDRA-12373)
 * Handle limit correctly on tables with strict liveness (CASSANDRA-13883)
 * Fix missing original update in TriggerExecutor (CASSANDRA-13894)
 * Remove non-rpc-ready nodes from counter leader candidates (CASSANDRA-13043)
 * Improve short read protection performance (CASSANDRA-13794)
 * Fix sstable reader to support range-tombstone-marker for multi-slices (CASSANDRA-13787)
 * Fix short read protection for tables with no clustering columns (CASSANDRA-13880)
 * Make isBuilt volatile in PartitionUpdate (CASSANDRA-13619)
 * Prevent integer overflow of timestamps in CellTest and RowsTest (CASSANDRA-13866)
 * Fix counter application order in short read protection (CASSANDRA-12872)
 * Don't block RepairJob execution on validation futures (CASSANDRA-13797)
 * Wait for all management tasks to complete before shutting down CLSM (CASSANDRA-13123)
 * INSERT statement fails when Tuple type is used as clustering column with default DESC order (CASSANDRA-13717)
 * Fix pending view mutations handling and cleanup batchlog when there are local and remote paired mutations (CASSANDRA-13069)
 * Improve config validation and documentation on overflow and NPE (CASSANDRA-13622)
 * Range deletes in a CAS batch are ignored (CASSANDRA-13655)
 * Avoid assertion error when IndexSummary > 2G (CASSANDRA-12014)
 * Change repair midpoint logging for tiny ranges (CASSANDRA-13603)
 * Better handle corrupt final commitlog segment (CASSANDRA-11995)
 * StreamingHistogram is not thread safe (CASSANDRA-13756)
 * Fix MV timestamp issues (CASSANDRA-11500)
 * Better tolerate improperly formatted bcrypt hashes (CASSANDRA-13626)
 * Fix race condition in read command serialization (CASSANDRA-13363)
 * Fix AssertionError in short read protection (CASSANDRA-13747)
 * Don't skip corrupted sstables on startup (CASSANDRA-13620)
 * Fix the merging of cells with different user type versions (CASSANDRA-13776)
 * Copy session properties on cqlsh.py do_login (CASSANDRA-13640)
 * Potential AssertionError during ReadRepair of range tombstone and partition deletions (CASSANDRA-13719)
 * Don't let stress write warmup data if n=0 (CASSANDRA-13773)
 * Gossip thread slows down when using batch commit log (CASSANDRA-12966)
 * Randomize batchlog endpoint selection with only 1 or 2 racks (CASSANDRA-12884)
 * Fix digest calculation for counter cells (CASSANDRA-13750)
 * Fix ColumnDefinition.cellValueType() for non-frozen collection and change SSTabledump to use type.toJSONString() (CASSANDRA-13573)
 * Skip materialized view addition if the base table doesn't exist (CASSANDRA-13737)
 * Drop table should remove corresponding entries in dropped_columns table (CASSANDRA-13730)
 * Log warn message until legacy auth tables have been migrated (CASSANDRA-13371)
 * Fix incorrect [2.1 <- 3.0] serialization of counter cells created in 2.0 (CASSANDRA-13691)
 * Fix invalid writetime for null cells (CASSANDRA-13711)
 * Fix ALTER TABLE statement to atomically propagate changes to the table and its MVs (CASSANDRA-12952)
 * Fixed ambiguous output of nodetool tablestats command (CASSANDRA-13722)
 * Fix Digest mismatch Exception if hints file has UnknownColumnFamily (CASSANDRA-13696)
 * Purge tombstones created by expired cells (CASSANDRA-13643)
 * Make concat work with iterators that have different subsets of columns (CASSANDRA-13482)
 * Set test.runners based on cores and memory size (CASSANDRA-13078)
 * Allow different NUMACTL_ARGS to be passed in (CASSANDRA-13557)
 * Allow native function calls in CQLSSTableWriter (CASSANDRA-12606)
 * Fix secondary index queries on COMPACT tables (CASSANDRA-13627)
 * Nodetool listsnapshots output is missing a newline, if there are no snapshots (CASSANDRA-13568)
 * sstabledump reports incorrect usage for argument order (CASSANDRA-13532)
Merged from 2.2:
 * Safely handle empty buffers when outputting to JSON (CASSANDRA-13868)
 * Copy session properties on cqlsh.py do_login (CASSANDRA-13847)
 * Fix load over calculated issue in IndexSummaryRedistribution (CASSANDRA-13738)
 * Fix compaction and flush exception not captured (CASSANDRA-13833)
 * Uncaught exceptions in Netty pipeline (CASSANDRA-13649)
 * Prevent integer overflow on exabyte filesystems (CASSANDRA-13067)
 * Fix queries with LIMIT and filtering on clustering columns (CASSANDRA-11223)
 * Fix potential NPE when resume bootstrap fails (CASSANDRA-13272)
 * Fix toJSONString for the UDT, tuple and collection types (CASSANDRA-13592)
 * Fix nested Tuples/UDTs validation (CASSANDRA-13646)
Merged from 2.1:
 * Clone HeartBeatState when building gossip messages. Make its generation/version volatile (CASSANDRA-13700)


3.11.0
 * Allow native function calls in CQLSSTableWriter (CASSANDRA-12606)
 * Replace string comparison with regex/number checks in MessagingService test (CASSANDRA-13216)
 * Fix formatting of duration columns in CQLSH (CASSANDRA-13549)
 * Fix the problem with duplicated rows when using paging with SASI (CASSANDRA-13302)
 * Allow CONTAINS statements filtering on the partition key and it’s parts (CASSANDRA-13275)
 * Fall back to even ranges calculation in clusters with vnodes when tokens are distributed unevenly (CASSANDRA-13229)
 * Fix duration type validation to prevent overflow (CASSANDRA-13218)
 * Forbid unsupported creation of SASI indexes over partition key columns (CASSANDRA-13228)
 * Reject multiple values for a key in CQL grammar. (CASSANDRA-13369)
 * UDA fails without input rows (CASSANDRA-13399)
 * Fix compaction-stress by using daemonInitialization (CASSANDRA-13188)
 * V5 protocol flags decoding broken (CASSANDRA-13443)
 * Use write lock not read lock for removing sstables from compaction strategies. (CASSANDRA-13422)
 * Use corePoolSize equal to maxPoolSize in JMXEnabledThreadPoolExecutors (CASSANDRA-13329)
 * Avoid rebuilding SASI indexes containing no values (CASSANDRA-12962)
 * Add charset to Analyser input stream (CASSANDRA-13151)
 * Fix testLimitSSTables flake caused by concurrent flush (CASSANDRA-12820)
 * cdc column addition strikes again (CASSANDRA-13382)
 * Fix static column indexes (CASSANDRA-13277)
 * DataOutputBuffer.asNewBuffer broken (CASSANDRA-13298)
 * unittest CipherFactoryTest failed on MacOS (CASSANDRA-13370)
 * Forbid SELECT restrictions and CREATE INDEX over non-frozen UDT columns (CASSANDRA-13247)
 * Default logging we ship will incorrectly print "?:?" for "%F:%L" pattern (CASSANDRA-13317)
 * Possible AssertionError in UnfilteredRowIteratorWithLowerBound (CASSANDRA-13366)
 * Support unaligned memory access for AArch64 (CASSANDRA-13326)
 * Improve SASI range iterator efficiency on intersection with an empty range (CASSANDRA-12915).
 * Fix equality comparisons of columns using the duration type (CASSANDRA-13174)
 * Move to FastThreadLocalThread and FastThreadLocal (CASSANDRA-13034)
 * nodetool stopdaemon errors out (CASSANDRA-13030)
 * Tables in system_distributed should not use gcgs of 0 (CASSANDRA-12954)
 * Fix primary index calculation for SASI (CASSANDRA-12910)
 * More fixes to the TokenAllocator (CASSANDRA-12990)
 * NoReplicationTokenAllocator should work with zero replication factor (CASSANDRA-12983)
 * Address message coalescing regression (CASSANDRA-12676)
 * Delete illegal character from StandardTokenizerImpl.jflex (CASSANDRA-13417)
 * Fix cqlsh automatic protocol downgrade regression (CASSANDRA-13307)
 * Tracing payload not passed from QueryMessage to tracing session (CASSANDRA-12835)
Merged from 3.0:
 * Filter header only commit logs before recovery (CASSANDRA-13918)
 * Ensure int overflow doesn't occur when calculating large partition warning size (CASSANDRA-13172)
 * Ensure consistent view of partition columns between coordinator and replica in ColumnFilter (CASSANDRA-13004)
 * Failed unregistering mbean during drop keyspace (CASSANDRA-13346)
 * nodetool scrub/cleanup/upgradesstables exit code is wrong (CASSANDRA-13542)
 * Fix the reported number of sstable data files accessed per read (CASSANDRA-13120)
 * Fix schema digest mismatch during rolling upgrades from versions before 3.0.12 (CASSANDRA-13559)
 * Upgrade JNA version to 4.4.0 (CASSANDRA-13072)
 * Interned ColumnIdentifiers should use minimal ByteBuffers (CASSANDRA-13533)
 * Fix repair process violating start/end token limits for small ranges (CASSANDRA-13052)
 * Add storage port options to sstableloader (CASSANDRA-13518)
 * Properly handle quoted index names in cqlsh DESCRIBE output (CASSANDRA-12847)
 * Fix NPE in StorageService.excise() (CASSANDRA-13163)
 * Expire OutboundTcpConnection messages by a single Thread (CASSANDRA-13265)
 * Fail repair if insufficient responses received (CASSANDRA-13397)
 * Fix SSTableLoader fail when the loaded table contains dropped columns (CASSANDRA-13276)
 * Avoid name clashes in CassandraIndexTest (CASSANDRA-13427)
 * Handling partially written hint files (CASSANDRA-12728)
 * Interrupt replaying hints on decommission (CASSANDRA-13308)
 * Handling partially written hint files (CASSANDRA-12728)
 * Fix NPE issue in StorageService (CASSANDRA-13060)
 * Make reading of range tombstones more reliable (CASSANDRA-12811)
 * Fix startup problems due to schema tables not completely flushed (CASSANDRA-12213)
 * Fix view builder bug that can filter out data on restart (CASSANDRA-13405)
 * Fix 2i page size calculation when there are no regular columns (CASSANDRA-13400)
 * Fix the conversion of 2.X expired rows without regular column data (CASSANDRA-13395)
 * Fix hint delivery when using ext+internal IPs with prefer_local enabled (CASSANDRA-13020)
 * Legacy deserializer can create empty range tombstones (CASSANDRA-13341)
 * Legacy caching options can prevent 3.0 upgrade (CASSANDRA-13384)
 * Use the Kernel32 library to retrieve the PID on Windows and fix startup checks (CASSANDRA-13333)
 * Fix code to not exchange schema across major versions (CASSANDRA-13274)
 * Dropping column results in "corrupt" SSTable (CASSANDRA-13337)
 * Bugs handling range tombstones in the sstable iterators (CASSANDRA-13340)
 * Fix CONTAINS filtering for null collections (CASSANDRA-13246)
 * Applying: Use a unique metric reservoir per test run when using Cassandra-wide metrics residing in MBeans (CASSANDRA-13216)
 * Propagate row deletions in 2i tables on upgrade (CASSANDRA-13320)
 * Slice.isEmpty() returns false for some empty slices (CASSANDRA-13305)
 * Add formatted row output to assertEmpty in CQL Tester (CASSANDRA-13238)
 * Prevent data loss on upgrade 2.1 - 3.0 by adding component separator to LogRecord absolute path (CASSANDRA-13294)
 * Improve testing on macOS by eliminating sigar logging (CASSANDRA-13233)
 * Cqlsh copy-from should error out when csv contains invalid data for collections (CASSANDRA-13071)
 * Fix "multiple versions of ant detected..." when running ant test (CASSANDRA-13232)
 * Coalescing strategy sleeps too much (CASSANDRA-13090)
 * Faster StreamingHistogram (CASSANDRA-13038)
 * Legacy deserializer can create unexpected boundary range tombstones (CASSANDRA-13237)
 * Remove unnecessary assertion from AntiCompactionTest (CASSANDRA-13070)
 * Fix cqlsh COPY for dates before 1900 (CASSANDRA-13185)
 * Use keyspace replication settings on system.size_estimates table (CASSANDRA-9639)
 * Add vm.max_map_count StartupCheck (CASSANDRA-13008)
 * Obfuscate password in stress-graphs (CASSANDRA-12233)
 * Hint related logging should include the IP address of the destination in addition to
   host ID (CASSANDRA-13205)
 * Reloading logback.xml does not work (CASSANDRA-13173)
 * Lightweight transactions temporarily fail after upgrade from 2.1 to 3.0 (CASSANDRA-13109)
 * Duplicate rows after upgrading from 2.1.16 to 3.0.10/3.9 (CASSANDRA-13125)
 * Fix UPDATE queries with empty IN restrictions (CASSANDRA-13152)
 * Fix handling of partition with partition-level deletion plus
   live rows in sstabledump (CASSANDRA-13177)
 * Provide user workaround when system_schema.columns does not contain entries
   for a table that's in system_schema.tables (CASSANDRA-13180)
 * Nodetool upgradesstables/scrub/compact ignores system tables (CASSANDRA-13410)
 * Fix schema version calculation for rolling upgrades (CASSANDRA-13441)
Merged from 2.2:
 * Nodes started with join_ring=False should be able to serve requests when authentication is enabled (CASSANDRA-11381)
 * cqlsh COPY FROM: increment error count only for failures, not for attempts (CASSANDRA-13209)
 * Avoid starting gossiper in RemoveTest (CASSANDRA-13407)
 * Fix weightedSize() for row-cache reported by JMX and NodeTool (CASSANDRA-13393)
 * Fix JVM metric names (CASSANDRA-13103)
 * Honor truststore-password parameter in cassandra-stress (CASSANDRA-12773)
 * Discard in-flight shadow round responses (CASSANDRA-12653)
 * Don't anti-compact repaired data to avoid inconsistencies (CASSANDRA-13153)
 * Wrong logger name in AnticompactionTask (CASSANDRA-13343)
 * Commitlog replay may fail if last mutation is within 4 bytes of end of segment (CASSANDRA-13282)
 * Fix queries updating multiple time the same list (CASSANDRA-13130)
 * Fix GRANT/REVOKE when keyspace isn't specified (CASSANDRA-13053)
 * Fix flaky LongLeveledCompactionStrategyTest (CASSANDRA-12202)
 * Fix failing COPY TO STDOUT (CASSANDRA-12497)
 * Fix ColumnCounter::countAll behaviour for reverse queries (CASSANDRA-13222)
 * Exceptions encountered calling getSeeds() breaks OTC thread (CASSANDRA-13018)
 * Fix negative mean latency metric (CASSANDRA-12876)
 * Use only one file pointer when creating commitlog segments (CASSANDRA-12539)
Merged from 2.1:
 * Fix 2ndary index queries on partition keys for tables with static columns (CASSANDRA-13147)
 * Fix ParseError unhashable type list in cqlsh copy from (CASSANDRA-13364)
 * Remove unused repositories (CASSANDRA-13278)
 * Log stacktrace of uncaught exceptions (CASSANDRA-13108)
 * Use portable stderr for java error in startup (CASSANDRA-13211)
 * Fix Thread Leak in OutboundTcpConnection (CASSANDRA-13204)
 * Upgrade netty version to fix memory leak with client encryption (CASSANDRA-13114)
 * Coalescing strategy can enter infinite loop (CASSANDRA-13159)


3.10
 * Fix secondary index queries regression (CASSANDRA-13013)
 * Add duration type to the protocol V5 (CASSANDRA-12850)
 * Fix duration type validation (CASSANDRA-13143)
 * Fix flaky GcCompactionTest (CASSANDRA-12664)
 * Fix TestHintedHandoff.hintedhandoff_decom_test (CASSANDRA-13058)
 * Fixed query monitoring for range queries (CASSANDRA-13050)
 * Remove outboundBindAny configuration property (CASSANDRA-12673)
 * Use correct bounds for all-data range when filtering (CASSANDRA-12666)
 * Remove timing window in test case (CASSANDRA-12875)
 * Resolve unit testing without JCE security libraries installed (CASSANDRA-12945)
 * Fix inconsistencies in cassandra-stress load balancing policy (CASSANDRA-12919)
 * Fix validation of non-frozen UDT cells (CASSANDRA-12916)
 * Don't shut down socket input/output on StreamSession (CASSANDRA-12903)
 * Fix Murmur3PartitionerTest (CASSANDRA-12858)
 * Move cqlsh syntax rules into separate module and allow easier customization (CASSANDRA-12897)
 * Fix CommitLogSegmentManagerTest (CASSANDRA-12283)
 * Fix cassandra-stress truncate option (CASSANDRA-12695)
 * Fix crossNode value when receiving messages (CASSANDRA-12791)
 * Don't load MX4J beans twice (CASSANDRA-12869)
 * Extend native protocol request flags, add versions to SUPPORTED, and introduce ProtocolVersion enum (CASSANDRA-12838)
 * Set JOINING mode when running pre-join tasks (CASSANDRA-12836)
 * remove net.mintern.primitive library due to license issue (CASSANDRA-12845)
 * Properly format IPv6 addresses when logging JMX service URL (CASSANDRA-12454)
 * Optimize the vnode allocation for single replica per DC (CASSANDRA-12777)
 * Use non-token restrictions for bounds when token restrictions are overridden (CASSANDRA-12419)
 * Fix CQLSH auto completion for PER PARTITION LIMIT (CASSANDRA-12803)
 * Use different build directories for Eclipse and Ant (CASSANDRA-12466)
 * Avoid potential AttributeError in cqlsh due to no table metadata (CASSANDRA-12815)
 * Fix RandomReplicationAwareTokenAllocatorTest.testExistingCluster (CASSANDRA-12812)
 * Upgrade commons-codec to 1.9 (CASSANDRA-12790)
 * Add duration data type (CASSANDRA-11873)
 * Make the fanout size for LeveledCompactionStrategy to be configurable (CASSANDRA-11550)
 * Fix timeout in ReplicationAwareTokenAllocatorTest (CASSANDRA-12784)
 * Improve sum aggregate functions (CASSANDRA-12417)
 * Make cassandra.yaml docs for batch_size_*_threshold_in_kb reflect changes in CASSANDRA-10876 (CASSANDRA-12761)
 * cqlsh fails to format collections when using aliases (CASSANDRA-11534)
 * Check for hash conflicts in prepared statements (CASSANDRA-12733)
 * Exit query parsing upon first error (CASSANDRA-12598)
 * Fix cassandra-stress to use single seed in UUID generation (CASSANDRA-12729)
 * CQLSSTableWriter does not allow Update statement (CASSANDRA-12450)
 * Config class uses boxed types but DD exposes primitive types (CASSANDRA-12199)
 * Add pre- and post-shutdown hooks to Storage Service (CASSANDRA-12461)
 * Add hint delivery metrics (CASSANDRA-12693)
 * Remove IndexInfo cache from FileIndexInfoRetriever (CASSANDRA-12731)
 * ColumnIndex does not reuse buffer (CASSANDRA-12502)
 * cdc column addition still breaks schema migration tasks (CASSANDRA-12697)
 * Upgrade metrics-reporter dependencies (CASSANDRA-12089)
 * Tune compaction thread count via nodetool (CASSANDRA-12248)
 * Add +=/-= shortcut syntax for update queries (CASSANDRA-12232)
 * Include repair session IDs in repair start message (CASSANDRA-12532)
 * Add a blocking task to Index, run before joining the ring (CASSANDRA-12039)
 * Fix NPE when using CQLSSTableWriter (CASSANDRA-12667)
 * Support optional backpressure strategies at the coordinator (CASSANDRA-9318)
 * Make randompartitioner work with new vnode allocation (CASSANDRA-12647)
 * Fix cassandra-stress graphing (CASSANDRA-12237)
 * Allow filtering on partition key columns for queries without secondary indexes (CASSANDRA-11031)
 * Fix Cassandra Stress reporting thread model and precision (CASSANDRA-12585)
 * Add JMH benchmarks.jar (CASSANDRA-12586)
 * Cleanup uses of AlterTableStatementColumn (CASSANDRA-12567)
 * Add keep-alive to streaming (CASSANDRA-11841)
 * Tracing payload is passed through newSession(..) (CASSANDRA-11706)
 * avoid deleting non existing sstable files and improve related log messages (CASSANDRA-12261)
 * json/yaml output format for nodetool compactionhistory (CASSANDRA-12486)
 * Retry all internode messages once after a connection is
   closed and reopened (CASSANDRA-12192)
 * Add support to rebuild from targeted replica (CASSANDRA-9875)
 * Add sequence distribution type to cassandra stress (CASSANDRA-12490)
 * "SELECT * FROM foo LIMIT ;" does not error out (CASSANDRA-12154)
 * Define executeLocally() at the ReadQuery Level (CASSANDRA-12474)
 * Extend read/write failure messages with a map of replica addresses
   to error codes in the v5 native protocol (CASSANDRA-12311)
 * Fix rebuild of SASI indexes with existing index files (CASSANDRA-12374)
 * Let DatabaseDescriptor not implicitly startup services (CASSANDRA-9054, 12550)
 * Fix clustering indexes in presence of static columns in SASI (CASSANDRA-12378)
 * Fix queries on columns with reversed type on SASI indexes (CASSANDRA-12223)
 * Added slow query log (CASSANDRA-12403)
 * Count full coordinated request against timeout (CASSANDRA-12256)
 * Allow TTL with null value on insert and update (CASSANDRA-12216)
 * Make decommission operation resumable (CASSANDRA-12008)
 * Add support to one-way targeted repair (CASSANDRA-9876)
 * Remove clientutil jar (CASSANDRA-11635)
 * Fix compaction throughput throttle (CASSANDRA-12366, CASSANDRA-12717)
 * Delay releasing Memtable memory on flush until PostFlush has finished running (CASSANDRA-12358)
 * Cassandra stress should dump all setting on startup (CASSANDRA-11914)
 * Make it possible to compact a given token range (CASSANDRA-10643)
 * Allow updating DynamicEndpointSnitch properties via JMX (CASSANDRA-12179)
 * Collect metrics on queries by consistency level (CASSANDRA-7384)
 * Add support for GROUP BY to SELECT statement (CASSANDRA-10707)
 * Deprecate memtable_cleanup_threshold and update default for memtable_flush_writers (CASSANDRA-12228)
 * Upgrade to OHC 0.4.4 (CASSANDRA-12133)
 * Add version command to cassandra-stress (CASSANDRA-12258)
 * Create compaction-stress tool (CASSANDRA-11844)
 * Garbage-collecting compaction operation and schema option (CASSANDRA-7019)
 * Add beta protocol flag for v5 native protocol (CASSANDRA-12142)
 * Support filtering on non-PRIMARY KEY columns in the CREATE
   MATERIALIZED VIEW statement's WHERE clause (CASSANDRA-10368)
 * Unify STDOUT and SYSTEMLOG logback format (CASSANDRA-12004)
 * COPY FROM should raise error for non-existing input files (CASSANDRA-12174)
 * Faster write path (CASSANDRA-12269)
 * Option to leave omitted columns in INSERT JSON unset (CASSANDRA-11424)
 * Support json/yaml output in nodetool tpstats (CASSANDRA-12035)
 * Expose metrics for successful/failed authentication attempts (CASSANDRA-10635)
 * Prepend snapshot name with "truncated" or "dropped" when a snapshot
   is taken before truncating or dropping a table (CASSANDRA-12178)
 * Optimize RestrictionSet (CASSANDRA-12153)
 * cqlsh does not automatically downgrade CQL version (CASSANDRA-12150)
 * Omit (de)serialization of state variable in UDAs (CASSANDRA-9613)
 * Create a system table to expose prepared statements (CASSANDRA-8831)
 * Reuse DataOutputBuffer from ColumnIndex (CASSANDRA-11970)
 * Remove DatabaseDescriptor dependency from SegmentedFile (CASSANDRA-11580)
 * Add supplied username to authentication error messages (CASSANDRA-12076)
 * Remove pre-startup check for open JMX port (CASSANDRA-12074)
 * Remove compaction Severity from DynamicEndpointSnitch (CASSANDRA-11738)
 * Restore resumable hints delivery (CASSANDRA-11960)
 * Properly record CAS contention (CASSANDRA-12626)
Merged from 3.0:
 * Dump threads when unit tests time out (CASSANDRA-13117)
 * Better error when modifying function permissions without explicit keyspace (CASSANDRA-12925)
 * Indexer is not correctly invoked when building indexes over sstables (CASSANDRA-13075)
 * Stress daemon help is incorrect (CASSANDRA-12563)
 * Read repair is not blocking repair to finish in foreground repair (CASSANDRA-13115)
 * Replace empty strings with null values if they cannot be converted (CASSANDRA-12794)
 * Remove support for non-JavaScript UDFs (CASSANDRA-12883)
 * Fix deserialization of 2.x DeletedCells (CASSANDRA-12620)
 * Add parent repair session id to anticompaction log message (CASSANDRA-12186)
 * Improve contention handling on failure to acquire MV lock for streaming and hints (CASSANDRA-12905)
 * Fix DELETE and UPDATE queries with empty IN restrictions (CASSANDRA-12829)
 * Mark MVs as built after successful bootstrap (CASSANDRA-12984)
 * Estimated TS drop-time histogram updated with Cell.NO_DELETION_TIME (CASSANDRA-13040)
 * Nodetool compactionstats fails with NullPointerException (CASSANDRA-13021)
 * Thread local pools never cleaned up (CASSANDRA-13033)
 * Set RPC_READY to false when draining or if a node is marked as shutdown (CASSANDRA-12781)
 * CQL often queries static columns unnecessarily (CASSANDRA-12768)
 * Make sure sstables only get committed when it's safe to discard commit log records (CASSANDRA-12956)
 * Reject default_time_to_live option when creating or altering MVs (CASSANDRA-12868)
 * Nodetool should use a more sane max heap size (CASSANDRA-12739)
 * LocalToken ensures token values are cloned on heap (CASSANDRA-12651)
 * AnticompactionRequestSerializer serializedSize is incorrect (CASSANDRA-12934)
 * Prevent reloading of logback.xml from UDF sandbox (CASSANDRA-12535)
 * Reenable HeapPool (CASSANDRA-12900)
 * Disallow offheap_buffers memtable allocation (CASSANDRA-11039)
 * Fix CommitLogSegmentManagerTest (CASSANDRA-12283)
 * Pass root cause to CorruptBlockException when uncompression failed (CASSANDRA-12889)
 * Batch with multiple conditional updates for the same partition causes AssertionError (CASSANDRA-12867)
 * Make AbstractReplicationStrategy extendable from outside its package (CASSANDRA-12788)
 * Don't tell users to turn off consistent rangemovements during rebuild. (CASSANDRA-12296)
 * Fix CommitLogTest.testDeleteIfNotDirty (CASSANDRA-12854)
 * Avoid deadlock due to MV lock contention (CASSANDRA-12689)
 * Fix for KeyCacheCqlTest flakiness (CASSANDRA-12801)
 * Include SSTable filename in compacting large row message (CASSANDRA-12384)
 * Fix potential socket leak (CASSANDRA-12329, CASSANDRA-12330)
 * Fix ViewTest.testCompaction (CASSANDRA-12789)
 * Improve avg aggregate functions (CASSANDRA-12417)
 * Preserve quoted reserved keyword column names in MV creation (CASSANDRA-11803)
 * nodetool stopdaemon errors out (CASSANDRA-12646)
 * Split materialized view mutations on build to prevent OOM (CASSANDRA-12268)
 * mx4j does not work in 3.0.8 (CASSANDRA-12274)
 * Abort cqlsh copy-from in case of no answer after prolonged period of time (CASSANDRA-12740)
 * Avoid sstable corrupt exception due to dropped static column (CASSANDRA-12582)
 * Make stress use client mode to avoid checking commit log size on startup (CASSANDRA-12478)
 * Fix exceptions with new vnode allocation (CASSANDRA-12715)
 * Unify drain and shutdown processes (CASSANDRA-12509)
 * Fix NPE in ComponentOfSlice.isEQ() (CASSANDRA-12706)
 * Fix failure in LogTransactionTest (CASSANDRA-12632)
 * Fix potentially incomplete non-frozen UDT values when querying with the
   full primary key specified (CASSANDRA-12605)
 * Make sure repaired tombstones are dropped when only_purge_repaired_tombstones is enabled (CASSANDRA-12703)
 * Skip writing MV mutations to commitlog on mutation.applyUnsafe() (CASSANDRA-11670)
 * Establish consistent distinction between non-existing partition and NULL value for LWTs on static columns (CASSANDRA-12060)
 * Extend ColumnIdentifier.internedInstances key to include the type that generated the byte buffer (CASSANDRA-12516)
 * Handle composite prefixes with final EOC=0 as in 2.x and refactor LegacyLayout.decodeBound (CASSANDRA-12423)
 * select_distinct_with_deletions_test failing on non-vnode environments (CASSANDRA-11126)
 * Stack Overflow returned to queries while upgrading (CASSANDRA-12527)
 * Fix legacy regex for temporary files from 2.2 (CASSANDRA-12565)
 * Add option to state current gc_grace_seconds to tools/bin/sstablemetadata (CASSANDRA-12208)
 * Fix file system race condition that may cause LogAwareFileLister to fail to classify files (CASSANDRA-11889)
 * Fix file handle leaks due to simultaneous compaction/repair and
   listing snapshots, calculating snapshot sizes, or making schema
   changes (CASSANDRA-11594)
 * Fix nodetool repair exits with 0 for some errors (CASSANDRA-12508)
 * Do not shut down BatchlogManager twice during drain (CASSANDRA-12504)
 * Disk failure policy should not be invoked on out of space (CASSANDRA-12385)
 * Calculate last compacted key on startup (CASSANDRA-6216)
 * Add schema to snapshot manifest, add USING TIMESTAMP clause to ALTER TABLE statements (CASSANDRA-7190)
 * If CF has no clustering columns, any row cache is full partition cache (CASSANDRA-12499)
 * Correct log message for statistics of offheap memtable flush (CASSANDRA-12776)
 * Explicitly set locale for string validation (CASSANDRA-12541,CASSANDRA-12542,CASSANDRA-12543,CASSANDRA-12545)
Merged from 2.2:
 * Fix speculative retry bugs (CASSANDRA-13009)
 * Fix handling of nulls and unsets in IN conditions (CASSANDRA-12981)
 * Fix race causing infinite loop if Thrift server is stopped before it starts listening (CASSANDRA-12856)
 * CompactionTasks now correctly drops sstables out of compaction when not enough disk space is available (CASSANDRA-12979)
 * Fix DynamicEndpointSnitch noop in multi-datacenter situations (CASSANDRA-13074)
 * cqlsh copy-from: encode column names to avoid primary key parsing errors (CASSANDRA-12909)
 * Temporarily fix bug that creates commit log when running offline tools (CASSANDRA-8616)
 * Reduce granuality of OpOrder.Group during index build (CASSANDRA-12796)
 * Test bind parameters and unset parameters in InsertUpdateIfConditionTest (CASSANDRA-12980)
 * Use saved tokens when setting local tokens on StorageService.joinRing (CASSANDRA-12935)
 * cqlsh: fix DESC TYPES errors (CASSANDRA-12914)
 * Fix leak on skipped SSTables in sstableupgrade (CASSANDRA-12899)
 * Avoid blocking gossip during pending range calculation (CASSANDRA-12281)
 * Fix purgeability of tombstones with max timestamp (CASSANDRA-12792)
 * Fail repair if participant dies during sync or anticompaction (CASSANDRA-12901)
 * cqlsh COPY: unprotected pk values before converting them if not using prepared statements (CASSANDRA-12863)
 * Fix Util.spinAssertEquals (CASSANDRA-12283)
 * Fix potential NPE for compactionstats (CASSANDRA-12462)
 * Prepare legacy authenticate statement if credentials table initialised after node startup (CASSANDRA-12813)
 * Change cassandra.wait_for_tracing_events_timeout_secs default to 0 (CASSANDRA-12754)
 * Clean up permissions when a UDA is dropped (CASSANDRA-12720)
 * Limit colUpdateTimeDelta histogram updates to reasonable deltas (CASSANDRA-11117)
 * Fix leak errors and execution rejected exceptions when draining (CASSANDRA-12457)
 * Fix merkle tree depth calculation (CASSANDRA-12580)
 * Make Collections deserialization more robust (CASSANDRA-12618)
 * Fix exceptions when enabling gossip on nodes that haven't joined the ring (CASSANDRA-12253)
 * Fix authentication problem when invoking cqlsh copy from a SOURCE command (CASSANDRA-12642)
 * Decrement pending range calculator jobs counter in finally block
 * cqlshlib tests: increase default execute timeout (CASSANDRA-12481)
 * Forward writes to replacement node when replace_address != broadcast_address (CASSANDRA-8523)
 * Fail repair on non-existing table (CASSANDRA-12279)
 * Enable repair -pr and -local together (fix regression of CASSANDRA-7450) (CASSANDRA-12522)
 * Better handle invalid system roles table (CASSANDRA-12700)
 * Split consistent range movement flag correction (CASSANDRA-12786)
Merged from 2.1:
 * cqlsh copy-from: sort user type fields in csv (CASSANDRA-12959)
 * Don't skip sstables based on maxLocalDeletionTime (CASSANDRA-12765)


3.8, 3.9
 * Fix value skipping with counter columns (CASSANDRA-11726)
 * Fix nodetool tablestats miss SSTable count (CASSANDRA-12205)
 * Fixed flacky SSTablesIteratedTest (CASSANDRA-12282)
 * Fixed flacky SSTableRewriterTest: check file counts before calling validateCFS (CASSANDRA-12348)
 * cqlsh: Fix handling of $$-escaped strings (CASSANDRA-12189)
 * Fix SSL JMX requiring truststore containing server cert (CASSANDRA-12109)
 * RTE from new CDC column breaks in flight queries (CASSANDRA-12236)
 * Fix hdr logging for single operation workloads (CASSANDRA-12145)
 * Fix SASI PREFIX search in CONTAINS mode with partial terms (CASSANDRA-12073)
 * Increase size of flushExecutor thread pool (CASSANDRA-12071)
 * Partial revert of CASSANDRA-11971, cannot recycle buffer in SP.sendMessagesToNonlocalDC (CASSANDRA-11950)
 * Upgrade netty to 4.0.39 (CASSANDRA-12032, CASSANDRA-12034)
 * Improve details in compaction log message (CASSANDRA-12080)
 * Allow unset values in CQLSSTableWriter (CASSANDRA-11911)
 * Chunk cache to request compressor-compatible buffers if pool space is exhausted (CASSANDRA-11993)
 * Remove DatabaseDescriptor dependencies from SequentialWriter (CASSANDRA-11579)
 * Move skip_stop_words filter before stemming (CASSANDRA-12078)
 * Support seek() in EncryptedFileSegmentInputStream (CASSANDRA-11957)
 * SSTable tools mishandling LocalPartitioner (CASSANDRA-12002)
 * When SEPWorker assigned work, set thread name to match pool (CASSANDRA-11966)
 * Add cross-DC latency metrics (CASSANDRA-11569)
 * Allow terms in selection clause (CASSANDRA-10783)
 * Add bind variables to trace (CASSANDRA-11719)
 * Switch counter shards' clock to timestamps (CASSANDRA-9811)
 * Introduce HdrHistogram and response/service/wait separation to stress tool (CASSANDRA-11853)
 * entry-weighers in QueryProcessor should respect partitionKeyBindIndexes field (CASSANDRA-11718)
 * Support older ant versions (CASSANDRA-11807)
 * Estimate compressed on disk size when deciding if sstable size limit reached (CASSANDRA-11623)
 * cassandra-stress profiles should support case sensitive schemas (CASSANDRA-11546)
 * Remove DatabaseDescriptor dependency from FileUtils (CASSANDRA-11578)
 * Faster streaming (CASSANDRA-9766)
 * Add prepared query parameter to trace for "Execute CQL3 prepared query" session (CASSANDRA-11425)
 * Add repaired percentage metric (CASSANDRA-11503)
 * Add Change-Data-Capture (CASSANDRA-8844)
Merged from 3.0:
 * Fix paging for 2.x to 3.x upgrades (CASSANDRA-11195)
 * Fix clean interval not sent to commit log for empty memtable flush (CASSANDRA-12436)
 * Fix potential resource leak in RMIServerSocketFactoryImpl (CASSANDRA-12331)
 * Make sure compaction stats are updated when compaction is interrupted (CASSANDRA-12100)
 * Change commitlog and sstables to track dirty and clean intervals (CASSANDRA-11828)
 * NullPointerException during compaction on table with static columns (CASSANDRA-12336)
 * Fixed ConcurrentModificationException when reading metrics in GraphiteReporter (CASSANDRA-11823)
 * Fix upgrade of super columns on thrift (CASSANDRA-12335)
 * Fixed flacky BlacklistingCompactionsTest, switched to fixed size types and increased corruption size (CASSANDRA-12359)
 * Rerun ReplicationAwareTokenAllocatorTest on failure to avoid flakiness (CASSANDRA-12277)
 * Exception when computing read-repair for range tombstones (CASSANDRA-12263)
 * Lost counter writes in compact table and static columns (CASSANDRA-12219)
 * AssertionError with MVs on updating a row that isn't indexed due to a null value (CASSANDRA-12247)
 * Disable RR and speculative retry with EACH_QUORUM reads (CASSANDRA-11980)
 * Add option to override compaction space check (CASSANDRA-12180)
 * Faster startup by only scanning each directory for temporary files once (CASSANDRA-12114)
 * Respond with v1/v2 protocol header when responding to driver that attempts
   to connect with too low of a protocol version (CASSANDRA-11464)
 * NullPointerExpception when reading/compacting table (CASSANDRA-11988)
 * Fix problem with undeleteable rows on upgrade to new sstable format (CASSANDRA-12144)
 * Fix potential bad messaging service message for paged range reads
   within mixed-version 3.x clusters (CASSANDRA-12249)
 * Fix paging logic for deleted partitions with static columns (CASSANDRA-12107)
 * Wait until the message is being send to decide which serializer must be used (CASSANDRA-11393)
 * Fix migration of static thrift column names with non-text comparators (CASSANDRA-12147)
 * Fix upgrading sparse tables that are incorrectly marked as dense (CASSANDRA-11315)
 * Fix reverse queries ignoring range tombstones (CASSANDRA-11733)
 * Avoid potential race when rebuilding CFMetaData (CASSANDRA-12098)
 * Avoid missing sstables when getting the canonical sstables (CASSANDRA-11996)
 * Always select the live sstables when getting sstables in bounds (CASSANDRA-11944)
 * Fix column ordering of results with static columns for Thrift requests in
   a mixed 2.x/3.x cluster, also fix potential non-resolved duplication of
   those static columns in query results (CASSANDRA-12123)
 * Avoid digest mismatch with empty but static rows (CASSANDRA-12090)
 * Fix EOF exception when altering column type (CASSANDRA-11820)
 * Fix potential race in schema during new table creation (CASSANDRA-12083)
 * cqlsh: fix error handling in rare COPY FROM failure scenario (CASSANDRA-12070)
 * Disable autocompaction during drain (CASSANDRA-11878)
 * Add a metrics timer to MemtablePool and use it to track time spent blocked on memory in MemtableAllocator (CASSANDRA-11327)
 * Fix upgrading schema with super columns with non-text subcomparators (CASSANDRA-12023)
 * Add TimeWindowCompactionStrategy (CASSANDRA-9666)
 * Fix JsonTransformer output of partition with deletion info (CASSANDRA-12418)
 * Fix NPE in SSTableLoader when specifying partial directory path (CASSANDRA-12609)
Merged from 2.2:
 * Add local address entry in PropertyFileSnitch (CASSANDRA-11332)
 * cqlsh copy: fix missing counter values (CASSANDRA-12476)
 * Move migration tasks to non-periodic queue, assure flush executor shutdown after non-periodic executor (CASSANDRA-12251)
 * cqlsh copy: fixed possible race in initializing feeding thread (CASSANDRA-11701)
 * Only set broadcast_rpc_address on Ec2MultiRegionSnitch if it's not set (CASSANDRA-11357)
 * Update StorageProxy range metrics for timeouts, failures and unavailables (CASSANDRA-9507)
 * Add Sigar to classes included in clientutil.jar (CASSANDRA-11635)
 * Add decay to histograms and timers used for metrics (CASSANDRA-11752)
 * Fix hanging stream session (CASSANDRA-10992)
 * Fix INSERT JSON, fromJson() support of smallint, tinyint types (CASSANDRA-12371)
 * Restore JVM metric export for metric reporters (CASSANDRA-12312)
 * Release sstables of failed stream sessions only when outgoing transfers are finished (CASSANDRA-11345)
 * Wait for tracing events before returning response and query at same consistency level client side (CASSANDRA-11465)
 * cqlsh copyutil should get host metadata by connected address (CASSANDRA-11979)
 * Fixed cqlshlib.test.remove_test_db (CASSANDRA-12214)
 * Synchronize ThriftServer::stop() (CASSANDRA-12105)
 * Use dedicated thread for JMX notifications (CASSANDRA-12146)
 * Improve streaming synchronization and fault tolerance (CASSANDRA-11414)
 * MemoryUtil.getShort() should return an unsigned short also for architectures not supporting unaligned memory accesses (CASSANDRA-11973)
Merged from 2.1:
 * Fix queries with empty ByteBuffer values in clustering column restrictions (CASSANDRA-12127)
 * Disable passing control to post-flush after flush failure to prevent data loss (CASSANDRA-11828)
 * Allow STCS-in-L0 compactions to reduce scope with LCS (CASSANDRA-12040)
 * cannot use cql since upgrading python to 2.7.11+ (CASSANDRA-11850)
 * Fix filtering on clustering columns when 2i is used (CASSANDRA-11907)


3.0.8
 * Fix potential race in schema during new table creation (CASSANDRA-12083)
 * cqlsh: fix error handling in rare COPY FROM failure scenario (CASSANDRA-12070)
 * Disable autocompaction during drain (CASSANDRA-11878)
 * Add a metrics timer to MemtablePool and use it to track time spent blocked on memory in MemtableAllocator (CASSANDRA-11327)
 * Fix upgrading schema with super columns with non-text subcomparators (CASSANDRA-12023)
 * Add TimeWindowCompactionStrategy (CASSANDRA-9666)
Merged from 2.2:
 * Allow nodetool info to run with readonly JMX access (CASSANDRA-11755)
 * Validate bloom_filter_fp_chance against lowest supported
   value when the table is created (CASSANDRA-11920)
 * Don't send erroneous NEW_NODE notifications on restart (CASSANDRA-11038)
 * StorageService shutdown hook should use a volatile variable (CASSANDRA-11984)
Merged from 2.1:
 * Add system property to set the max number of native transport requests in queue (CASSANDRA-11363)
 * Fix queries with empty ByteBuffer values in clustering column restrictions (CASSANDRA-12127)
 * Disable passing control to post-flush after flush failure to prevent data loss (CASSANDRA-11828)
 * Allow STCS-in-L0 compactions to reduce scope with LCS (CASSANDRA-12040)
 * cannot use cql since upgrading python to 2.7.11+ (CASSANDRA-11850)
 * Fix filtering on clustering columns when 2i is used (CASSANDRA-11907)
 * Avoid stalling paxos when the paxos state expires (CASSANDRA-12043)
 * Remove finished incoming streaming connections from MessagingService (CASSANDRA-11854)
 * Don't try to get sstables for non-repairing column families (CASSANDRA-12077)
 * Avoid marking too many sstables as repaired (CASSANDRA-11696)
 * Prevent select statements with clustering key > 64k (CASSANDRA-11882)
 * Fix clock skew corrupting other nodes with paxos (CASSANDRA-11991)
 * Remove distinction between non-existing static columns and existing but null in LWTs (CASSANDRA-9842)
 * Cache local ranges when calculating repair neighbors (CASSANDRA-11934)
 * Allow LWT operation on static column with only partition keys (CASSANDRA-10532)
 * Create interval tree over canonical sstables to avoid missing sstables during streaming (CASSANDRA-11886)
 * cqlsh COPY FROM: shutdown parent cluster after forking, to avoid corrupting SSL connections (CASSANDRA-11749)


3.7
 * Support multiple folders for user defined compaction tasks (CASSANDRA-11765)
 * Fix race in CompactionStrategyManager's pause/resume (CASSANDRA-11922)
Merged from 3.0:
 * Fix legacy serialization of Thrift-generated non-compound range tombstones
   when communicating with 2.x nodes (CASSANDRA-11930)
 * Fix Directories instantiations where CFS.initialDirectories should be used (CASSANDRA-11849)
 * Avoid referencing DatabaseDescriptor in AbstractType (CASSANDRA-11912)
 * Don't use static dataDirectories field in Directories instances (CASSANDRA-11647)
 * Fix sstables not being protected from removal during index build (CASSANDRA-11905)
 * cqlsh: Suppress stack trace from Read/WriteFailures (CASSANDRA-11032)
 * Remove unneeded code to repair index summaries that have
   been improperly down-sampled (CASSANDRA-11127)
 * Avoid WriteTimeoutExceptions during commit log replay due to materialized
   view lock contention (CASSANDRA-11891)
 * Prevent OOM failures on SSTable corruption, improve tests for corruption detection (CASSANDRA-9530)
 * Use CFS.initialDirectories when clearing snapshots (CASSANDRA-11705)
 * Allow compaction strategies to disable early open (CASSANDRA-11754)
 * Refactor Materialized View code (CASSANDRA-11475)
 * Update Java Driver (CASSANDRA-11615)
Merged from 2.2:
 * Persist local metadata earlier in startup sequence (CASSANDRA-11742)
 * cqlsh: fix tab completion for case-sensitive identifiers (CASSANDRA-11664)
 * Avoid showing estimated key as -1 in tablestats (CASSANDRA-11587)
 * Fix possible race condition in CommitLog.recover (CASSANDRA-11743)
 * Enable client encryption in sstableloader with cli options (CASSANDRA-11708)
 * Possible memory leak in NIODataInputStream (CASSANDRA-11867)
 * Add seconds to cqlsh tracing session duration (CASSANDRA-11753)
 * Fix commit log replay after out-of-order flush completion (CASSANDRA-9669)
 * Prohibit Reversed Counter type as part of the PK (CASSANDRA-9395)
 * cqlsh: correctly handle non-ascii chars in error messages (CASSANDRA-11626)
Merged from 2.1:
 * Run CommitLog tests with different compression settings (CASSANDRA-9039)
 * cqlsh: apply current keyspace to source command (CASSANDRA-11152)
 * Clear out parent repair session if repair coordinator dies (CASSANDRA-11824)
 * Set default streaming_socket_timeout_in_ms to 24 hours (CASSANDRA-11840)
 * Do not consider local node a valid source during replace (CASSANDRA-11848)
 * Add message dropped tasks to nodetool netstats (CASSANDRA-11855)
 * Avoid holding SSTableReaders for duration of incremental repair (CASSANDRA-11739)


3.6
 * Correctly migrate schema for frozen UDTs during 2.x -> 3.x upgrades
   (does not affect any released versions) (CASSANDRA-11613)
 * Allow server startup if JMX is configured directly (CASSANDRA-11725)
 * Prevent direct memory OOM on buffer pool allocations (CASSANDRA-11710)
 * Enhanced Compaction Logging (CASSANDRA-10805)
 * Make prepared statement cache size configurable (CASSANDRA-11555)
 * Integrated JMX authentication and authorization (CASSANDRA-10091)
 * Add units to stress ouput (CASSANDRA-11352)
 * Fix PER PARTITION LIMIT for single and multi partitions queries (CASSANDRA-11603)
 * Add uncompressed chunk cache for RandomAccessReader (CASSANDRA-5863)
 * Clarify ClusteringPrefix hierarchy (CASSANDRA-11213)
 * Always perform collision check before joining ring (CASSANDRA-10134)
 * SSTableWriter output discrepancy (CASSANDRA-11646)
 * Fix potential timeout in NativeTransportService.testConcurrentDestroys (CASSANDRA-10756)
 * Support large partitions on the 3.0 sstable format (CASSANDRA-11206,11763)
 * Add support to rebuild from specific range (CASSANDRA-10406)
 * Optimize the overlapping lookup by calculating all the
   bounds in advance (CASSANDRA-11571)
 * Support json/yaml output in nodetool tablestats (CASSANDRA-5977)
 * (stress) Add datacenter option to -node options (CASSANDRA-11591)
 * Fix handling of empty slices (CASSANDRA-11513)
 * Make number of cores used by cqlsh COPY visible to testing code (CASSANDRA-11437)
 * Allow filtering on clustering columns for queries without secondary indexes (CASSANDRA-11310)
 * Refactor Restriction hierarchy (CASSANDRA-11354)
 * Eliminate allocations in R/W path (CASSANDRA-11421)
 * Update Netty to 4.0.36 (CASSANDRA-11567)
 * Fix PER PARTITION LIMIT for queries requiring post-query ordering (CASSANDRA-11556)
 * Allow instantiation of UDTs and tuples in UDFs (CASSANDRA-10818)
 * Support UDT in CQLSSTableWriter (CASSANDRA-10624)
 * Support for non-frozen user-defined types, updating
   individual fields of user-defined types (CASSANDRA-7423)
 * Make LZ4 compression level configurable (CASSANDRA-11051)
 * Allow per-partition LIMIT clause in CQL (CASSANDRA-7017)
 * Make custom filtering more extensible with UserExpression (CASSANDRA-11295)
 * Improve field-checking and error reporting in cassandra.yaml (CASSANDRA-10649)
 * Print CAS stats in nodetool proxyhistograms (CASSANDRA-11507)
 * More user friendly error when providing an invalid token to nodetool (CASSANDRA-9348)
 * Add static column support to SASI index (CASSANDRA-11183)
 * Support EQ/PREFIX queries in SASI CONTAINS mode without tokenization (CASSANDRA-11434)
 * Support LIKE operator in prepared statements (CASSANDRA-11456)
 * Add a command to see if a Materialized View has finished building (CASSANDRA-9967)
 * Log endpoint and port associated with streaming operation (CASSANDRA-8777)
 * Print sensible units for all log messages (CASSANDRA-9692)
 * Upgrade Netty to version 4.0.34 (CASSANDRA-11096)
 * Break the CQL grammar into separate Parser and Lexer (CASSANDRA-11372)
 * Compress only inter-dc traffic by default (CASSANDRA-8888)
 * Add metrics to track write amplification (CASSANDRA-11420)
 * cassandra-stress: cannot handle "value-less" tables (CASSANDRA-7739)
 * Add/drop multiple columns in one ALTER TABLE statement (CASSANDRA-10411)
 * Add require_endpoint_verification opt for internode encryption (CASSANDRA-9220)
 * Add auto import java.util for UDF code block (CASSANDRA-11392)
 * Add --hex-format option to nodetool getsstables (CASSANDRA-11337)
 * sstablemetadata should print sstable min/max token (CASSANDRA-7159)
 * Do not wrap CassandraException in TriggerExecutor (CASSANDRA-9421)
 * COPY TO should have higher double precision (CASSANDRA-11255)
 * Stress should exit with non-zero status after failure (CASSANDRA-10340)
 * Add client to cqlsh SHOW_SESSION (CASSANDRA-8958)
 * Fix nodetool tablestats keyspace level metrics (CASSANDRA-11226)
 * Store repair options in parent_repair_history (CASSANDRA-11244)
 * Print current leveling in sstableofflinerelevel (CASSANDRA-9588)
 * Change repair message for keyspaces with RF 1 (CASSANDRA-11203)
 * Remove hard-coded SSL cipher suites and protocols (CASSANDRA-10508)
 * Improve concurrency in CompactionStrategyManager (CASSANDRA-10099)
 * (cqlsh) interpret CQL type for formatting blobs (CASSANDRA-11274)
 * Refuse to start and print txn log information in case of disk
   corruption (CASSANDRA-10112)
 * Resolve some eclipse-warnings (CASSANDRA-11086)
 * (cqlsh) Show static columns in a different color (CASSANDRA-11059)
 * Allow to remove TTLs on table with default_time_to_live (CASSANDRA-11207)
Merged from 3.0:
 * Disallow creating view with a static column (CASSANDRA-11602)
 * Reduce the amount of object allocations caused by the getFunctions methods (CASSANDRA-11593)
 * Potential error replaying commitlog with smallint/tinyint/date/time types (CASSANDRA-11618)
 * Fix queries with filtering on counter columns (CASSANDRA-11629)
 * Improve tombstone printing in sstabledump (CASSANDRA-11655)
 * Fix paging for range queries where all clustering columns are specified (CASSANDRA-11669)
 * Don't require HEAP_NEW_SIZE to be set when using G1 (CASSANDRA-11600)
 * Fix sstabledump not showing cells after tombstone marker (CASSANDRA-11654)
 * Ignore all LocalStrategy keyspaces for streaming and other related
   operations (CASSANDRA-11627)
 * Ensure columnfilter covers indexed columns for thrift 2i queries (CASSANDRA-11523)
 * Only open one sstable scanner per sstable (CASSANDRA-11412)
 * Option to specify ProtocolVersion in cassandra-stress (CASSANDRA-11410)
 * ArithmeticException in avgFunctionForDecimal (CASSANDRA-11485)
 * LogAwareFileLister should only use OLD sstable files in current folder to determine disk consistency (CASSANDRA-11470)
 * Notify indexers of expired rows during compaction (CASSANDRA-11329)
 * Properly respond with ProtocolError when a v1/v2 native protocol
   header is received (CASSANDRA-11464)
 * Validate that num_tokens and initial_token are consistent with one another (CASSANDRA-10120)
Merged from 2.2:
 * Exit JVM if JMX server fails to startup (CASSANDRA-11540)
 * Produce a heap dump when exiting on OOM (CASSANDRA-9861)
 * Restore ability to filter on clustering columns when using a 2i (CASSANDRA-11510)
 * JSON datetime formatting needs timezone (CASSANDRA-11137)
 * Fix is_dense recalculation for Thrift-updated tables (CASSANDRA-11502)
 * Remove unnescessary file existence check during anticompaction (CASSANDRA-11660)
 * Add missing files to debian packages (CASSANDRA-11642)
 * Avoid calling Iterables::concat in loops during ModificationStatement::getFunctions (CASSANDRA-11621)
 * cqlsh: COPY FROM should use regular inserts for single statement batches and
   report errors correctly if workers processes crash on initialization (CASSANDRA-11474)
 * Always close cluster with connection in CqlRecordWriter (CASSANDRA-11553)
 * Allow only DISTINCT queries with partition keys restrictions (CASSANDRA-11339)
 * CqlConfigHelper no longer requires both a keystore and truststore to work (CASSANDRA-11532)
 * Make deprecated repair methods backward-compatible with previous notification service (CASSANDRA-11430)
 * IncomingStreamingConnection version check message wrong (CASSANDRA-11462)
Merged from 2.1:
 * Support mlockall on IBM POWER arch (CASSANDRA-11576)
 * Add option to disable use of severity in DynamicEndpointSnitch (CASSANDRA-11737)
 * cqlsh COPY FROM fails for null values with non-prepared statements (CASSANDRA-11631)
 * Make cython optional in pylib/setup.py (CASSANDRA-11630)
 * Change order of directory searching for cassandra.in.sh to favor local one (CASSANDRA-11628)
 * cqlsh COPY FROM fails with []{} chars in UDT/tuple fields/values (CASSANDRA-11633)
 * clqsh: COPY FROM throws TypeError with Cython extensions enabled (CASSANDRA-11574)
 * cqlsh: COPY FROM ignores NULL values in conversion (CASSANDRA-11549)
 * Validate levels when building LeveledScanner to avoid overlaps with orphaned sstables (CASSANDRA-9935)


3.5
 * StaticTokenTreeBuilder should respect posibility of duplicate tokens (CASSANDRA-11525)
 * Correctly fix potential assertion error during compaction (CASSANDRA-11353)
 * Avoid index segment stitching in RAM which lead to OOM on big SSTable files (CASSANDRA-11383)
 * Fix clustering and row filters for LIKE queries on clustering columns (CASSANDRA-11397)
Merged from 3.0:
 * Fix rare NPE on schema upgrade from 2.x to 3.x (CASSANDRA-10943)
 * Improve backoff policy for cqlsh COPY FROM (CASSANDRA-11320)
 * Improve IF NOT EXISTS check in CREATE INDEX (CASSANDRA-11131)
 * Upgrade ohc to 0.4.3
 * Enable SO_REUSEADDR for JMX RMI server sockets (CASSANDRA-11093)
 * Allocate merkletrees with the correct size (CASSANDRA-11390)
 * Support streaming pre-3.0 sstables (CASSANDRA-10990)
 * Add backpressure to compressed or encrypted commit log (CASSANDRA-10971)
 * SSTableExport supports secondary index tables (CASSANDRA-11330)
 * Fix sstabledump to include missing info in debug output (CASSANDRA-11321)
 * Establish and implement canonical bulk reading workload(s) (CASSANDRA-10331)
 * Fix paging for IN queries on tables without clustering columns (CASSANDRA-11208)
 * Remove recursive call from CompositesSearcher (CASSANDRA-11304)
 * Fix filtering on non-primary key columns for queries without index (CASSANDRA-6377)
 * Fix sstableloader fail when using materialized view (CASSANDRA-11275)
Merged from 2.2:
 * DatabaseDescriptor should log stacktrace in case of Eception during seed provider creation (CASSANDRA-11312)
 * Use canonical path for directory in SSTable descriptor (CASSANDRA-10587)
 * Add cassandra-stress keystore option (CASSANDRA-9325)
 * Dont mark sstables as repairing with sub range repairs (CASSANDRA-11451)
 * Notify when sstables change after cancelling compaction (CASSANDRA-11373)
 * cqlsh: COPY FROM should check that explicit column names are valid (CASSANDRA-11333)
 * Add -Dcassandra.start_gossip startup option (CASSANDRA-10809)
 * Fix UTF8Validator.validate() for modified UTF-8 (CASSANDRA-10748)
 * Clarify that now() function is calculated on the coordinator node in CQL documentation (CASSANDRA-10900)
 * Fix bloom filter sizing with LCS (CASSANDRA-11344)
 * (cqlsh) Fix error when result is 0 rows with EXPAND ON (CASSANDRA-11092)
 * Add missing newline at end of bin/cqlsh (CASSANDRA-11325)
 * Unresolved hostname leads to replace being ignored (CASSANDRA-11210)
 * Only log yaml config once, at startup (CASSANDRA-11217)
 * Reference leak with parallel repairs on the same table (CASSANDRA-11215)
Merged from 2.1:
 * Add a -j parameter to scrub/cleanup/upgradesstables to state how
   many threads to use (CASSANDRA-11179)
 * COPY FROM on large datasets: fix progress report and debug performance (CASSANDRA-11053)
 * InvalidateKeys should have a weak ref to key cache (CASSANDRA-11176)


3.4
 * (cqlsh) add cqlshrc option to always connect using ssl (CASSANDRA-10458)
 * Cleanup a few resource warnings (CASSANDRA-11085)
 * Allow custom tracing implementations (CASSANDRA-10392)
 * Extract LoaderOptions to be able to be used from outside (CASSANDRA-10637)
 * fix OnDiskIndexTest to properly treat empty ranges (CASSANDRA-11205)
 * fix TrackerTest to handle new notifications (CASSANDRA-11178)
 * add SASI validation for partitioner and complex columns (CASSANDRA-11169)
 * Add caching of encrypted credentials in PasswordAuthenticator (CASSANDRA-7715)
 * fix SASI memtable switching on flush (CASSANDRA-11159)
 * Remove duplicate offline compaction tracking (CASSANDRA-11148)
 * fix EQ semantics of analyzed SASI indexes (CASSANDRA-11130)
 * Support long name output for nodetool commands (CASSANDRA-7950)
 * Encrypted hints (CASSANDRA-11040)
 * SASI index options validation (CASSANDRA-11136)
 * Optimize disk seek using min/max column name meta data when the LIMIT clause is used
   (CASSANDRA-8180)
 * Add LIKE support to CQL3 (CASSANDRA-11067)
 * Generic Java UDF types (CASSANDRA-10819)
 * cqlsh: Include sub-second precision in timestamps by default (CASSANDRA-10428)
 * Set javac encoding to utf-8 (CASSANDRA-11077)
 * Integrate SASI index into Cassandra (CASSANDRA-10661)
 * Add --skip-flush option to nodetool snapshot
 * Skip values for non-queried columns (CASSANDRA-10657)
 * Add support for secondary indexes on static columns (CASSANDRA-8103)
 * CommitLogUpgradeTestMaker creates broken commit logs (CASSANDRA-11051)
 * Add metric for number of dropped mutations (CASSANDRA-10866)
 * Simplify row cache invalidation code (CASSANDRA-10396)
 * Support user-defined compaction through nodetool (CASSANDRA-10660)
 * Stripe view locks by key and table ID to reduce contention (CASSANDRA-10981)
 * Add nodetool gettimeout and settimeout commands (CASSANDRA-10953)
 * Add 3.0 metadata to sstablemetadata output (CASSANDRA-10838)
Merged from 3.0:
 * MV should only query complex columns included in the view (CASSANDRA-11069)
 * Failed aggregate creation breaks server permanently (CASSANDRA-11064)
 * Add sstabledump tool (CASSANDRA-7464)
 * Introduce backpressure for hints (CASSANDRA-10972)
 * Fix ClusteringPrefix not being able to read tombstone range boundaries (CASSANDRA-11158)
 * Prevent logging in sandboxed state (CASSANDRA-11033)
 * Disallow drop/alter operations of UDTs used by UDAs (CASSANDRA-10721)
 * Add query time validation method on Index (CASSANDRA-11043)
 * Avoid potential AssertionError in mixed version cluster (CASSANDRA-11128)
 * Properly handle hinted handoff after topology changes (CASSANDRA-5902)
 * AssertionError when listing sstable files on inconsistent disk state (CASSANDRA-11156)
 * Fix wrong rack counting and invalid conditions check for TokenAllocation
   (CASSANDRA-11139)
 * Avoid creating empty hint files (CASSANDRA-11090)
 * Fix leak detection strong reference loop using weak reference (CASSANDRA-11120)
 * Configurie BatchlogManager to stop delayed tasks on shutdown (CASSANDRA-11062)
 * Hadoop integration is incompatible with Cassandra Driver 3.0.0 (CASSANDRA-11001)
 * Add dropped_columns to the list of schema table so it gets handled
   properly (CASSANDRA-11050)
 * Fix NPE when using forceRepairRangeAsync without DC (CASSANDRA-11239)
Merged from 2.2:
 * Preserve order for preferred SSL cipher suites (CASSANDRA-11164)
 * Range.compareTo() violates the contract of Comparable (CASSANDRA-11216)
 * Avoid NPE when serializing ErrorMessage with null message (CASSANDRA-11167)
 * Replacing an aggregate with a new version doesn't reset INITCOND (CASSANDRA-10840)
 * (cqlsh) cqlsh cannot be called through symlink (CASSANDRA-11037)
 * fix ohc and java-driver pom dependencies in build.xml (CASSANDRA-10793)
 * Protect from keyspace dropped during repair (CASSANDRA-11065)
 * Handle adding fields to a UDT in SELECT JSON and toJson() (CASSANDRA-11146)
 * Better error message for cleanup (CASSANDRA-10991)
 * cqlsh pg-style-strings broken if line ends with ';' (CASSANDRA-11123)
 * Always persist upsampled index summaries (CASSANDRA-10512)
 * (cqlsh) Fix inconsistent auto-complete (CASSANDRA-10733)
 * Make SELECT JSON and toJson() threadsafe (CASSANDRA-11048)
 * Fix SELECT on tuple relations for mixed ASC/DESC clustering order (CASSANDRA-7281)
 * Use cloned TokenMetadata in size estimates to avoid race against membership check
   (CASSANDRA-10736)
 * (cqlsh) Support utf-8/cp65001 encoding on Windows (CASSANDRA-11030)
 * Fix paging on DISTINCT queries repeats result when first row in partition changes
   (CASSANDRA-10010)
 * (cqlsh) Support timezone conversion using pytz (CASSANDRA-10397)
 * cqlsh: change default encoding to UTF-8 (CASSANDRA-11124)
Merged from 2.1:
 * Checking if an unlogged batch is local is inefficient (CASSANDRA-11529)
 * Fix out-of-space error treatment in memtable flushing (CASSANDRA-11448).
 * Don't do defragmentation if reading from repaired sstables (CASSANDRA-10342)
 * Fix streaming_socket_timeout_in_ms not enforced (CASSANDRA-11286)
 * Avoid dropping message too quickly due to missing unit conversion (CASSANDRA-11302)
 * Don't remove FailureDetector history on removeEndpoint (CASSANDRA-10371)
 * Only notify if repair status changed (CASSANDRA-11172)
 * Use logback setting for 'cassandra -v' command (CASSANDRA-10767)
 * Fix sstableloader to unthrottle streaming by default (CASSANDRA-9714)
 * Fix incorrect warning in 'nodetool status' (CASSANDRA-10176)
 * Properly release sstable ref when doing offline scrub (CASSANDRA-10697)
 * Improve nodetool status performance for large cluster (CASSANDRA-7238)
 * Gossiper#isEnabled is not thread safe (CASSANDRA-11116)
 * Avoid major compaction mixing repaired and unrepaired sstables in DTCS (CASSANDRA-11113)
 * Make it clear what DTCS timestamp_resolution is used for (CASSANDRA-11041)
 * (cqlsh) Display milliseconds when datetime overflows (CASSANDRA-10625)


3.3
 * Avoid infinite loop if owned range is smaller than number of
   data dirs (CASSANDRA-11034)
 * Avoid bootstrap hanging when existing nodes have no data to stream (CASSANDRA-11010)
Merged from 3.0:
 * Remove double initialization of newly added tables (CASSANDRA-11027)
 * Filter keys searcher results by target range (CASSANDRA-11104)
 * Fix deserialization of legacy read commands (CASSANDRA-11087)
 * Fix incorrect computation of deletion time in sstable metadata (CASSANDRA-11102)
 * Avoid memory leak when collecting sstable metadata (CASSANDRA-11026)
 * Mutations do not block for completion under view lock contention (CASSANDRA-10779)
 * Invalidate legacy schema tables when unloading them (CASSANDRA-11071)
 * (cqlsh) handle INSERT and UPDATE statements with LWT conditions correctly
   (CASSANDRA-11003)
 * Fix DISTINCT queries in mixed version clusters (CASSANDRA-10762)
 * Migrate build status for indexes along with legacy schema (CASSANDRA-11046)
 * Ensure SSTables for legacy KEYS indexes can be read (CASSANDRA-11045)
 * Added support for IBM zSystems architecture (CASSANDRA-11054)
 * Update CQL documentation (CASSANDRA-10899)
 * Check the column name, not cell name, for dropped columns when reading
   legacy sstables (CASSANDRA-11018)
 * Don't attempt to index clustering values of static rows (CASSANDRA-11021)
 * Remove checksum files after replaying hints (CASSANDRA-10947)
 * Support passing base table metadata to custom 2i validation (CASSANDRA-10924)
 * Ensure stale index entries are purged during reads (CASSANDRA-11013)
 * (cqlsh) Also apply --connect-timeout to control connection
   timeout (CASSANDRA-10959)
 * Fix AssertionError when removing from list using UPDATE (CASSANDRA-10954)
 * Fix UnsupportedOperationException when reading old sstable with range
   tombstone (CASSANDRA-10743)
 * MV should use the maximum timestamp of the primary key (CASSANDRA-10910)
 * Fix potential assertion error during compaction (CASSANDRA-10944)
Merged from 2.2:
 * maxPurgeableTimestamp needs to check memtables too (CASSANDRA-9949)
 * Apply change to compaction throughput in real time (CASSANDRA-10025)
 * (cqlsh) encode input correctly when saving history
 * Fix potential NPE on ORDER BY queries with IN (CASSANDRA-10955)
 * Start L0 STCS-compactions even if there is a L0 -> L1 compaction
   going (CASSANDRA-10979)
 * Make UUID LSB unique per process (CASSANDRA-7925)
 * Avoid NPE when performing sstable tasks (scrub etc.) (CASSANDRA-10980)
 * Make sure client gets tombstone overwhelmed warning (CASSANDRA-9465)
 * Fix error streaming section more than 2GB (CASSANDRA-10961)
 * Histogram buckets exposed in jmx are sorted incorrectly (CASSANDRA-10975)
 * Enable GC logging by default (CASSANDRA-10140)
 * Optimize pending range computation (CASSANDRA-9258)
 * Skip commit log and saved cache directories in SSTable version startup check (CASSANDRA-10902)
 * drop/alter user should be case sensitive (CASSANDRA-10817)
Merged from 2.1:
 * test_bulk_round_trip_blogposts is failing occasionally (CASSANDRA-10938)
 * Fix isJoined return true only after becoming cluster member (CASANDRA-11007)
 * Fix bad gossip generation seen in long-running clusters (CASSANDRA-10969)
 * Avoid NPE when incremental repair fails (CASSANDRA-10909)
 * Unmark sstables compacting once they are done in cleanup/scrub/upgradesstables (CASSANDRA-10829)
 * Allow simultaneous bootstrapping with strict consistency when no vnodes are used (CASSANDRA-11005)
 * Log a message when major compaction does not result in a single file (CASSANDRA-10847)
 * (cqlsh) fix cqlsh_copy_tests when vnodes are disabled (CASSANDRA-10997)
 * (cqlsh) Add request timeout option to cqlsh (CASSANDRA-10686)
 * Avoid AssertionError while submitting hint with LWT (CASSANDRA-10477)
 * If CompactionMetadata is not in stats file, use index summary instead (CASSANDRA-10676)
 * Retry sending gossip syn multiple times during shadow round (CASSANDRA-8072)
 * Fix pending range calculation during moves (CASSANDRA-10887)
 * Sane default (200Mbps) for inter-DC streaming througput (CASSANDRA-8708)


3.2
 * Make sure tokens don't exist in several data directories (CASSANDRA-6696)
 * Add requireAuthorization method to IAuthorizer (CASSANDRA-10852)
 * Move static JVM options to conf/jvm.options file (CASSANDRA-10494)
 * Fix CassandraVersion to accept x.y version string (CASSANDRA-10931)
 * Add forceUserDefinedCleanup to allow more flexible cleanup (CASSANDRA-10708)
 * (cqlsh) allow setting TTL with COPY (CASSANDRA-9494)
 * Fix counting of received sstables in streaming (CASSANDRA-10949)
 * Implement hints compression (CASSANDRA-9428)
 * Fix potential assertion error when reading static columns (CASSANDRA-10903)
 * Fix EstimatedHistogram creation in nodetool tablehistograms (CASSANDRA-10859)
 * Establish bootstrap stream sessions sequentially (CASSANDRA-6992)
 * Sort compactionhistory output by timestamp (CASSANDRA-10464)
 * More efficient BTree removal (CASSANDRA-9991)
 * Make tablehistograms accept the same syntax as tablestats (CASSANDRA-10149)
 * Group pending compactions based on table (CASSANDRA-10718)
 * Add compressor name in sstablemetadata output (CASSANDRA-9879)
 * Fix type casting for counter columns (CASSANDRA-10824)
 * Prevent running Cassandra as root (CASSANDRA-8142)
 * bound maximum in-flight commit log replay mutation bytes to 64 megabytes (CASSANDRA-8639)
 * Normalize all scripts (CASSANDRA-10679)
 * Make compression ratio much more accurate (CASSANDRA-10225)
 * Optimize building of Clustering object when only one is created (CASSANDRA-10409)
 * Make index building pluggable (CASSANDRA-10681)
 * Add sstable flush observer (CASSANDRA-10678)
 * Improve NTS endpoints calculation (CASSANDRA-10200)
 * Improve performance of the folderSize function (CASSANDRA-10677)
 * Add support for type casting in selection clause (CASSANDRA-10310)
 * Added graphing option to cassandra-stress (CASSANDRA-7918)
 * Abort in-progress queries that time out (CASSANDRA-7392)
 * Add transparent data encryption core classes (CASSANDRA-9945)
Merged from 3.0:
 * Better handling of SSL connection errors inter-node (CASSANDRA-10816)
 * Avoid NoSuchElementException when executing empty batch (CASSANDRA-10711)
 * Avoid building PartitionUpdate in toString (CASSANDRA-10897)
 * Reduce heap spent when receiving many SSTables (CASSANDRA-10797)
 * Add back support for 3rd party auth providers to bulk loader (CASSANDRA-10873)
 * Eliminate the dependency on jgrapht for UDT resolution (CASSANDRA-10653)
 * (Hadoop) Close Clusters and Sessions in Hadoop Input/Output classes (CASSANDRA-10837)
 * Fix sstableloader not working with upper case keyspace name (CASSANDRA-10806)
Merged from 2.2:
 * jemalloc detection fails due to quoting issues in regexv (CASSANDRA-10946)
 * (cqlsh) show correct column names for empty result sets (CASSANDRA-9813)
 * Add new types to Stress (CASSANDRA-9556)
 * Add property to allow listening on broadcast interface (CASSANDRA-9748)
Merged from 2.1:
 * Match cassandra-loader options in COPY FROM (CASSANDRA-9303)
 * Fix binding to any address in CqlBulkRecordWriter (CASSANDRA-9309)
 * cqlsh fails to decode utf-8 characters for text typed columns (CASSANDRA-10875)
 * Log error when stream session fails (CASSANDRA-9294)
 * Fix bugs in commit log archiving startup behavior (CASSANDRA-10593)
 * (cqlsh) further optimise COPY FROM (CASSANDRA-9302)
 * Allow CREATE TABLE WITH ID (CASSANDRA-9179)
 * Make Stress compiles within eclipse (CASSANDRA-10807)
 * Cassandra Daemon should print JVM arguments (CASSANDRA-10764)
 * Allow cancellation of index summary redistribution (CASSANDRA-8805)


3.1.1
Merged from 3.0:
  * Fix upgrade data loss due to range tombstone deleting more data than then should
    (CASSANDRA-10822)


3.1
Merged from 3.0:
 * Avoid MV race during node decommission (CASSANDRA-10674)
 * Disable reloading of GossipingPropertyFileSnitch (CASSANDRA-9474)
 * Handle single-column deletions correction in materialized views
   when the column is part of the view primary key (CASSANDRA-10796)
 * Fix issue with datadir migration on upgrade (CASSANDRA-10788)
 * Fix bug with range tombstones on reverse queries and test coverage for
   AbstractBTreePartition (CASSANDRA-10059)
 * Remove 64k limit on collection elements (CASSANDRA-10374)
 * Remove unclear Indexer.indexes() method (CASSANDRA-10690)
 * Fix NPE on stream read error (CASSANDRA-10771)
 * Normalize cqlsh DESC output (CASSANDRA-10431)
 * Rejects partition range deletions when columns are specified (CASSANDRA-10739)
 * Fix error when saving cached key for old format sstable (CASSANDRA-10778)
 * Invalidate prepared statements on DROP INDEX (CASSANDRA-10758)
 * Fix SELECT statement with IN restrictions on partition key,
   ORDER BY and LIMIT (CASSANDRA-10729)
 * Improve stress performance over 1k threads (CASSANDRA-7217)
 * Wait for migration responses to complete before bootstrapping (CASSANDRA-10731)
 * Unable to create a function with argument of type Inet (CASSANDRA-10741)
 * Fix backward incompatibiliy in CqlInputFormat (CASSANDRA-10717)
 * Correctly preserve deletion info on updated rows when notifying indexers
   of single-row deletions (CASSANDRA-10694)
 * Notify indexers of partition delete during cleanup (CASSANDRA-10685)
 * Keep the file open in trySkipCache (CASSANDRA-10669)
 * Updated trigger example (CASSANDRA-10257)
Merged from 2.2:
 * Verify tables in pseudo-system keyspaces at startup (CASSANDRA-10761)
 * Fix IllegalArgumentException in DataOutputBuffer.reallocate for large buffers (CASSANDRA-10592)
 * Show CQL help in cqlsh in web browser (CASSANDRA-7225)
 * Serialize on disk the proper SSTable compression ratio (CASSANDRA-10775)
 * Reject index queries while the index is building (CASSANDRA-8505)
 * CQL.textile syntax incorrectly includes optional keyspace for aggregate SFUNC and FINALFUNC (CASSANDRA-10747)
 * Fix JSON update with prepared statements (CASSANDRA-10631)
 * Don't do anticompaction after subrange repair (CASSANDRA-10422)
 * Fix SimpleDateType type compatibility (CASSANDRA-10027)
 * (Hadoop) fix splits calculation (CASSANDRA-10640)
 * (Hadoop) ensure that Cluster instances are always closed (CASSANDRA-10058)
Merged from 2.1:
 * Fix Stress profile parsing on Windows (CASSANDRA-10808)
 * Fix incremental repair hang when replica is down (CASSANDRA-10288)
 * Optimize the way we check if a token is repaired in anticompaction (CASSANDRA-10768)
 * Add proper error handling to stream receiver (CASSANDRA-10774)
 * Warn or fail when changing cluster topology live (CASSANDRA-10243)
 * Status command in debian/ubuntu init script doesn't work (CASSANDRA-10213)
 * Some DROP ... IF EXISTS incorrectly result in exceptions on non-existing KS (CASSANDRA-10658)
 * DeletionTime.compareTo wrong in rare cases (CASSANDRA-10749)
 * Force encoding when computing statement ids (CASSANDRA-10755)
 * Properly reject counters as map keys (CASSANDRA-10760)
 * Fix the sstable-needs-cleanup check (CASSANDRA-10740)
 * (cqlsh) Print column names before COPY operation (CASSANDRA-8935)
 * Fix CompressedInputStream for proper cleanup (CASSANDRA-10012)
 * (cqlsh) Support counters in COPY commands (CASSANDRA-9043)
 * Try next replica if not possible to connect to primary replica on
   ColumnFamilyRecordReader (CASSANDRA-2388)
 * Limit window size in DTCS (CASSANDRA-10280)
 * sstableloader does not use MAX_HEAP_SIZE env parameter (CASSANDRA-10188)
 * (cqlsh) Improve COPY TO performance and error handling (CASSANDRA-9304)
 * Create compression chunk for sending file only (CASSANDRA-10680)
 * Forbid compact clustering column type changes in ALTER TABLE (CASSANDRA-8879)
 * Reject incremental repair with subrange repair (CASSANDRA-10422)
 * Add a nodetool command to refresh size_estimates (CASSANDRA-9579)
 * Invalidate cache after stream receive task is completed (CASSANDRA-10341)
 * Reject counter writes in CQLSSTableWriter (CASSANDRA-10258)
 * Remove superfluous COUNTER_MUTATION stage mapping (CASSANDRA-10605)


3.0
 * Fix AssertionError while flushing memtable due to materialized views
   incorrectly inserting empty rows (CASSANDRA-10614)
 * Store UDA initcond as CQL literal in the schema table, instead of a blob (CASSANDRA-10650)
 * Don't use -1 for the position of partition key in schema (CASSANDRA-10491)
 * Fix distinct queries in mixed version cluster (CASSANDRA-10573)
 * Skip sstable on clustering in names query (CASSANDRA-10571)
 * Remove value skipping as it breaks read-repair (CASSANDRA-10655)
 * Fix bootstrapping with MVs (CASSANDRA-10621)
 * Make sure EACH_QUORUM reads are using NTS (CASSANDRA-10584)
 * Fix MV replica filtering for non-NetworkTopologyStrategy (CASSANDRA-10634)
 * (Hadoop) fix CIF describeSplits() not handling 0 size estimates (CASSANDRA-10600)
 * Fix reading of legacy sstables (CASSANDRA-10590)
 * Use CQL type names in schema metadata tables (CASSANDRA-10365)
 * Guard batchlog replay against integer division by zero (CASSANDRA-9223)
 * Fix bug when adding a column to thrift with the same name than a primary key (CASSANDRA-10608)
 * Add client address argument to IAuthenticator::newSaslNegotiator (CASSANDRA-8068)
 * Fix implementation of LegacyLayout.LegacyBoundComparator (CASSANDRA-10602)
 * Don't use 'names query' read path for counters (CASSANDRA-10572)
 * Fix backward compatibility for counters (CASSANDRA-10470)
 * Remove memory_allocator paramter from cassandra.yaml (CASSANDRA-10581,10628)
 * Execute the metadata reload task of all registered indexes on CFS::reload (CASSANDRA-10604)
 * Fix thrift cas operations with defined columns (CASSANDRA-10576)
 * Fix PartitionUpdate.operationCount()for updates with static column operations (CASSANDRA-10606)
 * Fix thrift get() queries with defined columns (CASSANDRA-10586)
 * Fix marking of indexes as built and removed (CASSANDRA-10601)
 * Skip initialization of non-registered 2i instances, remove Index::getIndexName (CASSANDRA-10595)
 * Fix batches on multiple tables (CASSANDRA-10554)
 * Ensure compaction options are validated when updating KeyspaceMetadata (CASSANDRA-10569)
 * Flatten Iterator Transformation Hierarchy (CASSANDRA-9975)
 * Remove token generator (CASSANDRA-5261)
 * RolesCache should not be created for any authenticator that does not requireAuthentication (CASSANDRA-10562)
 * Fix LogTransaction checking only a single directory for files (CASSANDRA-10421)
 * Fix handling of range tombstones when reading old format sstables (CASSANDRA-10360)
 * Aggregate with Initial Condition fails with C* 3.0 (CASSANDRA-10367)
Merged from 2.2:
 * (cqlsh) show partial trace if incomplete after max_trace_wait (CASSANDRA-7645)
 * Use most up-to-date version of schema for system tables (CASSANDRA-10652)
 * Deprecate memory_allocator in cassandra.yaml (CASSANDRA-10581,10628)
 * Expose phi values from failure detector via JMX and tweak debug
   and trace logging (CASSANDRA-9526)
 * Fix IllegalArgumentException in DataOutputBuffer.reallocate for large buffers (CASSANDRA-10592)
Merged from 2.1:
 * Shutdown compaction in drain to prevent leak (CASSANDRA-10079)
 * (cqlsh) fix COPY using wrong variable name for time_format (CASSANDRA-10633)
 * Do not run SizeEstimatesRecorder if a node is not a member of the ring (CASSANDRA-9912)
 * Improve handling of dead nodes in gossip (CASSANDRA-10298)
 * Fix logback-tools.xml incorrectly configured for outputing to System.err
   (CASSANDRA-9937)
 * Fix streaming to catch exception so retry not fail (CASSANDRA-10557)
 * Add validation method to PerRowSecondaryIndex (CASSANDRA-10092)
 * Support encrypted and plain traffic on the same port (CASSANDRA-10559)
 * Do STCS in DTCS windows (CASSANDRA-10276)
 * Avoid repetition of JVM_OPTS in debian package (CASSANDRA-10251)
 * Fix potential NPE from handling result of SIM.highestSelectivityIndex (CASSANDRA-10550)
 * Fix paging issues with partitions containing only static columns data (CASSANDRA-10381)
 * Fix conditions on static columns (CASSANDRA-10264)
 * AssertionError: attempted to delete non-existing file CommitLog (CASSANDRA-10377)
 * Fix sorting for queries with an IN condition on partition key columns (CASSANDRA-10363)


3.0-rc2
 * Fix SELECT DISTINCT queries between 2.2.2 nodes and 3.0 nodes (CASSANDRA-10473)
 * Remove circular references in SegmentedFile (CASSANDRA-10543)
 * Ensure validation of indexed values only occurs once per-partition (CASSANDRA-10536)
 * Fix handling of static columns for range tombstones in thrift (CASSANDRA-10174)
 * Support empty ColumnFilter for backward compatility on empty IN (CASSANDRA-10471)
 * Remove Pig support (CASSANDRA-10542)
 * Fix LogFile throws Exception when assertion is disabled (CASSANDRA-10522)
 * Revert CASSANDRA-7486, make CMS default GC, move GC config to
   conf/jvm.options (CASSANDRA-10403)
 * Fix TeeingAppender causing some logs to be truncated/empty (CASSANDRA-10447)
 * Allow EACH_QUORUM for reads (CASSANDRA-9602)
 * Fix potential ClassCastException while upgrading (CASSANDRA-10468)
 * Fix NPE in MVs on update (CASSANDRA-10503)
 * Only include modified cell data in indexing deltas (CASSANDRA-10438)
 * Do not load keyspace when creating sstable writer (CASSANDRA-10443)
 * If node is not yet gossiping write all MV updates to batchlog only (CASSANDRA-10413)
 * Re-populate token metadata after commit log recovery (CASSANDRA-10293)
 * Provide additional metrics for materialized views (CASSANDRA-10323)
 * Flush system schema tables after local schema changes (CASSANDRA-10429)
Merged from 2.2:
 * Reduce contention getting instances of CompositeType (CASSANDRA-10433)
 * Fix the regression when using LIMIT with aggregates (CASSANDRA-10487)
 * Avoid NoClassDefFoundError during DataDescriptor initialization on windows (CASSANDRA-10412)
 * Preserve case of quoted Role & User names (CASSANDRA-10394)
 * cqlsh pg-style-strings broken (CASSANDRA-10484)
 * cqlsh prompt includes name of keyspace after failed `use` statement (CASSANDRA-10369)
Merged from 2.1:
 * (cqlsh) Distinguish negative and positive infinity in output (CASSANDRA-10523)
 * (cqlsh) allow custom time_format for COPY TO (CASSANDRA-8970)
 * Don't allow startup if the node's rack has changed (CASSANDRA-10242)
 * (cqlsh) show partial trace if incomplete after max_trace_wait (CASSANDRA-7645)
 * Allow LOCAL_JMX to be easily overridden (CASSANDRA-10275)
 * Mark nodes as dead even if they've already left (CASSANDRA-10205)


3.0.0-rc1
 * Fix mixed version read request compatibility for compact static tables
   (CASSANDRA-10373)
 * Fix paging of DISTINCT with static and IN (CASSANDRA-10354)
 * Allow MATERIALIZED VIEW's SELECT statement to restrict primary key
   columns (CASSANDRA-9664)
 * Move crc_check_chance out of compression options (CASSANDRA-9839)
 * Fix descending iteration past end of BTreeSearchIterator (CASSANDRA-10301)
 * Transfer hints to a different node on decommission (CASSANDRA-10198)
 * Check partition keys for CAS operations during stmt validation (CASSANDRA-10338)
 * Add custom query expressions to SELECT (CASSANDRA-10217)
 * Fix minor bugs in MV handling (CASSANDRA-10362)
 * Allow custom indexes with 0,1 or multiple target columns (CASSANDRA-10124)
 * Improve MV schema representation (CASSANDRA-9921)
 * Add flag to enable/disable coordinator batchlog for MV writes (CASSANDRA-10230)
 * Update cqlsh COPY for new internal driver serialization interface (CASSANDRA-10318)
 * Give index implementations more control over rebuild operations (CASSANDRA-10312)
 * Update index file format (CASSANDRA-10314)
 * Add "shadowable" row tombstones to deal with mv timestamp issues (CASSANDRA-10261)
 * CFS.loadNewSSTables() broken for pre-3.0 sstables
 * Cache selected index in read command to reduce lookups (CASSANDRA-10215)
 * Small optimizations of sstable index serialization (CASSANDRA-10232)
 * Support for both encrypted and unencrypted native transport connections (CASSANDRA-9590)
Merged from 2.2:
 * Configurable page size in cqlsh (CASSANDRA-9855)
 * Defer default role manager setup until all nodes are on 2.2+ (CASSANDRA-9761)
 * Handle missing RoleManager in config after upgrade to 2.2 (CASSANDRA-10209)
Merged from 2.1:
 * Bulk Loader API could not tolerate even node failure (CASSANDRA-10347)
 * Avoid misleading pushed notifications when multiple nodes
   share an rpc_address (CASSANDRA-10052)
 * Fix dropping undroppable when message queue is full (CASSANDRA-10113)
 * Fix potential ClassCastException during paging (CASSANDRA-10352)
 * Prevent ALTER TYPE from creating circular references (CASSANDRA-10339)
 * Fix cache handling of 2i and base tables (CASSANDRA-10155, 10359)
 * Fix NPE in nodetool compactionhistory (CASSANDRA-9758)
 * (Pig) support BulkOutputFormat as a URL parameter (CASSANDRA-7410)
 * BATCH statement is broken in cqlsh (CASSANDRA-10272)
 * (cqlsh) Make cqlsh PEP8 Compliant (CASSANDRA-10066)
 * (cqlsh) Fix error when starting cqlsh with --debug (CASSANDRA-10282)
 * Scrub, Cleanup and Upgrade do not unmark compacting until all operations
   have completed, regardless of the occurence of exceptions (CASSANDRA-10274)


3.0.0-beta2
 * Fix columns returned by AbstractBtreePartitions (CASSANDRA-10220)
 * Fix backward compatibility issue due to AbstractBounds serialization bug (CASSANDRA-9857)
 * Fix startup error when upgrading nodes (CASSANDRA-10136)
 * Base table PRIMARY KEY can be assumed to be NOT NULL in MV creation (CASSANDRA-10147)
 * Improve batchlog write patch (CASSANDRA-9673)
 * Re-apply MaterializedView updates on commitlog replay (CASSANDRA-10164)
 * Require AbstractType.isByteOrderComparable declaration in constructor (CASSANDRA-9901)
 * Avoid digest mismatch on upgrade to 3.0 (CASSANDRA-9554)
 * Fix Materialized View builder when adding multiple MVs (CASSANDRA-10156)
 * Choose better poolingOptions for protocol v4 in cassandra-stress (CASSANDRA-10182)
 * Fix LWW bug affecting Materialized Views (CASSANDRA-10197)
 * Ensures frozen sets and maps are always sorted (CASSANDRA-10162)
 * Don't deadlock when flushing CFS backed custom indexes (CASSANDRA-10181)
 * Fix double flushing of secondary index tables (CASSANDRA-10180)
 * Fix incorrect handling of range tombstones in thrift (CASSANDRA-10046)
 * Only use batchlog when paired materialized view replica is remote (CASSANDRA-10061)
 * Reuse TemporalRow when updating multiple MaterializedViews (CASSANDRA-10060)
 * Validate gc_grace_seconds for batchlog writes and MVs (CASSANDRA-9917)
 * Fix sstablerepairedset (CASSANDRA-10132)
Merged from 2.2:
 * Cancel transaction for sstables we wont redistribute index summary
   for (CASSANDRA-10270)
 * Retry snapshot deletion after compaction and gc on Windows (CASSANDRA-10222)
 * Fix failure to start with space in directory path on Windows (CASSANDRA-10239)
 * Fix repair hang when snapshot failed (CASSANDRA-10057)
 * Fall back to 1/4 commitlog volume for commitlog_total_space on small disks
   (CASSANDRA-10199)
Merged from 2.1:
 * Added configurable warning threshold for GC duration (CASSANDRA-8907)
 * Fix handling of streaming EOF (CASSANDRA-10206)
 * Only check KeyCache when it is enabled
 * Change streaming_socket_timeout_in_ms default to 1 hour (CASSANDRA-8611)
 * (cqlsh) update list of CQL keywords (CASSANDRA-9232)
 * Add nodetool gettraceprobability command (CASSANDRA-10234)
Merged from 2.0:
 * Fix rare race where older gossip states can be shadowed (CASSANDRA-10366)
 * Fix consolidating racks violating the RF contract (CASSANDRA-10238)
 * Disallow decommission when node is in drained state (CASSANDRA-8741)


2.2.1
 * Fix race during construction of commit log (CASSANDRA-10049)
 * Fix LeveledCompactionStrategyTest (CASSANDRA-9757)
 * Fix broken UnbufferedDataOutputStreamPlus.writeUTF (CASSANDRA-10203)
 * (cqlsh) default load-from-file encoding to utf-8 (CASSANDRA-9898)
 * Avoid returning Permission.NONE when failing to query users table (CASSANDRA-10168)
 * (cqlsh) add CLEAR command (CASSANDRA-10086)
 * Support string literals as Role names for compatibility (CASSANDRA-10135)
Merged from 2.1:
 * Only check KeyCache when it is enabled
 * Change streaming_socket_timeout_in_ms default to 1 hour (CASSANDRA-8611)
 * (cqlsh) update list of CQL keywords (CASSANDRA-9232)


3.0.0-beta1
 * Redesign secondary index API (CASSANDRA-9459, 7771, 9041)
 * Fix throwing ReadFailure instead of ReadTimeout on range queries (CASSANDRA-10125)
 * Rewrite hinted handoff (CASSANDRA-6230)
 * Fix query on static compact tables (CASSANDRA-10093)
 * Fix race during construction of commit log (CASSANDRA-10049)
 * Add option to only purge repaired tombstones (CASSANDRA-6434)
 * Change authorization handling for MVs (CASSANDRA-9927)
 * Add custom JMX enabled executor for UDF sandbox (CASSANDRA-10026)
 * Fix row deletion bug for Materialized Views (CASSANDRA-10014)
 * Support mixed-version clusters with Cassandra 2.1 and 2.2 (CASSANDRA-9704)
 * Fix multiple slices on RowSearchers (CASSANDRA-10002)
 * Fix bug in merging of collections (CASSANDRA-10001)
 * Optimize batchlog replay to avoid full scans (CASSANDRA-7237)
 * Repair improvements when using vnodes (CASSANDRA-5220)
 * Disable scripted UDFs by default (CASSANDRA-9889)
 * Bytecode inspection for Java-UDFs (CASSANDRA-9890)
 * Use byte to serialize MT hash length (CASSANDRA-9792)
 * Replace usage of Adler32 with CRC32 (CASSANDRA-8684)
 * Fix migration to new format from 2.1 SSTable (CASSANDRA-10006)
 * SequentialWriter should extend BufferedDataOutputStreamPlus (CASSANDRA-9500)
 * Use the same repairedAt timestamp within incremental repair session (CASSANDRA-9111)
Merged from 2.2:
 * Allow count(*) and count(1) to be use as normal aggregation (CASSANDRA-10114)
 * An NPE is thrown if the column name is unknown for an IN relation (CASSANDRA-10043)
 * Apply commit_failure_policy to more errors on startup (CASSANDRA-9749)
 * Fix histogram overflow exception (CASSANDRA-9973)
 * Route gossip messages over dedicated socket (CASSANDRA-9237)
 * Add checksum to saved cache files (CASSANDRA-9265)
 * Log warning when using an aggregate without partition key (CASSANDRA-9737)
Merged from 2.1:
 * (cqlsh) Allow encoding to be set through command line (CASSANDRA-10004)
 * Add new JMX methods to change local compaction strategy (CASSANDRA-9965)
 * Write hints for paxos commits (CASSANDRA-7342)
 * (cqlsh) Fix timestamps before 1970 on Windows, always
   use UTC for timestamp display (CASSANDRA-10000)
 * (cqlsh) Avoid overwriting new config file with old config
   when both exist (CASSANDRA-9777)
 * Release snapshot selfRef when doing snapshot repair (CASSANDRA-9998)
 * Cannot replace token does not exist - DN node removed as Fat Client (CASSANDRA-9871)
Merged from 2.0:
 * Don't cast expected bf size to an int (CASSANDRA-9959)
 * Make getFullyExpiredSSTables less expensive (CASSANDRA-9882)


3.0.0-alpha1
 * Implement proper sandboxing for UDFs (CASSANDRA-9402)
 * Simplify (and unify) cleanup of compaction leftovers (CASSANDRA-7066)
 * Allow extra schema definitions in cassandra-stress yaml (CASSANDRA-9850)
 * Metrics should use up to date nomenclature (CASSANDRA-9448)
 * Change CREATE/ALTER TABLE syntax for compression (CASSANDRA-8384)
 * Cleanup crc and adler code for java 8 (CASSANDRA-9650)
 * Storage engine refactor (CASSANDRA-8099, 9743, 9746, 9759, 9781, 9808, 9825,
   9848, 9705, 9859, 9867, 9874, 9828, 9801)
 * Update Guava to 18.0 (CASSANDRA-9653)
 * Bloom filter false positive ratio is not honoured (CASSANDRA-8413)
 * New option for cassandra-stress to leave a ratio of columns null (CASSANDRA-9522)
 * Change hinted_handoff_enabled yaml setting, JMX (CASSANDRA-9035)
 * Add algorithmic token allocation (CASSANDRA-7032)
 * Add nodetool command to replay batchlog (CASSANDRA-9547)
 * Make file buffer cache independent of paths being read (CASSANDRA-8897)
 * Remove deprecated legacy Hadoop code (CASSANDRA-9353)
 * Decommissioned nodes will not rejoin the cluster (CASSANDRA-8801)
 * Change gossip stabilization to use endpoit size (CASSANDRA-9401)
 * Change default garbage collector to G1 (CASSANDRA-7486)
 * Populate TokenMetadata early during startup (CASSANDRA-9317)
 * Undeprecate cache recentHitRate (CASSANDRA-6591)
 * Add support for selectively varint encoding fields (CASSANDRA-9499, 9865)
 * Materialized Views (CASSANDRA-6477)
Merged from 2.2:
 * Avoid grouping sstables for anticompaction with DTCS (CASSANDRA-9900)
 * UDF / UDA execution time in trace (CASSANDRA-9723)
 * Fix broken internode SSL (CASSANDRA-9884)
Merged from 2.1:
 * Add new JMX methods to change local compaction strategy (CASSANDRA-9965)
 * Fix handling of enable/disable autocompaction (CASSANDRA-9899)
 * Add consistency level to tracing ouput (CASSANDRA-9827)
 * Remove repair snapshot leftover on startup (CASSANDRA-7357)
 * Use random nodes for batch log when only 2 racks (CASSANDRA-8735)
 * Ensure atomicity inside thrift and stream session (CASSANDRA-7757)
 * Fix nodetool info error when the node is not joined (CASSANDRA-9031)
Merged from 2.0:
 * Log when messages are dropped due to cross_node_timeout (CASSANDRA-9793)
 * Don't track hotness when opening from snapshot for validation (CASSANDRA-9382)


2.2.0
 * Allow the selection of columns together with aggregates (CASSANDRA-9767)
 * Fix cqlsh copy methods and other windows specific issues (CASSANDRA-9795)
 * Don't wrap byte arrays in SequentialWriter (CASSANDRA-9797)
 * sum() and avg() functions missing for smallint and tinyint types (CASSANDRA-9671)
 * Revert CASSANDRA-9542 (allow native functions in UDA) (CASSANDRA-9771)
Merged from 2.1:
 * Fix MarshalException when upgrading superColumn family (CASSANDRA-9582)
 * Fix broken logging for "empty" flushes in Memtable (CASSANDRA-9837)
 * Handle corrupt files on startup (CASSANDRA-9686)
 * Fix clientutil jar and tests (CASSANDRA-9760)
 * (cqlsh) Allow the SSL protocol version to be specified through the
    config file or environment variables (CASSANDRA-9544)
Merged from 2.0:
 * Add tool to find why expired sstables are not getting dropped (CASSANDRA-10015)
 * Remove erroneous pending HH tasks from tpstats/jmx (CASSANDRA-9129)
 * Don't cast expected bf size to an int (CASSANDRA-9959)
 * checkForEndpointCollision fails for legitimate collisions (CASSANDRA-9765)
 * Complete CASSANDRA-8448 fix (CASSANDRA-9519)
 * Don't include auth credentials in debug log (CASSANDRA-9682)
 * Can't transition from write survey to normal mode (CASSANDRA-9740)
 * Scrub (recover) sstables even when -Index.db is missing (CASSANDRA-9591)
 * Fix growing pending background compaction (CASSANDRA-9662)


2.2.0-rc2
 * Re-enable memory-mapped I/O on Windows (CASSANDRA-9658)
 * Warn when an extra-large partition is compacted (CASSANDRA-9643)
 * (cqlsh) Allow setting the initial connection timeout (CASSANDRA-9601)
 * BulkLoader has --transport-factory option but does not use it (CASSANDRA-9675)
 * Allow JMX over SSL directly from nodetool (CASSANDRA-9090)
 * Update cqlsh for UDFs (CASSANDRA-7556)
 * Change Windows kernel default timer resolution (CASSANDRA-9634)
 * Deprected sstable2json and json2sstable (CASSANDRA-9618)
 * Allow native functions in user-defined aggregates (CASSANDRA-9542)
 * Don't repair system_distributed by default (CASSANDRA-9621)
 * Fix mixing min, max, and count aggregates for blob type (CASSANRA-9622)
 * Rename class for DATE type in Java driver (CASSANDRA-9563)
 * Duplicate compilation of UDFs on coordinator (CASSANDRA-9475)
 * Fix connection leak in CqlRecordWriter (CASSANDRA-9576)
 * Mlockall before opening system sstables & remove boot_without_jna option (CASSANDRA-9573)
 * Add functions to convert timeuuid to date or time, deprecate dateOf and unixTimestampOf (CASSANDRA-9229)
 * Make sure we cancel non-compacting sstables from LifecycleTransaction (CASSANDRA-9566)
 * Fix deprecated repair JMX API (CASSANDRA-9570)
 * Add logback metrics (CASSANDRA-9378)
 * Update and refactor ant test/test-compression to run the tests in parallel (CASSANDRA-9583)
 * Fix upgrading to new directory for secondary index (CASSANDRA-9687)
Merged from 2.1:
 * (cqlsh) Fix bad check for CQL compatibility when DESCRIBE'ing
   COMPACT STORAGE tables with no clustering columns
 * Eliminate strong self-reference chains in sstable ref tidiers (CASSANDRA-9656)
 * Ensure StreamSession uses canonical sstable reader instances (CASSANDRA-9700)
 * Ensure memtable book keeping is not corrupted in the event we shrink usage (CASSANDRA-9681)
 * Update internal python driver for cqlsh (CASSANDRA-9064)
 * Fix IndexOutOfBoundsException when inserting tuple with too many
   elements using the string literal notation (CASSANDRA-9559)
 * Enable describe on indices (CASSANDRA-7814)
 * Fix incorrect result for IN queries where column not found (CASSANDRA-9540)
 * ColumnFamilyStore.selectAndReference may block during compaction (CASSANDRA-9637)
 * Fix bug in cardinality check when compacting (CASSANDRA-9580)
 * Fix memory leak in Ref due to ConcurrentLinkedQueue.remove() behaviour (CASSANDRA-9549)
 * Make rebuild only run one at a time (CASSANDRA-9119)
Merged from 2.0:
 * Avoid NPE in AuthSuccess#decode (CASSANDRA-9727)
 * Add listen_address to system.local (CASSANDRA-9603)
 * Bug fixes to resultset metadata construction (CASSANDRA-9636)
 * Fix setting 'durable_writes' in ALTER KEYSPACE (CASSANDRA-9560)
 * Avoids ballot clash in Paxos (CASSANDRA-9649)
 * Improve trace messages for RR (CASSANDRA-9479)
 * Fix suboptimal secondary index selection when restricted
   clustering column is also indexed (CASSANDRA-9631)
 * (cqlsh) Add min_threshold to DTCS option autocomplete (CASSANDRA-9385)
 * Fix error message when attempting to create an index on a column
   in a COMPACT STORAGE table with clustering columns (CASSANDRA-9527)
 * 'WITH WITH' in alter keyspace statements causes NPE (CASSANDRA-9565)
 * Expose some internals of SelectStatement for inspection (CASSANDRA-9532)
 * ArrivalWindow should use primitives (CASSANDRA-9496)
 * Periodically submit background compaction tasks (CASSANDRA-9592)
 * Set HAS_MORE_PAGES flag to false when PagingState is null (CASSANDRA-9571)


2.2.0-rc1
 * Compressed commit log should measure compressed space used (CASSANDRA-9095)
 * Fix comparison bug in CassandraRoleManager#collectRoles (CASSANDRA-9551)
 * Add tinyint,smallint,time,date support for UDFs (CASSANDRA-9400)
 * Deprecates SSTableSimpleWriter and SSTableSimpleUnsortedWriter (CASSANDRA-9546)
 * Empty INITCOND treated as null in aggregate (CASSANDRA-9457)
 * Remove use of Cell in Thrift MapReduce classes (CASSANDRA-8609)
 * Integrate pre-release Java Driver 2.2-rc1, custom build (CASSANDRA-9493)
 * Clean up gossiper logic for old versions (CASSANDRA-9370)
 * Fix custom payload coding/decoding to match the spec (CASSANDRA-9515)
 * ant test-all results incomplete when parsed (CASSANDRA-9463)
 * Disallow frozen<> types in function arguments and return types for
   clarity (CASSANDRA-9411)
 * Static Analysis to warn on unsafe use of Autocloseable instances (CASSANDRA-9431)
 * Update commitlog archiving examples now that commitlog segments are
   not recycled (CASSANDRA-9350)
 * Extend Transactional API to sstable lifecycle management (CASSANDRA-8568)
 * (cqlsh) Add support for native protocol 4 (CASSANDRA-9399)
 * Ensure that UDF and UDAs are keyspace-isolated (CASSANDRA-9409)
 * Revert CASSANDRA-7807 (tracing completion client notifications) (CASSANDRA-9429)
 * Add ability to stop compaction by ID (CASSANDRA-7207)
 * Let CassandraVersion handle SNAPSHOT version (CASSANDRA-9438)
Merged from 2.1:
 * (cqlsh) Fix using COPY through SOURCE or -f (CASSANDRA-9083)
 * Fix occasional lack of `system` keyspace in schema tables (CASSANDRA-8487)
 * Use ProtocolError code instead of ServerError code for native protocol
   error responses to unsupported protocol versions (CASSANDRA-9451)
 * Default commitlog_sync_batch_window_in_ms changed to 2ms (CASSANDRA-9504)
 * Fix empty partition assertion in unsorted sstable writing tools (CASSANDRA-9071)
 * Ensure truncate without snapshot cannot produce corrupt responses (CASSANDRA-9388)
 * Consistent error message when a table mixes counter and non-counter
   columns (CASSANDRA-9492)
 * Avoid getting unreadable keys during anticompaction (CASSANDRA-9508)
 * (cqlsh) Better float precision by default (CASSANDRA-9224)
 * Improve estimated row count (CASSANDRA-9107)
 * Optimize range tombstone memory footprint (CASSANDRA-8603)
 * Use configured gcgs in anticompaction (CASSANDRA-9397)
Merged from 2.0:
 * Don't accumulate more range than necessary in RangeTombstone.Tracker (CASSANDRA-9486)
 * Add broadcast and rpc addresses to system.local (CASSANDRA-9436)
 * Always mark sstable suspect when corrupted (CASSANDRA-9478)
 * Add database users and permissions to CQL3 documentation (CASSANDRA-7558)
 * Allow JVM_OPTS to be passed to standalone tools (CASSANDRA-5969)
 * Fix bad condition in RangeTombstoneList (CASSANDRA-9485)
 * Fix potential StackOverflow when setting CrcCheckChance over JMX (CASSANDRA-9488)
 * Fix null static columns in pages after the first, paged reversed
   queries (CASSANDRA-8502)
 * Fix counting cache serialization in request metrics (CASSANDRA-9466)
 * Add option not to validate atoms during scrub (CASSANDRA-9406)


2.2.0-beta1
 * Introduce Transactional API for internal state changes (CASSANDRA-8984)
 * Add a flag in cassandra.yaml to enable UDFs (CASSANDRA-9404)
 * Better support of null for UDF (CASSANDRA-8374)
 * Use ecj instead of javassist for UDFs (CASSANDRA-8241)
 * faster async logback configuration for tests (CASSANDRA-9376)
 * Add `smallint` and `tinyint` data types (CASSANDRA-8951)
 * Avoid thrift schema creation when native driver is used in stress tool (CASSANDRA-9374)
 * Make Functions.declared thread-safe
 * Add client warnings to native protocol v4 (CASSANDRA-8930)
 * Allow roles cache to be invalidated (CASSANDRA-8967)
 * Upgrade Snappy (CASSANDRA-9063)
 * Don't start Thrift rpc by default (CASSANDRA-9319)
 * Only stream from unrepaired sstables with incremental repair (CASSANDRA-8267)
 * Aggregate UDFs allow SFUNC return type to differ from STYPE if FFUNC specified (CASSANDRA-9321)
 * Remove Thrift dependencies in bundled tools (CASSANDRA-8358)
 * Disable memory mapping of hsperfdata file for JVM statistics (CASSANDRA-9242)
 * Add pre-startup checks to detect potential incompatibilities (CASSANDRA-8049)
 * Distinguish between null and unset in protocol v4 (CASSANDRA-7304)
 * Add user/role permissions for user-defined functions (CASSANDRA-7557)
 * Allow cassandra config to be updated to restart daemon without unloading classes (CASSANDRA-9046)
 * Don't initialize compaction writer before checking if iter is empty (CASSANDRA-9117)
 * Don't execute any functions at prepare-time (CASSANDRA-9037)
 * Share file handles between all instances of a SegmentedFile (CASSANDRA-8893)
 * Make it possible to major compact LCS (CASSANDRA-7272)
 * Make FunctionExecutionException extend RequestExecutionException
   (CASSANDRA-9055)
 * Add support for SELECT JSON, INSERT JSON syntax and new toJson(), fromJson()
   functions (CASSANDRA-7970)
 * Optimise max purgeable timestamp calculation in compaction (CASSANDRA-8920)
 * Constrain internode message buffer sizes, and improve IO class hierarchy (CASSANDRA-8670)
 * New tool added to validate all sstables in a node (CASSANDRA-5791)
 * Push notification when tracing completes for an operation (CASSANDRA-7807)
 * Delay "node up" and "node added" notifications until native protocol server is started (CASSANDRA-8236)
 * Compressed Commit Log (CASSANDRA-6809)
 * Optimise IntervalTree (CASSANDRA-8988)
 * Add a key-value payload for third party usage (CASSANDRA-8553, 9212)
 * Bump metrics-reporter-config dependency for metrics 3.0 (CASSANDRA-8149)
 * Partition intra-cluster message streams by size, not type (CASSANDRA-8789)
 * Add WriteFailureException to native protocol, notify coordinator of
   write failures (CASSANDRA-8592)
 * Convert SequentialWriter to nio (CASSANDRA-8709)
 * Add role based access control (CASSANDRA-7653, 8650, 7216, 8760, 8849, 8761, 8850)
 * Record client ip address in tracing sessions (CASSANDRA-8162)
 * Indicate partition key columns in response metadata for prepared
   statements (CASSANDRA-7660)
 * Merge UUIDType and TimeUUIDType parse logic (CASSANDRA-8759)
 * Avoid memory allocation when searching index summary (CASSANDRA-8793)
 * Optimise (Time)?UUIDType Comparisons (CASSANDRA-8730)
 * Make CRC32Ex into a separate maven dependency (CASSANDRA-8836)
 * Use preloaded jemalloc w/ Unsafe (CASSANDRA-8714, 9197)
 * Avoid accessing partitioner through StorageProxy (CASSANDRA-8244, 8268)
 * Upgrade Metrics library and remove depricated metrics (CASSANDRA-5657)
 * Serializing Row cache alternative, fully off heap (CASSANDRA-7438)
 * Duplicate rows returned when in clause has repeated values (CASSANDRA-6706)
 * Make CassandraException unchecked, extend RuntimeException (CASSANDRA-8560)
 * Support direct buffer decompression for reads (CASSANDRA-8464)
 * DirectByteBuffer compatible LZ4 methods (CASSANDRA-7039)
 * Group sstables for anticompaction correctly (CASSANDRA-8578)
 * Add ReadFailureException to native protocol, respond
   immediately when replicas encounter errors while handling
   a read request (CASSANDRA-7886)
 * Switch CommitLogSegment from RandomAccessFile to nio (CASSANDRA-8308)
 * Allow mixing token and partition key restrictions (CASSANDRA-7016)
 * Support index key/value entries on map collections (CASSANDRA-8473)
 * Modernize schema tables (CASSANDRA-8261)
 * Support for user-defined aggregation functions (CASSANDRA-8053)
 * Fix NPE in SelectStatement with empty IN values (CASSANDRA-8419)
 * Refactor SelectStatement, return IN results in natural order instead
   of IN value list order and ignore duplicate values in partition key IN restrictions (CASSANDRA-7981)
 * Support UDTs, tuples, and collections in user-defined
   functions (CASSANDRA-7563)
 * Fix aggregate fn results on empty selection, result column name,
   and cqlsh parsing (CASSANDRA-8229)
 * Mark sstables as repaired after full repair (CASSANDRA-7586)
 * Extend Descriptor to include a format value and refactor reader/writer
   APIs (CASSANDRA-7443)
 * Integrate JMH for microbenchmarks (CASSANDRA-8151)
 * Keep sstable levels when bootstrapping (CASSANDRA-7460)
 * Add Sigar library and perform basic OS settings check on startup (CASSANDRA-7838)
 * Support for aggregation functions (CASSANDRA-4914)
 * Remove cassandra-cli (CASSANDRA-7920)
 * Accept dollar quoted strings in CQL (CASSANDRA-7769)
 * Make assassinate a first class command (CASSANDRA-7935)
 * Support IN clause on any partition key column (CASSANDRA-7855)
 * Support IN clause on any clustering column (CASSANDRA-4762)
 * Improve compaction logging (CASSANDRA-7818)
 * Remove YamlFileNetworkTopologySnitch (CASSANDRA-7917)
 * Do anticompaction in groups (CASSANDRA-6851)
 * Support user-defined functions (CASSANDRA-7395, 7526, 7562, 7740, 7781, 7929,
   7924, 7812, 8063, 7813, 7708)
 * Permit configurable timestamps with cassandra-stress (CASSANDRA-7416)
 * Move sstable RandomAccessReader to nio2, which allows using the
   FILE_SHARE_DELETE flag on Windows (CASSANDRA-4050)
 * Remove CQL2 (CASSANDRA-5918)
 * Optimize fetching multiple cells by name (CASSANDRA-6933)
 * Allow compilation in java 8 (CASSANDRA-7028)
 * Make incremental repair default (CASSANDRA-7250)
 * Enable code coverage thru JaCoCo (CASSANDRA-7226)
 * Switch external naming of 'column families' to 'tables' (CASSANDRA-4369)
 * Shorten SSTable path (CASSANDRA-6962)
 * Use unsafe mutations for most unit tests (CASSANDRA-6969)
 * Fix race condition during calculation of pending ranges (CASSANDRA-7390)
 * Fail on very large batch sizes (CASSANDRA-8011)
 * Improve concurrency of repair (CASSANDRA-6455, 8208, 9145)
 * Select optimal CRC32 implementation at runtime (CASSANDRA-8614)
 * Evaluate MurmurHash of Token once per query (CASSANDRA-7096)
 * Generalize progress reporting (CASSANDRA-8901)
 * Resumable bootstrap streaming (CASSANDRA-8838, CASSANDRA-8942)
 * Allow scrub for secondary index (CASSANDRA-5174)
 * Save repair data to system table (CASSANDRA-5839)
 * fix nodetool names that reference column families (CASSANDRA-8872)
 Merged from 2.1:
 * Warn on misuse of unlogged batches (CASSANDRA-9282)
 * Failure detector detects and ignores local pauses (CASSANDRA-9183)
 * Add utility class to support for rate limiting a given log statement (CASSANDRA-9029)
 * Add missing consistency levels to cassandra-stess (CASSANDRA-9361)
 * Fix commitlog getCompletedTasks to not increment (CASSANDRA-9339)
 * Fix for harmless exceptions logged as ERROR (CASSANDRA-8564)
 * Delete processed sstables in sstablesplit/sstableupgrade (CASSANDRA-8606)
 * Improve sstable exclusion from partition tombstones (CASSANDRA-9298)
 * Validate the indexed column rather than the cell's contents for 2i (CASSANDRA-9057)
 * Add support for top-k custom 2i queries (CASSANDRA-8717)
 * Fix error when dropping table during compaction (CASSANDRA-9251)
 * cassandra-stress supports validation operations over user profiles (CASSANDRA-8773)
 * Add support for rate limiting log messages (CASSANDRA-9029)
 * Log the partition key with tombstone warnings (CASSANDRA-8561)
 * Reduce runWithCompactionsDisabled poll interval to 1ms (CASSANDRA-9271)
 * Fix PITR commitlog replay (CASSANDRA-9195)
 * GCInspector logs very different times (CASSANDRA-9124)
 * Fix deleting from an empty list (CASSANDRA-9198)
 * Update tuple and collection types that use a user-defined type when that UDT
   is modified (CASSANDRA-9148, CASSANDRA-9192)
 * Use higher timeout for prepair and snapshot in repair (CASSANDRA-9261)
 * Fix anticompaction blocking ANTI_ENTROPY stage (CASSANDRA-9151)
 * Repair waits for anticompaction to finish (CASSANDRA-9097)
 * Fix streaming not holding ref when stream error (CASSANDRA-9295)
 * Fix canonical view returning early opened SSTables (CASSANDRA-9396)
Merged from 2.0:
 * (cqlsh) Add LOGIN command to switch users (CASSANDRA-7212)
 * Clone SliceQueryFilter in AbstractReadCommand implementations (CASSANDRA-8940)
 * Push correct protocol notification for DROP INDEX (CASSANDRA-9310)
 * token-generator - generated tokens too long (CASSANDRA-9300)
 * Fix counting of tombstones for TombstoneOverwhelmingException (CASSANDRA-9299)
 * Fix ReconnectableSnitch reconnecting to peers during upgrade (CASSANDRA-6702)
 * Include keyspace and table name in error log for collections over the size
   limit (CASSANDRA-9286)
 * Avoid potential overlap in LCS with single-partition sstables (CASSANDRA-9322)
 * Log warning message when a table is queried before the schema has fully
   propagated (CASSANDRA-9136)
 * Overload SecondaryIndex#indexes to accept the column definition (CASSANDRA-9314)
 * (cqlsh) Add SERIAL and LOCAL_SERIAL consistency levels (CASSANDRA-8051)
 * Fix index selection during rebuild with certain table layouts (CASSANDRA-9281)
 * Fix partition-level-delete-only workload accounting (CASSANDRA-9194)
 * Allow scrub to handle corrupted compressed chunks (CASSANDRA-9140)
 * Fix assertion error when resetlocalschema is run during repair (CASSANDRA-9249)
 * Disable single sstable tombstone compactions for DTCS by default (CASSANDRA-9234)
 * IncomingTcpConnection thread is not named (CASSANDRA-9262)
 * Close incoming connections when MessagingService is stopped (CASSANDRA-9238)
 * Fix streaming hang when retrying (CASSANDRA-9132)


2.1.5
 * Re-add deprecated cold_reads_to_omit param for backwards compat (CASSANDRA-9203)
 * Make anticompaction visible in compactionstats (CASSANDRA-9098)
 * Improve nodetool getendpoints documentation about the partition
   key parameter (CASSANDRA-6458)
 * Don't check other keyspaces for schema changes when an user-defined
   type is altered (CASSANDRA-9187)
 * Add generate-idea-files target to build.xml (CASSANDRA-9123)
 * Allow takeColumnFamilySnapshot to take a list of tables (CASSANDRA-8348)
 * Limit major sstable operations to their canonical representation (CASSANDRA-8669)
 * cqlsh: Add tests for INSERT and UPDATE tab completion (CASSANDRA-9125)
 * cqlsh: quote column names when needed in COPY FROM inserts (CASSANDRA-9080)
 * Do not load read meter for offline operations (CASSANDRA-9082)
 * cqlsh: Make CompositeType data readable (CASSANDRA-8919)
 * cqlsh: Fix display of triggers (CASSANDRA-9081)
 * Fix NullPointerException when deleting or setting an element by index on
   a null list collection (CASSANDRA-9077)
 * Buffer bloom filter serialization (CASSANDRA-9066)
 * Fix anti-compaction target bloom filter size (CASSANDRA-9060)
 * Make FROZEN and TUPLE unreserved keywords in CQL (CASSANDRA-9047)
 * Prevent AssertionError from SizeEstimatesRecorder (CASSANDRA-9034)
 * Avoid overwriting index summaries for sstables with an older format that
   does not support downsampling; rebuild summaries on startup when this
   is detected (CASSANDRA-8993)
 * Fix potential data loss in CompressedSequentialWriter (CASSANDRA-8949)
 * Make PasswordAuthenticator number of hashing rounds configurable (CASSANDRA-8085)
 * Fix AssertionError when binding nested collections in DELETE (CASSANDRA-8900)
 * Check for overlap with non-early sstables in LCS (CASSANDRA-8739)
 * Only calculate max purgable timestamp if we have to (CASSANDRA-8914)
 * (cqlsh) Greatly improve performance of COPY FROM (CASSANDRA-8225)
 * IndexSummary effectiveIndexInterval is now a guideline, not a rule (CASSANDRA-8993)
 * Use correct bounds for page cache eviction of compressed files (CASSANDRA-8746)
 * SSTableScanner enforces its bounds (CASSANDRA-8946)
 * Cleanup cell equality (CASSANDRA-8947)
 * Introduce intra-cluster message coalescing (CASSANDRA-8692)
 * DatabaseDescriptor throws NPE when rpc_interface is used (CASSANDRA-8839)
 * Don't check if an sstable is live for offline compactions (CASSANDRA-8841)
 * Don't set clientMode in SSTableLoader (CASSANDRA-8238)
 * Fix SSTableRewriter with disabled early open (CASSANDRA-8535)
 * Fix cassandra-stress so it respects the CL passed in user mode (CASSANDRA-8948)
 * Fix rare NPE in ColumnDefinition#hasIndexOption() (CASSANDRA-8786)
 * cassandra-stress reports per-operation statistics, plus misc (CASSANDRA-8769)
 * Add SimpleDate (cql date) and Time (cql time) types (CASSANDRA-7523)
 * Use long for key count in cfstats (CASSANDRA-8913)
 * Make SSTableRewriter.abort() more robust to failure (CASSANDRA-8832)
 * Remove cold_reads_to_omit from STCS (CASSANDRA-8860)
 * Make EstimatedHistogram#percentile() use ceil instead of floor (CASSANDRA-8883)
 * Fix top partitions reporting wrong cardinality (CASSANDRA-8834)
 * Fix rare NPE in KeyCacheSerializer (CASSANDRA-8067)
 * Pick sstables for validation as late as possible inc repairs (CASSANDRA-8366)
 * Fix commitlog getPendingTasks to not increment (CASSANDRA-8862)
 * Fix parallelism adjustment in range and secondary index queries
   when the first fetch does not satisfy the limit (CASSANDRA-8856)
 * Check if the filtered sstables is non-empty in STCS (CASSANDRA-8843)
 * Upgrade java-driver used for cassandra-stress (CASSANDRA-8842)
 * Fix CommitLog.forceRecycleAllSegments() memory access error (CASSANDRA-8812)
 * Improve assertions in Memory (CASSANDRA-8792)
 * Fix SSTableRewriter cleanup (CASSANDRA-8802)
 * Introduce SafeMemory for CompressionMetadata.Writer (CASSANDRA-8758)
 * 'nodetool info' prints exception against older node (CASSANDRA-8796)
 * Ensure SSTableReader.last corresponds exactly with the file end (CASSANDRA-8750)
 * Make SSTableWriter.openEarly more robust and obvious (CASSANDRA-8747)
 * Enforce SSTableReader.first/last (CASSANDRA-8744)
 * Cleanup SegmentedFile API (CASSANDRA-8749)
 * Avoid overlap with early compaction replacement (CASSANDRA-8683)
 * Safer Resource Management++ (CASSANDRA-8707)
 * Write partition size estimates into a system table (CASSANDRA-7688)
 * cqlsh: Fix keys() and full() collection indexes in DESCRIBE output
   (CASSANDRA-8154)
 * Show progress of streaming in nodetool netstats (CASSANDRA-8886)
 * IndexSummaryBuilder utilises offheap memory, and shares data between
   each IndexSummary opened from it (CASSANDRA-8757)
 * markCompacting only succeeds if the exact SSTableReader instances being
   marked are in the live set (CASSANDRA-8689)
 * cassandra-stress support for varint (CASSANDRA-8882)
 * Fix Adler32 digest for compressed sstables (CASSANDRA-8778)
 * Add nodetool statushandoff/statusbackup (CASSANDRA-8912)
 * Use stdout for progress and stats in sstableloader (CASSANDRA-8982)
 * Correctly identify 2i datadir from older versions (CASSANDRA-9116)
Merged from 2.0:
 * Ignore gossip SYNs after shutdown (CASSANDRA-9238)
 * Avoid overflow when calculating max sstable size in LCS (CASSANDRA-9235)
 * Make sstable blacklisting work with compression (CASSANDRA-9138)
 * Do not attempt to rebuild indexes if no index accepts any column (CASSANDRA-9196)
 * Don't initiate snitch reconnection for dead states (CASSANDRA-7292)
 * Fix ArrayIndexOutOfBoundsException in CQLSSTableWriter (CASSANDRA-8978)
 * Add shutdown gossip state to prevent timeouts during rolling restarts (CASSANDRA-8336)
 * Fix running with java.net.preferIPv6Addresses=true (CASSANDRA-9137)
 * Fix failed bootstrap/replace attempts being persisted in system.peers (CASSANDRA-9180)
 * Flush system.IndexInfo after marking index built (CASSANDRA-9128)
 * Fix updates to min/max_compaction_threshold through cassandra-cli
   (CASSANDRA-8102)
 * Don't include tmp files when doing offline relevel (CASSANDRA-9088)
 * Use the proper CAS WriteType when finishing a previous round during Paxos
   preparation (CASSANDRA-8672)
 * Avoid race in cancelling compactions (CASSANDRA-9070)
 * More aggressive check for expired sstables in DTCS (CASSANDRA-8359)
 * Fix ignored index_interval change in ALTER TABLE statements (CASSANDRA-7976)
 * Do more aggressive compaction in old time windows in DTCS (CASSANDRA-8360)
 * java.lang.AssertionError when reading saved cache (CASSANDRA-8740)
 * "disk full" when running cleanup (CASSANDRA-9036)
 * Lower logging level from ERROR to DEBUG when a scheduled schema pull
   cannot be completed due to a node being down (CASSANDRA-9032)
 * Fix MOVED_NODE client event (CASSANDRA-8516)
 * Allow overriding MAX_OUTSTANDING_REPLAY_COUNT (CASSANDRA-7533)
 * Fix malformed JMX ObjectName containing IPv6 addresses (CASSANDRA-9027)
 * (cqlsh) Allow increasing CSV field size limit through
   cqlshrc config option (CASSANDRA-8934)
 * Stop logging range tombstones when exceeding the threshold
   (CASSANDRA-8559)
 * Fix NullPointerException when nodetool getendpoints is run
   against invalid keyspaces or tables (CASSANDRA-8950)
 * Allow specifying the tmp dir (CASSANDRA-7712)
 * Improve compaction estimated tasks estimation (CASSANDRA-8904)
 * Fix duplicate up/down messages sent to native clients (CASSANDRA-7816)
 * Expose commit log archive status via JMX (CASSANDRA-8734)
 * Provide better exceptions for invalid replication strategy parameters
   (CASSANDRA-8909)
 * Fix regression in mixed single and multi-column relation support for
   SELECT statements (CASSANDRA-8613)
 * Add ability to limit number of native connections (CASSANDRA-8086)
 * Fix CQLSSTableWriter throwing exception and spawning threads
   (CASSANDRA-8808)
 * Fix MT mismatch between empty and GC-able data (CASSANDRA-8979)
 * Fix incorrect validation when snapshotting single table (CASSANDRA-8056)
 * Add offline tool to relevel sstables (CASSANDRA-8301)
 * Preserve stream ID for more protocol errors (CASSANDRA-8848)
 * Fix combining token() function with multi-column relations on
   clustering columns (CASSANDRA-8797)
 * Make CFS.markReferenced() resistant to bad refcounting (CASSANDRA-8829)
 * Fix StreamTransferTask abort/complete bad refcounting (CASSANDRA-8815)
 * Fix AssertionError when querying a DESC clustering ordered
   table with ASC ordering and paging (CASSANDRA-8767)
 * AssertionError: "Memory was freed" when running cleanup (CASSANDRA-8716)
 * Make it possible to set max_sstable_age to fractional days (CASSANDRA-8406)
 * Fix some multi-column relations with indexes on some clustering
   columns (CASSANDRA-8275)
 * Fix memory leak in SSTableSimple*Writer and SSTableReader.validate()
   (CASSANDRA-8748)
 * Throw OOM if allocating memory fails to return a valid pointer (CASSANDRA-8726)
 * Fix SSTableSimpleUnsortedWriter ConcurrentModificationException (CASSANDRA-8619)
 * 'nodetool info' prints exception against older node (CASSANDRA-8796)
 * Ensure SSTableSimpleUnsortedWriter.close() terminates if
   disk writer has crashed (CASSANDRA-8807)


2.1.4
 * Bind JMX to localhost unless explicitly configured otherwise (CASSANDRA-9085)


2.1.3
 * Fix HSHA/offheap_objects corruption (CASSANDRA-8719)
 * Upgrade libthrift to 0.9.2 (CASSANDRA-8685)
 * Don't use the shared ref in sstableloader (CASSANDRA-8704)
 * Purge internal prepared statements if related tables or
   keyspaces are dropped (CASSANDRA-8693)
 * (cqlsh) Handle unicode BOM at start of files (CASSANDRA-8638)
 * Stop compactions before exiting offline tools (CASSANDRA-8623)
 * Update tools/stress/README.txt to match current behaviour (CASSANDRA-7933)
 * Fix schema from Thrift conversion with empty metadata (CASSANDRA-8695)
 * Safer Resource Management (CASSANDRA-7705)
 * Make sure we compact highly overlapping cold sstables with
   STCS (CASSANDRA-8635)
 * rpc_interface and listen_interface generate NPE on startup when specified
   interface doesn't exist (CASSANDRA-8677)
 * Fix ArrayIndexOutOfBoundsException in nodetool cfhistograms (CASSANDRA-8514)
 * Switch from yammer metrics for nodetool cf/proxy histograms (CASSANDRA-8662)
 * Make sure we don't add tmplink files to the compaction
   strategy (CASSANDRA-8580)
 * (cqlsh) Handle maps with blob keys (CASSANDRA-8372)
 * (cqlsh) Handle DynamicCompositeType schemas correctly (CASSANDRA-8563)
 * Duplicate rows returned when in clause has repeated values (CASSANDRA-6706)
 * Add tooling to detect hot partitions (CASSANDRA-7974)
 * Fix cassandra-stress user-mode truncation of partition generation (CASSANDRA-8608)
 * Only stream from unrepaired sstables during inc repair (CASSANDRA-8267)
 * Don't allow starting multiple inc repairs on the same sstables (CASSANDRA-8316)
 * Invalidate prepared BATCH statements when related tables
   or keyspaces are dropped (CASSANDRA-8652)
 * Fix missing results in secondary index queries on collections
